--
-- SpellChat
-- Version: SCR 2.1.100205
-- Author: Walkerbo
-- Email: walkerbo.saurfang@gmail.com
-- Date: Wednesday 17 January 2024
--

-- I have tried to name variables, functions, frames, and buttons to be descriptive

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Metrics, Lists & Variables          ===========================
-- ===================================================================================================
-- ===================================================================================================

local addonName = "SpellChat"
local versionNumber = "SCR 2.1.100205"
local currentClass = UnitClassBase("player")

-- ===========================         table of variables          ===========================
local VariableList = {
    currentAddClassNavigationButton = "",
    currentAddClassSpellList = {},
    currentAddPhraseTextBox = false,
    currentClassSpellEnabled = false,
    currentClassSpellID = 0,
    currentClassSpellLink = "",
    currentClassSpellList = {},
    currentClassSpellPercentage = 0,
    currentClassSpellPhrase = "",
    currentHandWaveChatList = {},
    currentHandWaveChatPhrase = "",
    currentObjectEnabled = false,
    currentObjectID = 0,
    currentObjectLink = "",
    currentObjectPercentage = 0,
    currentObjectPhrase = ""
}

local SortedHandButtonTable = {} -- debug --

-- ===========================         banner and buttons          ===========================
local ImageList = {
    deathKnightButton = ("Interface\\AddOns\\SpellChat\\Files\\DeathKnightButton"),
    deathKnightButtonH = ("Interface\\AddOns\\SpellChat\\Files\\DeathKnightButtonH"),
    demonHunterButton = ("Interface\\AddOns\\SpellChat\\Files\\DemonHunterButton"),
    demonHunterButtonH = ("Interface\\AddOns\\SpellChat\\Files\\DemonHunterButtonH"),
    druidButton = ("Interface\\AddOns\\SpellChat\\Files\\DruidButton"),
    druidButtonH = ("Interface\\AddOns\\SpellChat\\Files\\DruidButtonH"),
    evokerButton = ("Interface\\AddOns\\SpellChat\\Files\\EvokerButton"),
    evokerButtonH = ("Interface\\AddOns\\SpellChat\\Files\\EvokerButtonH"),
    generalChat1Button = ("Interface\\AddOns\\SpellChat\\Files\\GeneralChat175"),
    generalChat1ButtonH = ("Interface\\AddOns\\SpellChat\\Files\\GeneralChat1"),
    generalChat2Button = ("Interface\\AddOns\\SpellChat\\Files\\GeneralChat275"),
    generalChat2ButtonH = ("Interface\\AddOns\\SpellChat\\Files\\GeneralChat2"),
    groupGoodbyeButton = ("Interface\\AddOns\\SpellChat\\Files\\GroupGoodbye75"),
    groupGoodbyeButtonH = ("Interface\\AddOns\\SpellChat\\Files\\GroupGoodbye"),
    groupHelloButton = ("Interface\\AddOns\\SpellChat\\Files\\GroupHello75"),
    groupHelloButtonH = ("Interface\\AddOns\\SpellChat\\Files\\GroupHello"),
    guildGoodbyeButton = ("Interface\\AddOns\\SpellChat\\Files\\GuildGoodbye75"),
    guildGoodbyeButtonH = ("Interface\\AddOns\\SpellChat\\Files\\GuildGoodbye"),
    guildHelloButton = ("Interface\\AddOns\\SpellChat\\Files\\GuildHello75"),
    guildHelloButtonH = ("Interface\\AddOns\\SpellChat\\Files\\GuildHello"),
    handButton = ("Interface\\AddOns\\SpellChat\\Files\\HandButton"),
    handButtonH = ("Interface\\AddOns\\SpellChat\\Files\\HandButtonH"),
    hunterButton = ("Interface\\AddOns\\SpellChat\\Files\\HunterButton"),
    hunterButtonH = ("Interface\\AddOns\\SpellChat\\Files\\HunterButtonH"),
    itemButton = ("Interface\\AddOns\\SpellChat\\Files\\ItemsButton"),
    itemButtonH = ("Interface\\AddOns\\SpellChat\\Files\\ItemsButtonH"),
    lfgChatButton = ("Interface\\AddOns\\SpellChat\\Files\\LFGChat75"),
    lfgChatButtonH = ("Interface\\AddOns\\SpellChat\\Files\\LFGChat"),
    mageButton = ("Interface\\AddOns\\SpellChat\\Files\\MageButton"),
    mageButtonH = ("Interface\\AddOns\\SpellChat\\Files\\MageButtonH"),
    monkButton = ("Interface\\AddOns\\SpellChat\\Files\\MonkButton"),
    monkButtonH = ("Interface\\AddOns\\SpellChat\\Files\\MonkButtonH"),
    paladinButton = ("Interface\\AddOns\\SpellChat\\Files\\PaladinButton"),
    paladinButtonH = ("Interface\\AddOns\\SpellChat\\Files\\PaladinButtonH"),
    pawButton = ("Interface\\AddOns\\SpellChat\\Files\\PawButton"),
    pawButtonH = ("Interface\\AddOns\\SpellChat\\Files\\PawButtonH"),
    priestButton = ("Interface\\AddOns\\SpellChat\\Files\\PriestButton"),
    priestButtonH = ("Interface\\AddOns\\SpellChat\\Files\\PriestButtonH"),
    removeSpellItemButton = ("Interface\\AddOns\\SpellChat\\Files\\RedCross"),
    rogueButton = ("Interface\\AddOns\\SpellChat\\Files\\RogueButton"),
    rogueButtonH = ("Interface\\AddOns\\SpellChat\\Files\\RogueButtonH"),
    sayChatButton = ("Interface\\AddOns\\SpellChat\\Files\\SayChat75"),
    sayChatButtonH = ("Interface\\AddOns\\SpellChat\\Files\\SayChat"),
    shamanButton = ("Interface\\AddOns\\SpellChat\\Files\\ShamanButton"),
    shamanButtonH = ("Interface\\AddOns\\SpellChat\\Files\\ShamanButtonH"),
    spellChatBanner = ("Interface\\AddOns\\SpellChat\\Files\\SpellChatBanner"),
    spellChatButton = ("Interface\\AddOns\\SpellChat\\Files\\SpellChatButton"),
    spellChatButtonH = ("Interface\\AddOns\\SpellChat\\Files\\SpellChatButtonH"),
    spellChatMagicButton = ("Interface\\AddOns\\SpellChat\\Files\\SpellChatMagicButton75"),
    spellChatMagicButtonH = ("Interface\\AddOns\\SpellChat\\Files\\SpellChatMagicButton"),
    tradeChatButton = ("Interface\\AddOns\\SpellChat\\Files\\TradeChat75"),
    tradeChatButtonH = ("Interface\\AddOns\\SpellChat\\Files\\TradeChat"),
    warlockButton = ("Interface\\AddOns\\SpellChat\\Files\\WarlockButton"),
    warlockButtonH = ("Interface\\AddOns\\SpellChat\\Files\\WarlockButtonH"),
    warriorButton = ("Interface\\AddOns\\SpellChat\\Files\\WarriorButton"),
    warriorButtonH = ("Interface\\AddOns\\SpellChat\\Files\\WarriorButtonH"),
    yellChatButton = ("Interface\\AddOns\\SpellChat\\Files\\YellChat75"),
    yellChatButtonH = ("Interface\\AddOns\\SpellChat\\Files\\YellChat"),
    horseShoeButton = ("Interface\\AddOns\\SpellChat\\Files\\HorseShoe"),
    horseShoeButtonH = ("Interface\\AddOns\\SpellChat\\Files\\HorseShoeH")
}

-- ===========================         edge and text colours          ===========================
local ColourList = {
    deathKnightEdge = {0.77, 0.12, 0.23}, -- rgb(196, 30, 58)
    demonHunterEdge = {0.64, 0.19, 0.79}, -- rgb(163,48,201)
    druidEdge = {1, 0.49, 0.04}, -- rgb(255,124,10)
    evokerEdge = {0.2, 0.58, 0.5}, -- rgb(51, 147, 127)
    generalEdge = {0, 1, 1}, -- rgb(0,255,255)
    groupEdge = {1, 0.47, 0}, -- rgb(255,120,0)
    guildEdge = {0, 1, 0}, -- rgb(0,255,0)
    hunterEdge = {0.67, 0.83, 0.45}, -- rgb(170,211,114)
    itemEdge = {1, 1, 0}, -- rgb(255,255,0)
    lfgEdge = {0.5, 0, 1}, -- rgb(127,0,255)
    mageEdge = {0.25, 0.78, 0.92}, -- rgb(63,199,235)
    monkEdge = {0, 1, 0.6}, -- rgb(0,255,152)
    mountEdge = {0, 1, 0}, -- rgb(0,255,0)
    paladinEdge = {0.96, 0.55, 0.73}, -- rgb(244,140,186)
    petEdge = {0, 1, 1}, -- rgb(0,255,255)
    priestEdge = {1, 1, 1}, -- rgb(255,255,255)
    rogueEdge = {1, 0.96, 0.41}, -- rgb(255,244,104)
    sayEdge = {0.58, 0.58, 0.58}, -- rgb(148,148,148)
    shamanEdge = {0, 0.44, 0.87}, -- rgb(0,112,221)
    spellChatEdge = {1, 0.2, 0.8}, -- rgb(255, 51, 204)
    spellChatPetMountLink = "|cffff8000", -- rgb(255, 128, 0)
    spellChatText = "|cffff33cc", -- rgb(255, 51, 204)
    tradeEdge = {1, 0.88, 0}, -- rgb(255,225,0) -- 255,0,0
    warlockEdge = {0.53, 0.53, 0.93}, -- rgb(135,136,238)
    warriorEdge = {0.78, 0.61, 0.43}, -- rgb(198,155,109)
    yellEdge = {1, 0, 0} -- rgb(255,0,0)
}

-- ===========================         all the element sizes          ===========================
local NumberList = {
    addChatHeaderHeight = 31,
    addPhraseTextBoxHeight = 25,
    bannerBoxSize = 50,
    bannerGap = 30,
    bannerScale = 0.25,
    chatHeaderHeight = 61,
    chatScrollParentHeight = 224,
    checkBoxBigGap = 15,
    checkBoxGap = 10,
    checkBoxSmallGap = 6,
    checkEnableBottomGap = -2,
    classFrameHeight = 384,
    classFrameWidth = 610,
    clearTargetListHeight = 35,
    handWaveSelectChatButtonHeight = 32.6,
    handWaveSelectChatButtonGap = -3,
    edgeSize = 20,
    enableCheckBoxSize = 30,
    enableCheckBoxSmallSize = 25,
    handWaveScrollButtonHeight = 20,
    handWaveScrollButtonNumber = 7,
    handWaveScrollFrameHeight = 224,
    insetSize = 5,
    magicButtonScale = 1,
    navButtonGapW = 55,
    navButtonSize = 40,
    navButtonFrameW = 385,
    navFirstButtonGapX = -28,
    navButtonFrameTopGap = -137,
    navSpellChatButtonGapX = 60,
    navSpellChatButtonGapY = 43,
    navSpellChatButtonSize = 55,
    percentageTextBoxHeight = 25,
    percentageTextBoxWidth = 40,
    phraseTextButtonHeight = 30,
    scaleTextBoxGap = 13,
    scrollFrameHeight = 260,
    scrollFrameWidth = 210,
    scrollSpellFrameHight = 331,
    scrollSpellFrameWidth = 379,
    slashCommandHeight = 150,
    slashCommandWidth = 300,
    spellChatFrameBottomGap = 20,
    spellChatFrameScale = 1,
    spellChatMainFrameHeight = 630,
    spellChatMainFrameWidth = 650,
    spellItemChatScrollButtonHeight = 20,
    spellItemChatScrollButtonNumber = 7,
    spellItemScrollButtonHeight = 20,
    spellItemScrollButtonNumber = 8
}

-- ===========================         all the strings          ===========================
local TextList = {
    addonLoaded = ColourList.spellChatText .. " *** " .. addonName .. " - " .. versionNumber .. " Loaded *** \n",
    addItemButtonText = "Add Item",
    addSpellButtonText = "Add Spell",
    addMountButtonText = "Add Mount",
    addPetButtonText = "Add Pet",
    allFeedbackMessagesText = " Feedback Messages",
    buttonFontObject = Game18Font,
    chatFrequencyText = "% Chat Frequency",
    checkBoxFontObject = Game18Font,
    checkBoxSmallFontObject = NumberFontNormalLargeYellow,
    clearAllListsText = ColourList.spellChatText .. "[SpellChat]:|r All Lists Cleared",
    clearChatListButtonText = "Clear Chat List",
    clearCurrentListText = "Clear Current List",
    clearItemListButtonText = "Clear Item List",
    clearMountListButtonText = "Clear Mount List",
    clearPetListButtonText = "Clear Pet List",
    clearSpellListButtonText = "Clear Spell List",
    enableChatsText = " Enable Chats",
    errorSpellAlreadyListed = ColourList.spellChatText .. "[SpellChat]:|r That Spell Is Already Listed",
    errorMountAlreadyListed = ColourList.spellChatText .. "[SpellChat]:|r That Mount Is Already Listed",
    errorPetAlreadyListed = ColourList.spellChatText .. "[SpellChat]:|r That Pet Is Already Listed",
    errorItemAlreadyListed = ColourList.spellChatText .. "[SpellChat]:|r That Item Is Already Listed",
    errorNoOnuseAction = ColourList.spellChatText .. "[SpellChat]:|r That Item Has No OnUse Action",
    errorNotAnItem = ColourList.spellChatText .. "[SpellChat]:|r That Was Not An Item, Pet or Mount",
    errorNotASpell = ColourList.spellChatText .. "[SpellChat]:|r That Was Not A Spell",
    errorNoPhrases = ColourList.spellChatText .. "[SpellChat]:|r You Have No Phrases For This Chat",
    errorNotInAGroup = ColourList.spellChatText .. "[SpellChat]:|r You Are Not In A Group",
    errorNotInAGuild = ColourList.spellChatText .. "[SpellChat]:|r You Are Not In A Guild",
    errorTradeChatNotAvailable = ColourList.spellChatText .. "[SpellChat]:|r Trade Chat Not Available In This Zone",
    errorLFGChatNotAvailable = ColourList.spellChatText .. "[SpellChat]:|r LFG Chat Not Available In This Zone",
    generalChat1ChannelButtonText = "General Chat 1",
    generalChat2ChannelButtonText = "General Chat 2",
    groupGoodbyeButtonText = "Group Goodbye",
    groupHelloButtonText = "Group Hello",
    guildGoodbyeButtonText = "Guild Goodbye",
    guildHelloButtonText = "Guild Hello",
    handTitleFontObject = Game24Font,
    keybindButtonText = "Keybinding UI",
    yellChatChannelButtonText = "Yell Chat",
    sayChatChannelButtonText = "Say Chat",
    sixButtonEnableText = " Enable SpellChat Button Box",
    slashCommandFontObject = NumberFontNormalLargeYellow,
    spellChatButtonGridOpacityText = "% SpellChat Button Box Opacity",
    spellChatButtonGridScaleText = "% SpellChat Button Box Scale",
    spellChatButtonOpacityText = "% SpellChat Buttton Opacity",
    spellChatButtonScaleText = "% SpellChat Buttton Scale",
    spellChatButtonText = " Enable SpellChat Button",
    spellChatEnableText = " Enable SpellChat",
    spellChatUIScaleText = "% SpellChatUI Scale",
    lfgChatChannelButtonText = "LFG Chat",
    tradeChatChannelButtonText = "Trade Chat",
    generalButtonsToggleText = " General Chat Buttons",
    groupButtonsToggleText = " Group Chat Buttons",
    guildButtonsToggleText = " Guild Chat Buttons",
    sayYellButtonsToggleText = " Say & Yell Chat Buttons",
    tradeLFGButtonsToggleText = " Trade & LFG Chat Buttons",
    slashCommandText1 = ("Slash Commands:\n\n" ..
        ColourList.spellChatText ..
            "/spc |r  -  Toggle SpellChat Frame\n" ..
                ColourList.spellChatText ..
                    "/spcpos |r  -  Reset SpellChat Layout\n" ..
                        ColourList.spellChatText ..
                            "/spcc |r  -  Clear All Lists\n" ..
                                ColourList.spellChatText ..
                                    "/spcgdh |r  -  Guild Hello Message\n" ..
                                        ColourList.spellChatText ..
                                            "/spcgdg |r  -  Guild Goodbye Message\n" ..
                                                ColourList.spellChatText ..
                                                    "/spcgph |r  -  Group Hello Message\n" ..
                                                        ColourList.spellChatText ..
                                                            "/spcgpg |r  -  Group Goodbye Message\n"),
    slashCommandText2 = (ColourList.spellChatText ..
        "/spcg1 |r  -  General Chat Message 1\n" ..
            ColourList.spellChatText ..
                "/spcg2 |r  -  General Chat Message 2\n" ..
                    ColourList.spellChatText ..
                        "/spct |r  -  Trade Chat Message\n" ..
                            ColourList.spellChatText ..
                                "/spcl |r  -  LFG Chat Message\n" ..
                                    ColourList.spellChatText ..
                                        "/spcs |r  -  Say Chat Message\n" ..
                                            ColourList.spellChatText ..
                                                "/spcy |r  -  Yell Chat Message\n" ..
                                                    ColourList.spellChatText ..
                                                        "/spcds |r  -  Reset Settings To Defaults"),
    buttonClickText = ("Button Clicks:\n\n" ..
        ColourList.spellChatText ..
            "Clear List Buttons |r  -  Right Click\n" ..
                ColourList.spellChatText ..
                    "Toggle SpellChat Frame |r  -  Right Click SpellChat Buttons\n" ..
                        ColourList.spellChatText ..
                            "Drag SpellChat Buttons |r  -  Middle Click SpellChat Buttons\n" ..
                                ColourList.spellChatText ..
                                    "Add Items and Spells to lists |r  -  Drag and Drop onto the add buttons\n" ..
                                        ColourList.spellChatText ..
                                            "Insert Items, Pets, Mounts and Spells into chats |r  -  Drag and Drop into the chat box\n" ..
                                                ColourList.spellChatText ..
                                                    "Insert Achievements into chats |r  -  Focus on Chat box Alt-Click\n" ..
                                                        ColourList.spellChatText ..
                                                            "Insert Adventure Journal Bosses and Boss Spells into chats |r  -  Focus on Chat box Alt-Click\n" ..
                                                                ColourList.spellChatText ..
                                                                    "Insert Adventure Journal Items into chats |r  -  Focus on Chat box Alt-Click\n")
}

-- ===========================         global keybinding Names          ===========================
BINDING_HEADER_SPCTKEYBINDINGTITLE = "- SpellChat -"
BINDING_NAME_SPCTRESETSPELLCHATUILAYOUT = "Reset SpellChat UI Layout"
BINDING_NAME_SPCTRUNGENERALCHANNELCHAT1FUNCTION = "General Chat Message 1"
BINDING_NAME_SPCTRUNGENERALCHANNELCHAT2FUNCTION = "General Chat Message 2"
BINDING_NAME_SPCTRUNGROUPGOODBYECHATFUNCTION = "Group Goodbye Chat Message"
BINDING_NAME_SPCTRUNGROUPHELLOCHATFUNCTION = "Group Hello Chat Message"
BINDING_NAME_SPCTRUNGUILDGOODBYECHATFUNCTION = "Guild Goodbye Chat Message"
BINDING_NAME_SPCTRUNGUILDHELLOCHATFUNCTION = "Guild Hello Chat Message"
BINDING_NAME_SPCTRUNLFGCHANNELCHATFUNCTION = "LFG Chat Message"
BINDING_NAME_SPCTRUNTRADECHANNELCHATFUNCTION = "Trade Chat Message"
BINDING_NAME_SPCTRUNSAYCHANNELCHATFUNCTION = "Say Chat Message"
BINDING_NAME_SPCTRUNYELLCHANNELCHATFUNCTION = "Yell Chat Message"
BINDING_NAME_SPCTTOGGLESPELLCHATINTERFACEFRAME = "Toggle SpellChat Interface Frame"

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Functions          ===========================
-- ===================================================================================================
-- ===================================================================================================

local function initialiseLists() -- build lists if they do not already exist
    if not SpellChatOptionsList then
        DeathKnightSpellList = {}
        DemonHunterSpellList = {}
        DruidSpellList = {}
        EvokerSpellList = {}
        HunterSpellList = {}
        MageSpellList = {}
        MonkSpellList = {}
        PaladinSpellList = {}
        PriestSpellList = {}
        RogueSpellList = {}
        ShamanSpellList = {}
        WarlockSpellList = {}
        WarriorSpellList = {}
        SpellChatGuildHelloList = {}
        SpellChatGuildGoodbyeList = {}
        SpellChatGroupHelloList = {}
        SpellChatGroupGoodbyeList = {}
        SpellChatGeneral1List = {}
        SpellChatGeneral2List = {}
        SpellChatTradeList = {}
        SpellChatLFGList = {}
        SpellChatSayList = {}
        SpellChatYellList = {}
        SpellChatItemList = {}
        SpellChatMountList = {} -- debug --
        SpellChatPetList = {} -- debug --
        SpellChatHandButtonList = {
            [1] = {guildButtons = true}, -- each button needs to be in order
            [2] = {groupButtons = true},
            [3] = {generalButtons = true},
            [4] = {tradeLFGButtons = true},
            [5] = {sayYellButtons = true}
        }
        SpellChatOptionsList = {
            buttonBoxEnabled = true,
            buttonBoxIsHidden = false,
            buttonBoxOpacity = 1,
            buttonBoxScale = 1,
            errorMessagesEnabled = true,
            magicButtonEnabled = true,
            magicButtonOpacity = 1,
            magicButtonScale = 1,
            spellChatEnabled = true,
            spellChatFrameScale = 1
        }
        SpellChatInterfaceFrame:Show() -- show spellchat UI on first login
    end
    if not EvokerSpellList then
        EvokerSpellList = {}
    end
end

local function setCheckBoxesAndScales() -- set up the checkboxes and the frame and buttons scale
    if SpellChatOptionsList.spellChatEnabled then
        SpellChatFrame1.EnableSpellChatCheckBox:SetChecked(true)
    else
        SpellChatFrame1.EnableSpellChatCheckBox:SetChecked(false)
        SpellChatFrame1.EnableSpellChatButtonCheckBox:SetEnabled(false)
        SpellChatFrame1.EnableSpellChatSixButtonCheckBox:SetEnabled(false)
        SpellChatFrame1.FeedbackMessagesCheckBox:SetEnabled(false)
    end
    if SpellChatOptionsList.magicButtonEnabled then
        SpellChatFrame1.EnableSpellChatButtonCheckBox:SetChecked(true)
        spellChatMagicButton:Show()
    else
        SpellChatFrame1.EnableSpellChatButtonCheckBox:SetChecked(false)
        spellChatMagicButton:Hide()
    end
    if SpellChatOptionsList.buttonBoxEnabled then
        SpellChatFrame1.EnableSpellChatSixButtonCheckBox:SetChecked(true)
        HandWaveButtonGridFrame:Show()
    else
        SpellChatFrame1.EnableSpellChatSixButtonCheckBox:SetChecked(false)
        HandWaveButtonGridFrame:Hide()
    end
    if SpellChatHandButtonList[1].guildButtons then
        SpellChatFrame1.GuildChatButtonsCheckBox:SetChecked(true)
    else
        SpellChatFrame1.GuildChatButtonsCheckBox:SetChecked(false)
    end
    if SpellChatHandButtonList[2].groupButtons then
        SpellChatFrame1.GroupChatButtonsCheckBox:SetChecked(true)
    else
        SpellChatFrame1.GroupChatButtonsCheckBox:SetChecked(false)
    end
    if SpellChatHandButtonList[3].generalButtons then
        SpellChatFrame1.GeneralChatButtonsCheckBox:SetChecked(true)
    else
        SpellChatFrame1.GeneralChatButtonsCheckBox:SetChecked(false)
    end
    if SpellChatHandButtonList[4].tradeLFGButtons then -- debug -- change
        SpellChatFrame1.TradeChatButtonsCheckBox:SetChecked(true)
    else
        SpellChatFrame1.TradeChatButtonsCheckBox:SetChecked(false)
    end
    if SpellChatHandButtonList[5].sayYellButtons then -- debug -- change
        SpellChatFrame1.LFGChatButtonsCheckBox:SetChecked(true)
    else
        SpellChatFrame1.LFGChatButtonsCheckBox:SetChecked(false)
    end
    if SpellChatOptionsList.errorMessagesEnabled then
        SpellChatFrame1.FeedbackMessagesCheckBox:SetChecked(true)
    else
        SpellChatFrame1.FeedbackMessagesCheckBox:SetChecked(false)
    end
    SpellChatInterfaceFrame:SetScale(SpellChatOptionsList.spellChatFrameScale)
    SpellChatFrame1.SpellChatFrameScaleTextBox:SetNumber(SpellChatOptionsList.spellChatFrameScale * 100)
    spellChatMagicButton:SetScale(SpellChatOptionsList.magicButtonScale)
    SpellChatFrame1.MagicButtonScaleTextBox:SetNumber(SpellChatOptionsList.magicButtonScale * 100)
    spellChatMagicButton:SetAlpha(SpellChatOptionsList.magicButtonOpacity)
    SpellChatFrame1.MagicButtonOpacityTextBox:SetNumber(SpellChatOptionsList.magicButtonOpacity * 100)
    HandWaveButtonGridFrame:SetScale(SpellChatOptionsList.buttonBoxScale)
    SpellChatFrame1.ButtonGridScaleTextBox:SetText(SpellChatOptionsList.buttonBoxScale * 100)
    SpellChatFrame1.ButtonGridOpacityTextBox:SetText(SpellChatOptionsList.buttonBoxOpacity * 100)
end

local function handWaveGridFrameButtonLayout()
    buttonCount, lastAnchor, buttonFrameWidthMultiplier = 1, HandWaveButtonGridFrame, 1 -- button build variables
    HandWaveButtonGridFrameguildButtons:Hide() -- hide all buttons to ensure no ghosting
    HandWaveButtonGridFrameguildButtons2:Hide()
    HandWaveButtonGridFramegroupButtons:Hide()
    HandWaveButtonGridFramegroupButtons2:Hide()
    HandWaveButtonGridFramegeneralButtons:Hide()
    HandWaveButtonGridFramegeneralButtons2:Hide()
    HandWaveButtonGridFrametradeLFGButtons:Hide()
    HandWaveButtonGridFrametradeLFGButtons2:Hide()
    HandWaveButtonGridFramesayYellButtons:Hide()
    HandWaveButtonGridFramesayYellButtons2:Hide()
    HandWaveButtonGridFrame:SetSize(NumberList.navButtonSize * buttonFrameWidthMultiplier, NumberList.navButtonSize * 2) -- set the button frame to its default size
    for a, b in pairs(SpellChatHandButtonList) do
        for k, v in pairs(b) do -- loop through the table at index
            if v then -- if the current button name is true
                thisButton = _G["HandWaveButtonGridFrame" .. k] -- set this button to the global button 2
                thisButton:ClearAllPoints()
                thisButton:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
                thisButton:Show()
                thisButton2 = _G["HandWaveButtonGridFrame" .. k .. "2"] -- set this button to the global button namebutton name
                thisButton2:ClearAllPoints()
                thisButton2:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
                thisButton2:Show()
                if buttonCount == 1 then
                    thisButton:SetPoint("TOPLEFT", HandWaveButtonGridFrame, "TOPLEFT") -- the very first button gets anchored to the button frame
                    thisButton2:SetPoint("TOP", thisButton, "BOTTOM") -- button 2 gets anchored to the button 1
                else
                    thisButton:SetPoint("LEFT", lastAnchor, "RIGHT") -- each subsequent button 1 gets anchored to the previous button 1
                    thisButton2:SetPoint("TOP", thisButton, "BOTTOM") -- button 2 gets anchored to the button 1
                end
                HandWaveButtonGridFrame:SetSize(
                    NumberList.navButtonSize * buttonFrameWidthMultiplier,
                    NumberList.navButtonSize * 2
                ) -- expand the frame by the number of buttons
                buttonCount = buttonCount + 1 -- increase button count
                lastAnchor = thisButton -- set the current button 1
                buttonFrameWidthMultiplier = buttonFrameWidthMultiplier + 1 -- increase the frame width multiplier
            end
        end
    end
    HandWaveButtonGridFrame:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
end

local function setCurrentAddClassSpellButtonList() -- set the default list based on the current class
    if currentClass == "DEATHKNIGHT" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelDeathKnightBtn
        VariableList.currentAddClassSpellList = DeathKnightSpellList
    elseif currentClass == "DEMONHUNTER" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelDemonHunterBtn
        VariableList.currentAddClassSpellList = DemonHunterSpellList
    elseif currentClass == "DRUID" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelDruidBtn
        VariableList.currentAddClassSpellList = DruidSpellList
    elseif currentClass == "EVOKER" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelEvokerBtn
        VariableList.currentAddClassSpellList = EvokerSpellList
    elseif currentClass == "HUNTER" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelHunterBtn
        VariableList.currentAddClassSpellList = HunterSpellList
    elseif currentClass == "MAGE" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelMageBtn
        VariableList.currentAddClassSpellList = MageSpellList
    elseif currentClass == "MONK" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelMonkBtn
        VariableList.currentAddClassSpellList = MonkSpellList
    elseif currentClass == "PALADIN" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelPaladinBtn
        VariableList.currentAddClassSpellList = PaladinSpellList
    elseif currentClass == "PRIEST" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelPriestBtn
        VariableList.currentAddClassSpellList = PriestSpellList
    elseif currentClass == "ROGUE" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelRogueBtn
        VariableList.currentAddClassSpellList = RogueSpellList
    elseif currentClass == "SHAMAN" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelShamanBtn
        VariableList.currentAddClassSpellList = ShamanSpellList
    elseif currentClass == "WARLOCK" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelWarlockBtn
        VariableList.currentAddClassSpellList = WarlockSpellList
    elseif currentClass == "WARRIOR" then
        VariableList.currentAddClassNavigationButton = SpellChatNavigationPanelWarriorBtn
        VariableList.currentAddClassSpellList = WarriorSpellList
    end
end

local function closeAllFrames()
    DeathKnightSpellChatFrame:Hide()
    DemonHunterSpellChatFrame:Hide()
    DruidSpellChatFrame:Hide()
    EvokerSpellChatFrame:Hide()
    HandWaveFrame:Hide()
    HunterSpellChatFrame:Hide()
    ItemsSpellChatFrame:Hide()
    MageSpellChatFrame:Hide()
    MonkSpellChatFrame:Hide()
    PaladinSpellChatFrame:Hide()
    PriestSpellChatFrame:Hide()
    RogueSpellChatFrame:Hide()
    ShamanSpellChatFrame:Hide()
    SpellChatFrame1:Hide()
    SpellChatFrame2:Hide()
    WarlockSpellChatFrame:Hide()
    WarriorSpellChatFrame:Hide()
    MountSpellChatFrame:Hide()
    PetSpellChatFrame:Hide()
    SpellChatInterfaceFrame.SpellChatBtn1:SetNormalTexture(ImageList.spellChatButton)
    SpellChatInterfaceFrame.SpellChatBtn2:SetNormalTexture(ImageList.spellChatButton)
    SpellChatNavigationPanel.DeathKnightBtn:SetNormalTexture(ImageList.deathKnightButton)
    SpellChatNavigationPanel.DemonHunterBtn:SetNormalTexture(ImageList.demonHunterButton)
    SpellChatNavigationPanel.DruidBtn:SetNormalTexture(ImageList.druidButton)
    SpellChatNavigationPanel.EvokerBtn:SetNormalTexture(ImageList.evokerButton)
    SpellChatNavigationPanel.HandWaveBtn:SetNormalTexture(ImageList.handButton)
    SpellChatNavigationPanel.HunterBtn:SetNormalTexture(ImageList.hunterButton)
    SpellChatNavigationPanel.ItemBtn:SetNormalTexture(ImageList.itemButton)
    SpellChatNavigationPanel.MageBtn:SetNormalTexture(ImageList.mageButton)
    SpellChatNavigationPanel.MonkBtn:SetNormalTexture(ImageList.monkButton)
    SpellChatNavigationPanel.PaladinBtn:SetNormalTexture(ImageList.paladinButton)
    SpellChatNavigationPanel.PriestBtn:SetNormalTexture(ImageList.priestButton)
    SpellChatNavigationPanel.RogueBtn:SetNormalTexture(ImageList.rogueButton)
    SpellChatNavigationPanel.ShamanBtn:SetNormalTexture(ImageList.shamanButton)
    SpellChatNavigationPanel.WarlockBtn:SetNormalTexture(ImageList.warlockButton)
    SpellChatNavigationPanel.WarriorBtn:SetNormalTexture(ImageList.warriorButton)
    SpellChatNavigationPanel.MountBtn:SetNormalTexture(ImageList.horseShoeButton)
    SpellChatNavigationPanel.PetBtn:SetNormalTexture(ImageList.pawButton)
end

local function printErrorMessages(errorMessageType)
    if SpellChatOptionsList.errorMessagesEnabled then
        if errorMessageType == "errorNotAnItem" then
            print(TextList.errorNotAnItem)
        elseif errorMessageType == "errorNotASpell" then
            print(TextList.errorNotASpell)
        elseif errorMessageType == "errorNoOnuseAction" then
            print(TextList.errorNoOnuseAction)
        elseif errorMessageType == "errorAlreadyListed" then
            print(TextList.errorAlreadyListed)
        elseif errorMessageType == "errorNotInAGuild" then
            print(TextList.errorNotInAGuild)
        elseif errorMessageType == "errorNotInAGroup" then
            print(TextList.errorNotInAGroup)
        elseif errorMessageType == "errorNoPhrases" then
            print(TextList.errorNoPhrases)
        elseif errorMessageType == "errorTradeChatNotAvailable" then
            print(TextList.errorTradeChatNotAvailable)
        elseif errorMessageType == "errorLFGChatNotAvailable" then
            print(TextList.errorLFGChatNotAvailable)
        end
    end
end

-- ===========================         update class spell list functions          ===========================
local function updateDeathKnightSpellList()
    FauxScrollFrame_Update(
        DeathKnightSpellScrollFrame,
        #DeathKnightSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(DeathKnightSpellScrollFrame)
        button = DeathKnightSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #DeathKnightSpellList then
            button:SetText(DeathKnightSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateDeathKnightSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(DeathKnightSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        DeathKnightChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(DeathKnightChatScrollFrame)
        button = DeathKnightChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateDemonHunterSpellList()
    FauxScrollFrame_Update(
        DemonHunterSpellScrollFrame,
        #DemonHunterSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(DemonHunterSpellScrollFrame)
        button = DemonHunterSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #DemonHunterSpellList then
            button:SetText(DemonHunterSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateDemonHunterSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(DemonHunterSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        DemonHunterChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(DemonHunterChatScrollFrame)
        button = DemonHunterChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateDruidSpellList()
    FauxScrollFrame_Update(
        DruidSpellScrollFrame,
        #DruidSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(DruidSpellScrollFrame)
        button = DruidSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #DruidSpellList then
            button:SetText(DruidSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateDruidSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(DruidSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        DruidChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(DruidChatScrollFrame)
        button = DruidChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateEvokerSpellList()
    FauxScrollFrame_Update(
        EvokerSpellScrollFrame,
        #EvokerSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(EvokerSpellScrollFrame)
        button = EvokerSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #EvokerSpellList then
            button:SetText(EvokerSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateEvokerSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(EvokerSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        EvokerChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(EvokerChatScrollFrame)
        button = EvokerChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateHunterSpellList()
    FauxScrollFrame_Update(
        HunterSpellScrollFrame,
        #HunterSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(HunterSpellScrollFrame)
        button = HunterSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #HunterSpellList then
            button:SetText(HunterSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateHunterSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(HunterSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        HunterChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(HunterChatScrollFrame)
        button = HunterChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateMageSpellList()
    FauxScrollFrame_Update(
        MageSpellScrollFrame,
        #MageSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(MageSpellScrollFrame)
        button = MageSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #MageSpellList then
            button:SetText(MageSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateMageSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(MageSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        MageChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(MageChatScrollFrame)
        button = MageChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateMonkSpellList()
    FauxScrollFrame_Update(
        MonkSpellScrollFrame,
        #MonkSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(MonkSpellScrollFrame)
        button = MonkSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #MonkSpellList then
            button:SetText(MonkSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateMonkSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(MonkSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        MonkChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(MonkChatScrollFrame)
        button = MonkChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updatePaladinSpellList()
    FauxScrollFrame_Update(
        PaladinSpellScrollFrame,
        #PaladinSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(PaladinSpellScrollFrame)
        button = PaladinSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #PaladinSpellList then
            button:SetText(PaladinSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updatePaladinSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(PaladinSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        PaladinChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(PaladinChatScrollFrame)
        button = PaladinChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updatePriestSpellList()
    FauxScrollFrame_Update(
        PriestSpellScrollFrame,
        #PriestSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(PriestSpellScrollFrame)
        button = PriestSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #PriestSpellList then
            button:SetText(PriestSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updatePriestSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(PriestSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        PriestChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(PriestChatScrollFrame)
        button = PriestChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateRogueSpellList()
    FauxScrollFrame_Update(
        RogueSpellScrollFrame,
        #RogueSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(RogueSpellScrollFrame)
        button = RogueSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #RogueSpellList then
            button:SetText(RogueSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateRogueSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(RogueSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        RogueChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(RogueChatScrollFrame)
        button = RogueChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateShamanSpellList()
    FauxScrollFrame_Update(
        ShamanSpellScrollFrame,
        #ShamanSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(ShamanSpellScrollFrame)
        button = ShamanSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #ShamanSpellList then
            button:SetText(ShamanSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateShamanSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(ShamanSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        ShamanChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(ShamanChatScrollFrame)
        button = ShamanChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateWarlockSpellList()
    FauxScrollFrame_Update(
        WarlockSpellScrollFrame,
        #WarlockSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(WarlockSpellScrollFrame)
        button = WarlockSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #WarlockSpellList then
            button:SetText(WarlockSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateWarlockSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(WarlockSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        WarlockChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(WarlockChatScrollFrame)
        button = WarlockChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateWarriorSpellList()
    FauxScrollFrame_Update(
        WarriorSpellScrollFrame,
        #WarriorSpellList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(WarriorSpellScrollFrame)
        button = WarriorSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #WarriorSpellList then
            button:SetText(WarriorSpellList[offset].spellLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateWarriorSpellChatList()
    currentClassSpellList = {}
    for k, v in pairs(WarriorSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            currentClassSpellList = v.spellChatList
        end
    end
    FauxScrollFrame_Update(
        WarriorChatScrollFrame,
        #currentClassSpellList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(WarriorChatScrollFrame)
        button = WarriorChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentClassSpellList then
            button:SetText(currentClassSpellList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateMountSpellList()
    FauxScrollFrame_Update(
        MountSpellScrollFrame,
        #SpellChatMountList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(MountSpellScrollFrame)
        button = MountSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #SpellChatMountList then
            button:SetText(SpellChatMountList[offset].mountLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateMountSpellChatList()
    currentObjectList = {}
    for k, v in pairs(SpellChatMountList) do
        if v.mountID == VariableList.currentObjectID then
            currentObjectList = v.mountChatList
        end
    end
    FauxScrollFrame_Update(
        MountChatScrollFrame,
        #currentObjectList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(MountChatScrollFrame)
        button = MountChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentObjectList then
            button:SetText(currentObjectList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updatePetSpellList()
    FauxScrollFrame_Update(
        PetSpellScrollFrame,
        #SpellChatPetList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(PetSpellScrollFrame)
        button = PetSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #SpellChatPetList then
            button:SetText(SpellChatPetList[offset].petLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updatePetSpellChatList()
    currentObjectList = {}
    for k, v in pairs(SpellChatPetList) do
        if v.petID == VariableList.currentObjectID then
            currentObjectList = v.petChatList
        end
    end
    FauxScrollFrame_Update(
        PetChatScrollFrame,
        #currentObjectList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(PetChatScrollFrame)
        button = PetChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentObjectList then
            button:SetText(currentObjectList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateItemsSpellList()
    FauxScrollFrame_Update(
        ItemsSpellScrollFrame,
        #SpellChatItemList,
        NumberList.spellItemScrollButtonNumber,
        NumberList.spellItemScrollButtonHeight
    )
    for index = 1, NumberList.spellItemScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(ItemsSpellScrollFrame)
        button = ItemsSpellScrollFrame.buttons[index]
        button.index = offset
        if offset <= #SpellChatItemList then
            button:SetText(SpellChatItemList[offset].itemLink)
            button:Show()
        else
            button:Hide()
        end
    end
end
local function updateItemsSpellChatList()
    currentObjectList = {}
    for k, v in pairs(SpellChatItemList) do
        if v.itemID == VariableList.currentObjectID then
            currentObjectList = v.itemChatList
        end
    end
    FauxScrollFrame_Update(
        ItemsChatScrollFrame,
        #currentObjectList,
        NumberList.spellItemChatScrollButtonNumber,
        NumberList.spellItemChatScrollButtonHeight
    )
    for index = 1, NumberList.spellItemChatScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(ItemsChatScrollFrame)
        button = ItemsChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #currentObjectList then
            button:SetText(currentObjectList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateCurrentHandWaveList()
    FauxScrollFrame_Update(
        HandWaveChatScrollFrame,
        #VariableList.currentHandWaveChatList,
        NumberList.handWaveScrollButtonNumber,
        NumberList.handWaveScrollButtonHeight
    )
    for index = 1, NumberList.handWaveScrollButtonNumber do
        offset = index + FauxScrollFrame_GetOffset(HandWaveChatScrollFrame)
        button = HandWaveChatScrollFrame.buttons[index]
        button.index = offset
        if offset <= #VariableList.currentHandWaveChatList then
            button:SetText(VariableList.currentHandWaveChatList[offset])
            button:Show()
        else
            button:Hide()
        end
    end
end

local function updateListBasedOnOpenFrame()
    if DeathKnightSpellChatFrame:IsVisible() then
        updateDeathKnightSpellList()
    elseif DemonHunterSpellChatFrame:IsVisible() then
        updateDemonHunterSpellList()
    elseif DruidSpellChatFrame:IsVisible() then
        updateDruidSpellList()
    elseif EvokerSpellChatFrame:IsVisible() then
        updateEvokerSpellList()
    elseif HunterSpellChatFrame:IsVisible() then
        updateHunterSpellList()
    elseif MageSpellChatFrame:IsVisible() then
        updateMageSpellList()
    elseif MonkSpellChatFrame:IsVisible() then
        updateMonkSpellList()
    elseif PaladinSpellChatFrame:IsVisible() then
        updatePaladinSpellList()
    elseif PriestSpellChatFrame:IsVisible() then
        updatePriestSpellList()
    elseif RogueSpellChatFrame:IsVisible() then
        updateRogueSpellList()
    elseif ShamanSpellChatFrame:IsVisible() then
        updateShamanSpellList()
    elseif WarlockSpellChatFrame:IsVisible() then
        updateWarlockSpellList()
    elseif WarriorSpellChatFrame:IsVisible() then
        updateWarriorSpellList()
    elseif MountSpellChatFrame:IsVisible() then
        updateMountSpellList()
    elseif PetSpellChatFrame:IsVisible() then
        updatePetSpellList()
    elseif WarriorSpellChatFrame:IsVisible() then
        updateWarriorSpellList()
    elseif ItemsSpellChatFrame:IsVisible() then
        updateItemsSpellList()
    elseif HandWaveFrameGuildHello:IsVisible() then
        updateItemsSpellChatList()
    elseif HandWaveFrameGuildGoodbye:IsVisible() then
        updateItemsSpellChatList()
    elseif HandWaveFrameGroupClear:IsVisible() then
        updateItemsSpellChatList()
    elseif HandWaveFrameGroupGoodbye:IsVisible() then
        updateItemsSpellChatList()
    end
end

-- ===========================         button navigation          ===========================
local function toggleButton(buttonName)
    closeAllFrames()
    if buttonName == SpellChatNavigationPanelDeathKnightBtn then
        updateDeathKnightSpellList()
        updateDeathKnightSpellChatList()
        SpellChatNavigationPanel.DeathKnightBtn:SetNormalTexture(ImageList.deathKnightButtonH)
        DeathKnightSpellChatFrame.AddPhraseTextBox:SetText("")
        DeathKnightSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = DeathKnightSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelDemonHunterBtn then
        updateDemonHunterSpellList()
        updateDemonHunterSpellChatList()
        SpellChatNavigationPanel.DemonHunterBtn:SetNormalTexture(ImageList.demonHunterButtonH)
        DemonHunterSpellChatFrame.AddPhraseTextBox:SetText("")
        DemonHunterSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = DemonHunterSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelDruidBtn then
        updateDruidSpellList()
        updateDruidSpellChatList()
        SpellChatNavigationPanel.DruidBtn:SetNormalTexture(ImageList.druidButtonH)
        DruidSpellChatFrame.AddPhraseTextBox:SetText("")
        DruidSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = DruidSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelEvokerBtn then
        updateEvokerSpellList()
        updateEvokerSpellChatList()
        SpellChatNavigationPanel.EvokerBtn:SetNormalTexture(ImageList.evokerButtonH)
        EvokerSpellChatFrame.AddPhraseTextBox:SetText("")
        EvokerSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = EvokerSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelHunterBtn then
        updateHunterSpellList()
        updateHunterSpellChatList()
        SpellChatNavigationPanel.HunterBtn:SetNormalTexture(ImageList.hunterButtonH)
        HunterSpellChatFrame.AddPhraseTextBox:SetText("")
        HunterSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = HunterSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelMageBtn then
        updateMageSpellList()
        updateMageSpellChatList()
        SpellChatNavigationPanel.MageBtn:SetNormalTexture(ImageList.mageButtonH)
        MageSpellChatFrame.AddPhraseTextBox:SetText("")
        MageSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = MageSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelMonkBtn then
        updateMonkSpellList()
        updateMonkSpellChatList()
        SpellChatNavigationPanel.MonkBtn:SetNormalTexture(ImageList.monkButtonH)
        MonkSpellChatFrame.AddPhraseTextBox:SetText("")
        MonkSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = MonkSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelPaladinBtn then
        updatePaladinSpellList()
        updatePaladinSpellChatList()
        SpellChatNavigationPanel.PaladinBtn:SetNormalTexture(ImageList.paladinButtonH)
        PaladinSpellChatFrame.AddPhraseTextBox:SetText("")
        PaladinSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = PaladinSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelPriestBtn then
        updatePriestSpellList()
        updatePriestSpellChatList()
        SpellChatNavigationPanel.PriestBtn:SetNormalTexture(ImageList.priestButtonH)
        PriestSpellChatFrame.AddPhraseTextBox:SetText("")
        PriestSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = PriestSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelRogueBtn then
        updateRogueSpellList()
        updateRogueSpellChatList()
        SpellChatNavigationPanel.RogueBtn:SetNormalTexture(ImageList.rogueButtonH)
        RogueSpellChatFrame.AddPhraseTextBox:SetText("")
        RogueSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = RogueSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelShamanBtn then
        updateShamanSpellList()
        updateShamanSpellChatList()
        SpellChatNavigationPanel.ShamanBtn:SetNormalTexture(ImageList.shamanButtonH)
        ShamanSpellChatFrame.AddPhraseTextBox:SetText("")
        ShamanSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = ShamanSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelWarlockBtn then
        updateWarlockSpellList()
        updateWarlockSpellChatList()
        SpellChatNavigationPanel.WarlockBtn:SetNormalTexture(ImageList.warlockButtonH)
        WarlockSpellChatFrame.AddPhraseTextBox:SetText("")
        VariableList.currentAddPhraseTextBox = WarlockSpellChatFrameAddPhraseTextBox
        WarlockSpellChatFrame:Show()
    elseif buttonName == SpellChatNavigationPanelWarriorBtn then
        updateWarriorSpellList()
        updateWarriorSpellChatList()
        SpellChatNavigationPanel.WarriorBtn:SetNormalTexture(ImageList.warriorButtonH)
        WarriorSpellChatFrame.AddPhraseTextBox:SetText("")
        WarriorSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = WarriorSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelMountBtn then
        updateMountSpellList()
        updateMountSpellChatList()
        SpellChatNavigationPanel.MountBtn:SetNormalTexture(ImageList.horseShoeButtonH)
        MountSpellChatFrame.AddPhraseTextBox:SetText("")
        MountSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = MountSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelPetBtn then
        updatePetSpellList()
        updatePetSpellChatList()
        SpellChatNavigationPanel.PetBtn:SetNormalTexture(ImageList.pawButtonH)
        PetSpellChatFrame.AddPhraseTextBox:SetText("")
        PetSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = PetSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelItemBtn then
        updateItemsSpellList()
        updateItemsSpellChatList()
        SpellChatNavigationPanel.ItemBtn:SetNormalTexture(ImageList.itemButtonH)
        ItemsSpellChatFrame.AddPhraseTextBox:SetText("")
        ItemsSpellChatFrame:Show()
        VariableList.currentAddPhraseTextBox = ItemsSpellChatFrameAddPhraseTextBox
    elseif buttonName == SpellChatNavigationPanelHandWaveBtn then
        HandWaveFrame.AddPhraseTextBox:SetText("")
        updateCurrentHandWaveList()
        SpellChatNavigationPanel.HandWaveBtn:SetNormalTexture(ImageList.handButtonH)
        HandWaveFrame:Show()
        VariableList.currentAddPhraseTextBox = HandWaveFrameAddPhraseTextBox
    elseif buttonName == SpellChatInterfaceFrameSpellChatBtn1 then
        SpellChatInterfaceFrame.SpellChatBtn1:SetNormalTexture(ImageList.spellChatButtonH)
        SpellChatFrame1:Show()
        VariableList.currentAddPhraseTextBox = nil
    elseif buttonName == SpellChatInterfaceFrameSpellChatBtn2 then
        SpellChatInterfaceFrame.SpellChatBtn2:SetNormalTexture(ImageList.spellChatButtonH)
        SpellChatFrame2:Show()
        VariableList.currentAddPhraseTextBox = nil
    end
end

local function addSpellToClassSpellList(addSpellID, addSpellLink)
    tempSpellChatList = {
        spellLink = addSpellLink,
        spellID = addSpellID,
        percentage = 100,
        isEnabled = true,
        spellChatList = {}
    }
    table.insert(VariableList.currentAddClassSpellList, 1, tempSpellChatList)
end

local function addMountToMountList(addMountID, addMountLink, addMountSpellID)
    tempItemList = {
        mountID = addMountID,
        mountLink = addMountLink,
        mountSpellID = addMountSpellID,
        percentage = 100,
        isEnabled = true,
        mountChatList = {}
    }
    table.insert(SpellChatMountList, 1, tempItemList)
end

local function addPetToPetList(addPetID, addPetLink, addPetSpeciesID)
    tempItemList = {
        petID = addPetID,
        petLink = addPetLink,
        petSpeciesID = addPetSpeciesID,
        percentage = 100,
        isEnabled = true,
        petChatList = {}
    }
    table.insert(SpellChatPetList, 1, tempItemList)
end

local function addItemToItemList(addItemID, addItemLink, addItemSpellID)
    tempItemList = {
        itemID = addItemID,
        itemLink = addItemLink,
        itemSpellID = addItemSpellID,
        percentage = 100,
        isEnabled = true,
        itemChatList = {}
    }
    table.insert(SpellChatItemList, 1, tempItemList)
end

local function getCursorLinkForCurrentPhrase(cursorType, cursorArg1, cursorArg2, cursorArg3)
    if cursorType == "spell" then
        spellLink = GetSpellLink(arg3)
        return spellLink
    elseif cursorType == "item" then
        return arg2
    elseif cursorType == "mount" then
        _, mountSpellID = C_MountJournal.GetMountInfoByID(arg1)
        mountLink = GetSpellLink(mountSpellID)
        return mountLink
    elseif cursorType == "battlepet" then
        petLink = C_PetJournal.GetBattlePetLink(arg1)
        return petLink
    else
        printErrorMessages("errorCannotAddLink")
    end
end

local function addChatStringToClassSpellList(addString)
    for k, v in pairs(VariableList.currentClassSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            table.insert(v.spellChatList, 1, addString)
        end
    end
end

local function checkIfSpellIsAlreadyListed(checkSpellID)
    for k, v in pairs(VariableList.currentAddClassSpellList) do
        if v.spellID == checkSpellID then
            return true
        end
    end
end

local function addChatStringToMountChatList(addString)
    for k, v in pairs(SpellChatMountList) do
        if v.mountID == VariableList.currentObjectID then
            table.insert(v.mountChatList, 1, addString)
        end
    end
end

local function addChatStringToPetChatList(addString)
    for k, v in pairs(SpellChatPetList) do
        if v.petID == VariableList.currentObjectID then
            table.insert(v.petChatList, 1, addString)
        end
    end
end

local function addChatStringToItemChatList(addString)
    for k, v in pairs(SpellChatItemList) do
        if v.itemID == VariableList.currentObjectID then
            table.insert(v.itemChatList, 1, addString)
        end
    end
end

local function checkIfMountIsAlreadyListed(checkMountID)
    for k, v in pairs(SpellChatMountList) do
        if v.mountID == checkMountID then
            return true
        end
    end
end

local function checkIfPetIsAlreadyListed(checkPetID)
    for k, v in pairs(SpellChatPetList) do
        if v.petID == checkPetID then
            return true
        end
    end
end

local function checkIfItemIsAlreadyListed(checkItemID)
    for k, v in pairs(SpellChatItemList) do
        if v.itemID == checkItemID then
            return true
        end
    end
end

local function masterAddObjectToList(convertItemType, convertArg1, convertArg2) -- cursor information provides different returns based on the type
    if cursorType == "item" then -- test cursor type
        toggleButton(SpellChatNavigationPanelItemBtn)
        _, itemSpellID = GetItemSpell(arg1)
        if not itemSpellID then
            printErrorMessages("errorNoOnuseAction")
        elseif checkIfItemIsAlreadyListed(arg1) then
            printErrorMessages("errorAlreadyListed")
        else
            addItemToItemList(arg1, arg2, itemSpellID)
        end
    elseif cursorType == "mount" then
        toggleButton(SpellChatNavigationPanelMountBtn)
        mountName, mountSpellID, _, _, _, _, _, _, _, _, _, mountID = C_MountJournal.GetMountInfoByID(arg1)
        mountLink = GetSpellLink(mountSpellID)
        if checkIfMountIsAlreadyListed(mountID) then
            printErrorMessages("errorAlreadyListed")
        else
            addMountToMountList(mountID, mountLink, mountSpellID)
        end
    elseif cursorType == "battlepet" then
        toggleButton(SpellChatNavigationPanelPetBtn)
        petLink = C_PetJournal.GetBattlePetLink(arg1)
        speciesID = C_PetJournal.GetPetInfoByPetID(arg1)
        if checkIfPetIsAlreadyListed(arg1) then
            printErrorMessages("errorAlreadyListed")
        else
            addPetToPetList(arg1, petLink, speciesID)
        end
    else
        printErrorMessages("errorNotAnItem")
    end
    updateListBasedOnOpenFrame()
    ClearCursor()
end

local function checkIfSuccessfulCastSpellIDIsListed(checkSpellID) -- check to see if the successful spell cast is on the spell, item or mount list
    for k, v in pairs(VariableList.currentAddClassSpellList) do
        if v.spellID == checkSpellID then
            return true
        end
    end
    for k, v in pairs(SpellChatItemList) do
        if v.itemSpellID == checkSpellID then
            return true
        end
    end
    for k, v in pairs(SpellChatMountList) do
        if v.mountSpellID == checkSpellID then
            return true
        end
    end
end

local function loadSpellHeader() -- fill the header based on the selected spell
    if VariableList.currentClassSpellList == DeathKnightSpellList then
        DeathKnightSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        DeathKnightSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        DeathKnightSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        DeathKnightSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == DemonHunterSpellList then
        DemonHunterSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        DemonHunterSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        DemonHunterSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        DemonHunterSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == DruidSpellList then
        DruidSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        DruidSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        DruidSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        DruidSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == EvokerSpellList then
        EvokerSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        EvokerSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        EvokerSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        EvokerSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == HunterSpellList then
        HunterSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        HunterSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        HunterSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        HunterSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == MageSpellList then
        MageSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        MageSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        MageSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        MageSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == MonkSpellList then
        MonkSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        MonkSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        MonkSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        MonkSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == PaladinSpellList then
        PaladinSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        PaladinSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        PaladinSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        PaladinSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == PriestSpellList then
        PriestSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        PriestSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        PriestSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        PriestSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == RogueSpellList then
        RogueSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        RogueSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        RogueSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        RogueSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == ShamanSpellList then
        ShamanSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        ShamanSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        ShamanSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        ShamanSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == WarlockSpellList then
        WarlockSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        WarlockSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        WarlockSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        WarlockSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    elseif VariableList.currentClassSpellList == WarriorSpellList then
        WarriorSpellChatFrame.TitleText:SetText(VariableList.currentClassSpellLink)
        WarriorSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentClassSpellPercentage)
        WarriorSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
        WarriorSpellChatFrame.AddPhraseTextBox:SetFocus(true)
    end
end

local function loadMountHeader() -- fill the header based on the selected mount
    MountSpellChatFrame.TitleText:SetText(VariableList.currentObjectLink)
    MountSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentObjectPercentage)
    MountSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentObjectEnabled)
    MountSpellChatFrame.AddPhraseTextBox:SetFocus(true)
end

local function loadPetHeader() -- fill the header based on the selected pet
    PetSpellChatFrame.TitleText:SetText(VariableList.currentObjectLink)
    PetSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentObjectPercentage)
    PetSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentObjectEnabled)
    PetSpellChatFrame.AddPhraseTextBox:SetFocus(true)
end

local function loadItemHeader() -- fill the header based on the selected item
    ItemsSpellChatFrame.TitleText:SetText(VariableList.currentObjectLink)
    ItemsSpellChatFrame.PercentageTextBox:SetNumber(VariableList.currentObjectPercentage)
    ItemsSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentObjectEnabled)
    ItemsSpellChatFrame.AddPhraseTextBox:SetFocus(true)
end

local function clearCurrentClassSpell() -- delete the currently selected spell including any associated chats
    for k, v in pairs(VariableList.currentClassSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            table.remove(VariableList.currentClassSpellList, k)
        end
    end
    if VariableList.currentClassSpellList == DeathKnightSpellList then
        DeathKnightSpellChatFrame.TitleText:SetText("")
        DeathKnightSpellChatFrame.PercentageTextBox:SetText("")
        DeathKnightSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == DemonHunterSpellList then
        DemonHunterSpellChatFrame.TitleText:SetText("")
        DemonHunterSpellChatFrame.PercentageTextBox:SetText("")
        DemonHunterSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == DruidSpellList then
        DruidSpellChatFrame.TitleText:SetText("")
        DruidSpellChatFrame.PercentageTextBox:SetText("")
        DruidSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == EvokerSpellList then
        EvokerSpellChatFrame.TitleText:SetText("")
        EvokerSpellChatFrame.PercentageTextBox:SetText("")
        EvokerSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == HunterSpellList then
        HunterSpellChatFrame.TitleText:SetText("")
        HunterSpellChatFrame.PercentageTextBox:SetText("")
        HunterSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == MageSpellList then
        MageSpellChatFrame.TitleText:SetText("")
        MageSpellChatFrame.PercentageTextBox:SetText("")
        MageSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == MonkSpellList then
        MonkSpellChatFrame.TitleText:SetText("")
        MonkSpellChatFrame.PercentageTextBox:SetText("")
        MonkSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == PaladinSpellList then
        PaladinSpellChatFrame.TitleText:SetText("")
        PaladinSpellChatFrame.PercentageTextBox:SetText("")
        PaladinSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == PriestSpellList then
        PriestSpellChatFrame.TitleText:SetText("")
        PriestSpellChatFrame.PercentageTextBox:SetText("")
        PriestSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == RogueSpellList then
        RogueSpellChatFrame.TitleText:SetText("")
        RogueSpellChatFrame.PercentageTextBox:SetText("")
        RogueSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == ShamanSpellList then
        ShamanSpellChatFrame.TitleText:SetText("")
        ShamanSpellChatFrame.PercentageTextBox:SetText("")
        ShamanSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == WarlockSpellList then
        WarlockSpellChatFrame.TitleText:SetText("")
        WarlockSpellChatFrame.PercentageTextBox:SetText("")
        WarlockSpellChatFrame.EnableCheckbox:SetChecked(false)
    elseif VariableList.currentClassSpellList == WarriorSpellList then
        WarriorSpellChatFrame.TitleText:SetText("")
        WarriorSpellChatFrame.PercentageTextBox:SetText("")
        WarriorSpellChatFrame.EnableCheckbox:SetChecked(false)
    end
end

local function clearCurrentClassSpellChat() -- clears all chats from the currently selected spell
    for k, v in pairs(VariableList.currentClassSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            for a, b in pairs(v.spellChatList) do
                if b == VariableList.currentClassSpellPhrase then
                    table.remove(v.spellChatList, a)
                end
            end
        end
    end
end

local function clearCurrentMount() -- delete the currently selected mount including any associated chats
    for k, v in pairs(SpellChatMountList) do
        if v.mountID == VariableList.currentObjectID then
            table.remove(SpellChatMountList, k)
        end
    end
    MountSpellChatFrame.TitleText:SetText("")
    MountSpellChatFrame.PercentageTextBox:SetText("")
    MountSpellChatFrame.EnableCheckbox:SetChecked(false)
end

local function clearCurrentPet() -- delete the currently selected pet including any associated chats
    for k, v in pairs(SpellChatPetList) do
        if v.petID == VariableList.currentObjectID then
            table.remove(SpellChatPetList, k)
        end
    end
    PetSpellChatFrame.TitleText:SetText("")
    PetSpellChatFrame.PercentageTextBox:SetText("")
    PetSpellChatFrame.EnableCheckbox:SetChecked(false)
end

local function clearCurrentItem() -- delete the currently selected item including any associated chats
    for k, v in pairs(SpellChatItemList) do
        if v.itemID == VariableList.currentObjectID then
            table.remove(SpellChatItemList, k)
        end
    end
    ItemsSpellChatFrame.TitleText:SetText("")
    ItemsSpellChatFrame.PercentageTextBox:SetText("")
    ItemsSpellChatFrame.EnableCheckbox:SetChecked(false)
end

local function clearCurrentMountSpellChat() -- clears all chats from the currently selected mount
    for k, v in pairs(SpellChatMountList) do
        if v.mountID == VariableList.currentObjectID then
            for a, b in pairs(v.mountChatList) do
                if b == VariableList.currentObjectPhrase then
                    table.remove(v.mountChatList, a)
                end
            end
        end
    end
end

local function clearCurrentPetSpellChat() -- clears all chats from the currently selected pet
    for k, v in pairs(SpellChatPetList) do
        if v.petID == VariableList.currentObjectID then
            for a, b in pairs(v.petChatList) do
                if b == VariableList.currentObjectPhrase then
                    table.remove(v.petChatList, a)
                end
            end
        end
    end
end

local function clearCurrentItemSpellChat() -- clears all chats from the currently selected item
    for k, v in pairs(SpellChatItemList) do
        if v.itemID == VariableList.currentObjectID then
            for a, b in pairs(v.itemChatList) do
                if b == VariableList.currentObjectPhrase then
                    table.remove(v.itemChatList, a)
                end
            end
        end
    end
end

local function clearCurrentHandWaveChatPhrase() -- clear all chats from the currently selected hand chats
    for k, v in pairs(VariableList.currentHandWaveChatList) do
        if v == VariableList.currentHandWaveChatPhrase then
            table.remove(VariableList.currentHandWaveChatList, k)
        end
    end
end

local function updateSpellPercentage(updatePercentageNumber)
    if updatePercentageNumber >= 101 then -- if the entered number is too high
        updatePercentageNumber = 100
    elseif updatePercentageNumber <= 9 then -- if the entered number is too low
        updatePercentageNumber = 10
    end
    for k, v in pairs(VariableList.currentClassSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            v.percentage = updatePercentageNumber
        end
    end
    if VariableList.currentClassSpellList == DeathKnightSpellList then
        DeathKnightSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == DemonHunterSpellList then
        DemonHunterSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == DruidSpellList then
        DruidSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == EvokerSpellList then
        EvokerSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == HunterSpellList then
        HunterSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == MageSpellList then
        MageSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == MonkSpellList then
        MonkSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == PaladinSpellList then
        PaladinSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == PriestSpellList then
        PriestSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == RogueSpellList then
        RogueSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == ShamanSpellList then
        ShamanSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == WarlockSpellList then
        WarlockSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    elseif updateClassList == WarriorSpellList then
        WarriorSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
    end
end

local function updateMountPercentage(updatePercentageNumber)
    if updatePercentageNumber >= 101 then -- if the entered number is too high
        updatePercentageNumber = 100
    elseif updatePercentageNumber <= 9 then -- if the entered number is too low
        updatePercentageNumber = 10
    end
    for k, v in pairs(SpellChatMountList) do
        if v.mountID == VariableList.currentObjectID then
            v.percentage = updatePercentageNumber
        end
    end
    MountSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
end

local function updatePetPercentage(updatePercentageNumber)
    if updatePercentageNumber >= 101 then -- if the entered number is too high
        updatePercentageNumber = 100
    elseif updatePercentageNumber <= 9 then -- if the entered number is too low
        updatePercentageNumber = 10
    end
    for k, v in pairs(SpellChatItemList) do
        if v.petID == VariableList.currentObjectID then
            v.percentage = updatePercentageNumber
        end
    end
    PetSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
end

local function updateItemPercentage(updatePercentageNumber)
    if updatePercentageNumber >= 101 then -- if the entered number is too high
        updatePercentageNumber = 100
    elseif updatePercentageNumber <= 9 then -- if the entered number is too low
        updatePercentageNumber = 10
    end
    for k, v in pairs(SpellChatItemList) do
        if v.itemID == VariableList.currentObjectID then
            v.percentage = updatePercentageNumber
        end
    end
    ItemsSpellChatFrame.PercentageTextBox:SetNumber(updatePercentageNumber)
end

local function updateScalePercentage(updateScaleNumber, updateScaleType)
    if updateScaleNumber >= 301 then -- if the entered number is too high
        updateScaleNumber = 300
    elseif updateScaleNumber <= 49 then -- if the entered number is too low
        updateScaleNumber = 50
    end
    saveScaleNumber = updateScaleNumber / 100
    if updateScaleType == "SpellChatFrameScaleTextBox" then
        SpellChatInterfaceFrame:SetScale(saveScaleNumber)
        SpellChatOptionsList.spellChatFrameScale = saveScaleNumber
        SpellChatFrame1.SpellChatFrameScaleTextBox:SetNumber(updateScaleNumber)
    elseif updateScaleType == "MagicButtonScaleTextBox" then
        spellChatMagicButton:SetScale(saveScaleNumber)
        SpellChatOptionsList.magicButtonScale = saveScaleNumber
        SpellChatFrame1.MagicButtonScaleTextBox:SetNumber(updateScaleNumber)
    elseif updateScaleType == "ButtonGridScaleTextBox" then
        HandWaveButtonGridFrame:SetScale(saveScaleNumber)
        SpellChatOptionsList.buttonBoxScale = saveScaleNumber
        SpellChatFrame1.ButtonGridScaleTextBox:SetText(updateScaleNumber)
    end
end

local function updateOpacityPercentage(updateOpacityNumber, updateOpacityType)
    if updateOpacityNumber >= 101 then -- if the entered number is too high
        updateOpacityNumber = 100
    elseif updateOpacityNumber <= 24 then -- if the entered number is too low
        updateOpacityNumber = 25
    end
    saveOpacityNumber = updateOpacityNumber / 100
    if updateOpacityType == "MagicButtonOpacityTextBox" then
        spellChatMagicButton:SetAlpha(saveOpacityNumber)
        SpellChatOptionsList.magicButtonOpacity = saveOpacityNumber
        SpellChatFrame1.MagicButtonOpacityTextBox:SetNumber(updateOpacityNumber)
    elseif updateOpacityType == "ButtonGridOpacityTextBox" then
        HandWaveButtonGridFrame:SetAlpha(saveOpacityNumber)
        SpellChatOptionsList.buttonBoxOpacity = saveOpacityNumber
        SpellChatFrame1.ButtonGridOpacityTextBox:SetNumber(updateOpacityNumber)
    end
end

local function updateSpellEnabled()
    for k, v in pairs(VariableList.currentClassSpellList) do
        if v.currentObjectID == VariableList.currentObjectID then
            v.isEnabled = VariableList.currentObjectEnabled
        end
    end
end

local function updateMountEnabled()
    for k, v in pairs(SpellChatMountList) do
        if v.mountID == VariableList.currentObjectID then
            v.isEnabled = VariableList.currentObjectEnabled
        end
    end
end

local function updatePetEnabled()
    for k, v in pairs(SpellChatPetList) do
        if v.petID == VariableList.currentObjectID then
            v.isEnabled = VariableList.currentObjectEnabled
        end
    end
end

local function updateItemEnabled()
    for k, v in pairs(SpellChatItemList) do
        if v.itemID == VariableList.currentObjectID then
            v.isEnabled = VariableList.currentObjectEnabled
        end
    end
end

local function clearCurrentChatList()
    for k, v in pairs(VariableList.currentClassSpellList) do
        if v.spellID == VariableList.currentClassSpellID then
            wipe(v.spellChatList)
        end
    end
end

local function clearCurrentMountChatList()
    for k, v in pairs(SpellChatMountList) do
        if v.mountID == VariableList.currentObjectID then
            wipe(v.mountChatList)
        end
    end
end

local function clearCurrentPetChatList()
    for k, v in pairs(SpellChatPetList) do
        if v.petID == VariableList.currentObjectID then
            wipe(v.petChatList)
        end
    end
end

local function clearCurrentItemChatList()
    for k, v in pairs(SpellChatItemList) do
        if v.itemID == VariableList.currentObjectID then
            wipe(v.itemChatList)
        end
    end
end

local function randomPercentageTest(percentage)
    math.random() -- sometimes random is not so random so lets kick start it to help
    randomNumber = math.random(1, 100)
    if percentage >= randomNumber then
        return true
    end
end

local function sendSpellChatPhraseToGroupChat(chatPhrase) -- send the phrase to correct chat channel
    SendChatMessage(
        chatPhrase,
        IsInGroup(LE_PARTY_CATEGORY_INSTANCE) and "INSTANCE_CHAT" or IsInRaid() and "RAID" or "PARTY"
    )
end

local function spellChatMainSpellPhraseFunction(spellID)
    for k, v in pairs(VariableList.currentAddClassSpellList) do -- take spellID and test against each list
        if v.spellID == spellID then -- if a match is found
            if randomPercentageTest(v.percentage) then -- test random number against spell percentage
                if #v.spellChatList > 0 then -- if no chat list stop
                    math.random()
                    randomNumber = math.random(1, #v.spellChatList) -- generate random number based on chat list size
                    sendSpellChatPhraseToGroupChat(v.spellChatList[randomNumber]) -- get the phrase at the random entry and send to print
                    return -- return out of function
                end
            end
        end
    end
    for k, v in pairs(SpellChatItemList) do
        if v.itemSpellID == spellID then
            if randomPercentageTest(v.percentage) then
                if #v.itemChatList > 0 then
                    math.random()
                    randomNumber = math.random(1, #v.itemChatList)
                    sendSpellChatPhraseToGroupChat(v.itemChatList[randomNumber])
                    return
                end
            end
        end
    end
end

local function spellChatPetPhraseFunction() -- special function as summoning pets works differently
    C_Timer.After(
        .3,
        function()
            -- need to wait as the pet data is not immediately available
            if C_PetJournal.GetSummonedPetGUID() then -- if a pet is summoned
                for k, v in pairs(SpellChatPetList) do
                    if v.petID == C_PetJournal.GetSummonedPetGUID() then
                        if randomPercentageTest(v.percentage) then
                            if #v.petChatList > 0 then
                                math.random()
                                randomNumber = math.random(.3, #v.petChatList)
                                --sendSpellChatPhraseToGroupChat(v.petChatList[randomNumber])
                                print(v.petChatList[randomNumber]) -- debug --
                            end
                        end
                    end
                end
            end
        end
    )
end

local function groupChatMainPhraseFunction(chatType) -- send phrase to correct chat channel
    if chatType == "guildHello" then
        math.random()
        randomNumber = math.random(1, #SpellChatGuildHelloList)
        SendChatMessage(SpellChatGuildHelloList[randomNumber], "GUILD")
        ChatEdit_ChooseBoxForSend():SetAttribute("chatType", "GUILD") -- set sticky channel
    elseif chatType == "guildGoodbye" then
        if #SpellChatGuildGoodbyeList > 0 then
            math.random()
            randomNumber = math.random(1, #SpellChatGuildGoodbyeList)
            SendChatMessage(SpellChatGuildGoodbyeList[randomNumber], "GUILD")
            ChatEdit_ChooseBoxForSend():SetAttribute("chatType", "GUILD") -- set sticky channel
        end
    elseif chatType == "groupHello" then
        if #SpellChatGroupHelloList > 0 then
            math.random()
            randomNumber = math.random(1, #SpellChatGroupHelloList)
            sendSpellChatPhraseToGroupChat(SpellChatGroupHelloList[randomNumber])
            ChatEdit_ChooseBoxForSend():SetAttribute("chatType", "PARTY") -- set sticky channel
        end
    elseif chatType == "groupGoodbye" then
        if #SpellChatGroupGoodbyeList > 0 then
            math.random()
            randomNumber = math.random(1, #SpellChatGroupGoodbyeList)
            sendSpellChatPhraseToGroupChat(SpellChatGroupGoodbyeList[randomNumber])
            ChatEdit_ChooseBoxForSend():SetAttribute("chatType", "PARTY") -- set sticky channel
        end
    elseif chatType == "generalChat1" then
        --        ChatEdit_ChooseBoxForSend():SetAttribute("chatType", "1. General - Garrison") -- cannot auto set sticky channel  -- debug
        math.random()
        randomNumber = math.random(1, #SpellChatGeneral1List)
        SendChatMessage(SpellChatGeneral1List[randomNumber], "CHANNEL", nil, 1)
    elseif chatType == "generalChat2" then
        math.random()
        randomNumber = math.random(1, #SpellChatGeneral2List)
        SendChatMessage(SpellChatGeneral2List[randomNumber], "CHANNEL", nil, 1)
    elseif chatType == "tradeChat" then
        math.random()
        randomNumber = math.random(1, #SpellChatTradeList)
        SendChatMessage(SpellChatTradeList[randomNumber], "CHANNEL", nil, 2)
    elseif chatType == "lfgChat" then
        math.random()
        randomNumber = math.random(1, #SpellChatLFGList)
        SendChatMessage(SpellChatLFGList[randomNumber], "CHANNEL", nil, 4) -- debug --
    elseif chatType == "sayChat" then
        math.random()
        randomNumber = math.random(1, #SpellChatSayList)
        SendChatMessage(SpellChatSayList[randomNumber], "SAY") -- debug --
    elseif chatType == "yellChat" then
        math.random()
        randomNumber = math.random(1, #SpellChatYellList)
        SendChatMessage(SpellChatYellList[randomNumber], "YELL")
    end
end

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         global functions for keybinds       ===========================
-- ===================================================================================================
-- ===================================================================================================

-- ===========================         run guild hello function          ===========================
function SPCTRUNGUILDHELLOCHATFUNCTION()
    if #SpellChatGuildHelloList > 0 then
        if IsInGuild() then
            groupChatMainPhraseFunction("guildHello")
        else
            printErrorMessages("errorNotInAGuild")
        end
    else
        printErrorMessages("errorNoPhrases")
    end
end

-- ===========================         run guild goodbye function          ===========================
function SPCTRUNGUILDGOODBYECHATFUNCTION()
    if #SpellChatGuildGoodbyeList > 0 then
        if IsInGuild() then
            groupChatMainPhraseFunction("guildGoodbye")
        else
            printErrorMessages("errorNotInAGuild")
        end
    else
        printErrorMessages("errorNoPhrases")
    end
end

-- ===========================         run group hello function          ===========================
function SPCTRUNGROUPHELLOCHATFUNCTION()
    if #SpellChatGroupHelloList > 0 then
        if IsInRaid() or IsInGroup() then
            groupChatMainPhraseFunction("groupHello")
        else
            printErrorMessages("errorNotInAGroup")
        end
    else
        printErrorMessages("errorNoPhrases")
    end
end

-- ===========================         run group goodbye function          ===========================
function SPCTRUNGROUPGOODBYECHATFUNCTION()
    if #SpellChatGroupGoodbyeList > 0 then
        if IsInRaid() or IsInGroup() then
            groupChatMainPhraseFunction("groupGoodbye")
        else
            printErrorMessages("errorNotInAGroup")
        end
    else
        printErrorMessages("errorNoPhrases")
    end
end

-- ===========================         run general 1 function          ===========================
function SPCTRUNGENERALCHANNELCHAT1FUNCTION()
    if #SpellChatGeneral1List > 0 then
        groupChatMainPhraseFunction("generalChat1")
    else
        printErrorMessages("errorNoPhrases")
    end
end

-- ===========================         run general 2 function          ===========================
function SPCTRUNGENERALCHANNELCHAT2FUNCTION()
    if #SpellChatGeneral2List > 0 then
        groupChatMainPhraseFunction("generalChat2")
    else
        printErrorMessages("errorNoPhrases")
    end
end

-- ===========================         run trade function          ===========================
function SPCTRUNTRADECHANNELCHATFUNCTION()
    if #SpellChatTradeList > 0 then
        groupChatMainPhraseFunction("tradeChat")
    else
        printErrorMessages("errorNoPhrases")
    end
end

-- ===========================         run lfg function          ===========================
function SPCTRUNLFGCHANNELCHATFUNCTION()
    if #SpellChatLFGList > 0 then
        groupChatMainPhraseFunction("lfgChat")
    else
        printErrorMessages("errorNoPhrases")
    end
end

-- ===========================         run say function          ===========================
function SPCTRUNSAYCHANNELCHATFUNCTION()
    if #SpellChatSayList > 0 then
        groupChatMainPhraseFunction("sayChat")
    else
        printErrorMessages("errorNoPhrases")
    end
end

-- ===========================         run yell function          ===========================
function SPCTRUNYELLCHANNELCHATFUNCTION()
    if #SpellChatYellList > 0 then
        groupChatMainPhraseFunction("yellChat")
    else
        printErrorMessages("errorNoPhrases")
    end
end

-- ===========================         toggle spellchat interface frame          ===========================
function SPCTTOGGLESPELLCHATINTERFACEFRAME()
    if SpellChatInterfaceFrame:IsShown() then
        SpellChatInterfaceFrame:Hide()
    else
        SpellChatInterfaceFrame:Show()
    end
end

-- ===========================         reset spellchat UI layout          ===========================
function SPCTRESETSPELLCHATUILAYOUT()
    SpellChatInterfaceFrame:ClearAllPoints()
    SpellChatOptionsList.spellChatFrameScale = 1
    SpellChatInterfaceFrame:SetScale(1)
    SpellChatFrame1.SpellChatFrameScaleTextBox:SetNumber(100)
    SpellChatInterfaceFrame:SetPoint("CENTER")
    spellChatMagicButton:ClearAllPoints()
    SpellChatOptionsList.magicButtonScale = 1
    spellChatMagicButton:SetScale(1)
    SpellChatFrame1.MagicButtonScaleTextBox:SetNumber(100)
    SpellChatOptionsList.magicButtonOpacity = 1
    spellChatMagicButton:SetAlpha(1)
    SpellChatFrame1.MagicButtonOpacityTextBox:SetNumber(100)
    spellChatMagicButton:SetPoint("BOTTOMRIGHT", SpellChatInterfaceFrame, "TOPRIGHT")
    HandWaveButtonGridFrame:ClearAllPoints()
    SpellChatOptionsList.buttonBoxScale = 1
    HandWaveButtonGridFrame:SetScale(1)
    SpellChatFrame1.ButtonGridScaleTextBox:SetText(100)
    SpellChatOptionsList.buttonBoxOpacity = 1
    HandWaveButtonGridFrame:SetAlpha(1)
    SpellChatFrame1.ButtonGridOpacityTextBox:SetText(100)
    HandWaveButtonGridFrame:SetPoint("TOPLEFT", SpellChatInterfaceFrame, "TOPRIGHT")
    if not SpellChatInterfaceFrame:IsVisible() then
        SpellChatInterfaceFrame:Show()
    end
end

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         slash commands          ===========================
-- ===================================================================================================
-- ===================================================================================================

-- ===========================         clear all lists          ===========================
SLASH_CLEARALLSPELLITEMLISTS1 = "/SPCC"
function SlashCmdList.CLEARALLSPELLITEMLISTS(msg, editbox)
    wipe(DeathKnightSpellList)
    wipe(DemonHunterSpellList)
    wipe(DruidSpellList)
    wipe(EvokerSpellList)
    wipe(HunterSpellList)
    wipe(MageSpellList)
    wipe(MonkSpellList)
    wipe(PaladinSpellList)
    wipe(PriestSpellList)
    wipe(RogueSpellList)
    wipe(ShamanSpellList)
    wipe(WarlockSpellList)
    wipe(WarriorSpellList)
    wipe(SpellChatGuildHelloList)
    wipe(SpellChatGuildGoodbyeList)
    wipe(SpellChatGroupHelloList)
    wipe(SpellChatGroupGoodbyeList)
    wipe(SpellChatGeneral1List)
    wipe(SpellChatGeneral2List)
    wipe(SpellChatTradeList)
    wipe(SpellChatSayList)
    wipe(SpellChatLFGList)
    wipe(SpellChatYellList)
    wipe(SpellChatItemList)
    wipe(SpellChatMountList)
    wipe(SpellChatPetList)
    if SpellChatInterfaceFrame:IsVisible() then
        updateListBasedOnOpenFrame()
    end
    if VariableList.currentHandWaveChatList then
        VariableList.currentHandWaveChatList = SpellChatGuildHelloList
        updateCurrentHandWaveList()
    end
    print(TextList.clearAllListsText)
end
-- ===========================         run guild hello function          ===========================
SLASH_SPCTRUNGUILDHELLOCHATFUNCTION1 = "/SPCGDH"
function SlashCmdList.SPCTRUNGUILDHELLOCHATFUNCTION(msg, editbox)
    SPCTRUNGUILDHELLOCHATFUNCTION()
end

-- ===========================         run guild goodbye function          ===========================
SLASH_SPCTRUNGUILDGOODBYECHATFUNCTION1 = "/SPCGDG"
function SlashCmdList.SPCTRUNGUILDGOODBYECHATFUNCTION(msg, editbox)
    SPCTRUNGUILDGOODBYECHATFUNCTION()
end

-- ===========================         run group hello function          ===========================
SLASH_SPCTRUNGROUPHELLOCHATFUNCTION1 = "/SPCGPH"
function SlashCmdList.SPCTRUNGROUPHELLOCHATFUNCTION(msg, editbox)
    SPCTRUNGROUPHELLOCHATFUNCTION()
end

-- ===========================         run group goodbye function          ===========================
SLASH_SPCTRUNGROUPGOODBYECHATFUNCTION1 = "/SPCGPG"
function SlashCmdList.SPCTRUNGROUPGOODBYECHATFUNCTION(msg, editbox)
    SPCTRUNGROUPGOODBYECHATFUNCTION()
end

-- ===========================         run general chat 1 function          ===========================
SLASH_SPCTRUNGENERALCHANNELCHAT1FUNCTION1 = "/SPCG1"
function SlashCmdList.SPCTRUNGENERALCHANNELCHAT1FUNCTION(msg, editbox)
    SPCTRUNGENERALCHANNELCHAT1FUNCTION()
end

-- ===========================         run general chat 2 function          ===========================
SPCTRUNGENERALCHANNELCHAT2FUNCTION1 = "/SPCG2"
function SlashCmdList.SPCTRUNGENERALCHANNELCHAT2FUNCTION(msg, editbox)
    SPCTRUNGENERALCHANNELCHAT2FUNCTION()
end

-- ===========================         run trade chat function          ===========================
SPCTRUNTRADECHANNELCHATFUNCTION1 = "/SPCT"
function SlashCmdList.SPCTRUNTRADECHANNELCHATFUNCTION(msg, editbox)
    SPCTRUNTRADECHANNELCHATFUNCTION()
end

-- ===========================         run lfg chat function          ===========================
SPCTRUNLFGCHANNELCHATFUNCTION1 = "/SPCL"
function SlashCmdList.SPCTRUNLFGCHANNELCHATFUNCTION(msg, editbox)
    SPCTRUNLFGCHANNELCHATFUNCTION()
end

-- ===========================         run say chat function          ===========================
SPCTRUNSAYCHANNELCHATFUNCTION1 = "/SPCS"
function SlashCmdList.SPCTRUNSAYCHANNELCHATFUNCTION(msg, editbox)
    SPCTRUNSAYCHANNELCHATFUNCTION()
end

-- ===========================         run yell chat function          ===========================
SPCTRUNYELLCHANNELCHATFUNCTION1 = "/SPY"
function SlashCmdList.SPCTRUNYELLCHANNELCHATFUNCTION(msg, editbox)
    SPCTRUNYELLCHANNELCHATFUNCTION()
end

-- ===========================         toggle spellchat interface frame          ===========================
SLASH_SPCTTOGGLESPELLCHATINTERFACEFRAME1 = "/SPC"
function SlashCmdList.SPCTTOGGLESPELLCHATINTERFACEFRAME(msg, editbox)
    SPCTTOGGLESPELLCHATINTERFACEFRAME()
end

-- ===========================         reset frame and buttons scales and positions          ===========================
SLASH_SPCTRESETSPELLCHATUILAYOUT1 = "/SPCPOS"
function SlashCmdList.SPCTRESETSPELLCHATUILAYOUT(msg, editbox)
    SPCTRESETSPELLCHATUILAYOUT()
end

-- ===========================         reset settings to their defaults          ===========================
SLASH_SPCTRESETSPELLCHATSETTINGS1 = "/SPCDS"
function SlashCmdList.SPCTRESETSPELLCHATSETTINGS(msg, editbox)
    SpellChatOptionsList = nil
    ReloadUI()
end

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Frames          ===========================
-- ===================================================================================================
-- ===================================================================================================

local SpellChatInterfaceFrame = CreateFrame("Frame", "SpellChatInterfaceFrame", UIParent, "BasicFrameTemplateWithInset")
SpellChatInterfaceFrame:SetSize(NumberList.spellChatMainFrameWidth, NumberList.spellChatMainFrameHeight)
SpellChatInterfaceFrame:SetScale(1)
SpellChatInterfaceFrame:ClearAllPoints()
SpellChatInterfaceFrame:ClearAllPoints()
SpellChatInterfaceFrame:SetPoint("CENTER")
SpellChatInterfaceFrame:EnableMouse(true)
SpellChatInterfaceFrame:SetMovable(true)
SpellChatInterfaceFrame:SetClampedToScreen(true)
SpellChatInterfaceFrame:RegisterForDrag("RightButton", "LeftButton")
SpellChatInterfaceFrame:SetScript("OnDragStart", SpellChatInterfaceFrame.StartMoving)
SpellChatInterfaceFrame:SetScript("OnDragStop", SpellChatInterfaceFrame.StopMovingOrSizing)
SpellChatInterfaceFrame:SetToplevel(true)
SpellChatInterfaceFrame:SetScript(
    "OnEvent",
    function(self, event, ...)
        if event == "PLAYER_LOGIN" then
            print(TextList.addonLoaded) -- load message
            initialiseLists()
            setCheckBoxesAndScales()
            setCurrentAddClassSpellButtonList()
            toggleButton(SpellChatInterfaceFrameSpellChatBtn1)
            handWaveGridFrameButtonLayout()
            if SpellChatOptionsList.buttonBoxIsHidden then
                HandWaveButtonGridFrame:Hide()
            end
        elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
            unit, _, spellID = ... -- get the casting unit and spellID
            if SpellChatOptionsList.spellChatEnabled then -- if addon enabled
                if IsInRaid() or IsInGroup() then -- must be in a group
                    if unit == "player" and checkIfSuccessfulCastSpellIDIsListed(spellID) then -- if the casting unit is player and the spell is listed
                        spellChatMainSpellPhraseFunction(spellID) -- print message to current group chat
                    elseif unit == "player" then -- make sure its the player that summons as pets work differently
                        spellChatPetPhraseFunction() -- run the pet phrase function
                    end
                end
            end
        elseif event == "ADDON_LOADED" then
            local arg1 = ...
            if arg1 == "Blizzard_AchievementUI" then -- if achievement journal
                hooksecurefunc(
                    "AchievementButton_OnClick", -- hook the achievementbutton_onclick function
                    function(self)
                        if IsAltKeyDown() then
                            if not VariableList.currentAddPhraseTextBox then -- make sure we have a text box
                                return
                            else
                                VariableList.currentAddPhraseTextBox:Insert(GetAchievementLink(self.id)) -- insert link into current text box
                            end
                        end
                    end
                )
            elseif arg1 == "Blizzard_EncounterJournal" then -- if adventure journal
                hooksecurefunc(
                    "EncounterJournal_Loot_OnClick", -- hook the item onclick item function
                    function(self)
                        if IsAltKeyDown() then
                            if not VariableList.currentAddPhraseTextBox then -- make sure we have a text box
                                return
                            else
                                VariableList.currentAddPhraseTextBox:Insert(self.link) -- insert link into current text box
                            end
                        end
                    end
                )
                hooksecurefunc(
                    "EncounterJournalBossButton_OnClick", -- hook the onclick boss function
                    function(self)
                        if IsAltKeyDown() then
                            if not VariableList.currentAddPhraseTextBox then -- make sure we have a text box
                                return
                            else
                                VariableList.currentAddPhraseTextBox:Insert(self.link) -- insert link into current text box
                            end
                        end
                    end
                )
                hooksecurefunc(
                    "EncounterJournal_OnClick", -- hook the onclick boss abilities function
                    function(self)
                        if IsAltKeyDown() then
                            if not VariableList.currentAddPhraseTextBox then -- make sure we have a text box
                                return
                            else
                                VariableList.currentAddPhraseTextBox:Insert(self.link) -- insert link into current text box
                            end
                        end
                    end
                )
            elseif arg1 == "Blizzard_Collections" then -- for all collections
                hooksecurefunc(
                    "HeirloomsJournalSpellButton_OnClick", -- for heirloom collection
                    function(self) -- hook the heirloomsjournalspellbutton_onclick function
                        if IsAltKeyDown() then
                            if not VariableList.currentAddPhraseTextBox then -- make sure we have a text box
                                return
                            else
                                VariableList.currentAddPhraseTextBox:Insert(C_Heirloom.GetHeirloomLink(self.itemID)) -- insert link into current text box
                            end
                        end
                    end
                )
                hooksecurefunc(
                    "ToySpellButton_OnModifiedClick", -- for toy collection
                    function(self)
                        if IsAltKeyDown() then
                            if not VariableList.currentAddPhraseTextBox then -- make sure we have a text box
                                return
                            else
                                VariableList.currentAddPhraseTextBox:Insert(C_ToyBox.GetToyLink(self.itemID)) -- insert link into current text box
                            end
                        end
                    end
                )
                local petIndex = 0 -- for pet collection
                while true do
                    petIndex = petIndex + 1
                    local buttonName = "PetJournalListScrollFrameButton" .. petIndex -- loop through the displayed pet buttons
                    local button = _G[buttonName]
                    if not button then
                        break
                    end
                    button:HookScript(
                        "OnClick",
                        function(self) -- add a hook to each displayed pet button
                            if IsAltKeyDown() then
                                if not VariableList.currentAddPhraseTextBox then -- make sure we have a text box
                                    return
                                else
                                    local _, _, _, _, _, _, _, speciesName = C_PetJournal.GetPetInfoByIndex(self.index)
                                    local speciesId, petGUID = C_PetJournal.FindPetIDByName(speciesName)
                                    if petGUID then
                                        VariableList.currentAddPhraseTextBox:Insert(
                                            C_PetJournal.GetBattlePetLink(petGUID)
                                        ) -- insert link into current text box
                                    else
                                        local fakePetLink =
                                            ColourList.spellChatPetMountLink ..
                                            "\124Hbattlepet:" ..
                                                self.speciesID ..
                                                    ":1:5:1:::BattlePet--:\124h[" .. speciesName .. "]\124h\124r" -- build fake link as unknown pets have no GUID as their stats and rarities can differ
                                        VariableList.currentAddPhraseTextBox:Insert(fakePetLink) -- insert fake link into current text box
                                    end
                                end
                            end
                        end
                    )
                end
                local mountIndex = 0 -- for mount collection
                while true do
                    mountIndex = mountIndex + 1
                    local buttonName = "MountJournalListScrollFrameButton" .. mountIndex -- loop through the displayed pet buttons
                    local button = _G[buttonName]
                    if not button then
                        break
                    end
                    button:HookScript(
                        "OnClick",
                        function(self) -- add a hook to each displayed mount button
                            if IsAltKeyDown() then
                                if not VariableList.currentAddPhraseTextBox then -- make sure we have a text box
                                    return
                                else
                                    VariableList.currentAddPhraseTextBox:Insert(GetSpellLink(self.spellID)) -- insert link into current text box
                                end
                            end
                        end
                    )
                end
            end
        end
    end
)
SpellChatInterfaceFrame:RegisterEvent("PLAYER_LOGIN") -- fires on login or reload
SpellChatInterfaceFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED") -- fires when spell cast is successful
SpellChatInterfaceFrame:RegisterEvent("ADDON_LOADED") -- fires when an addon, (including bliz addons), is loaded
SpellChatInterfaceFrame:Hide()

SpellChatInterfaceFrame.Banner = CreateFrame("Frame", "SpellChatInterfaceFrameBanner", SpellChatInterfaceFrame)
SpellChatInterfaceFrame.Banner:SetSize(NumberList.bannerBoxSize, NumberList.bannerBoxSize)
SpellChatInterfaceFrame.Banner:SetScale(NumberList.bannerScale)
SpellChatInterfaceFrame.Banner:SetPoint("TOP", 0, -50)
SpellChatInterfaceFrame.Banner.Texture = SpellChatInterfaceFrame.Banner:CreateTexture(nil, "BACKGROUND")
SpellChatInterfaceFrame.Banner.Texture:SetPoint("TOP", 0, NumberList.bannerGap)
SpellChatInterfaceFrame.Banner.Texture:SetTexture(ImageList.spellChatBanner)

SpellChatInterfaceFrame.SpellChatBtn1 =
    CreateFrame("Button", "SpellChatInterfaceFrameSpellChatBtn1", SpellChatInterfaceFrame)
SpellChatInterfaceFrame.SpellChatBtn1:SetPoint(
    "TOPLEFT",
    SpellChatInterfaceFrame,
    "TOPLEFT",
    NumberList.navSpellChatButtonGapX,
    -NumberList.navSpellChatButtonGapY
)
SpellChatInterfaceFrame.SpellChatBtn1:SetSize(NumberList.navSpellChatButtonSize, NumberList.navSpellChatButtonSize)
SpellChatInterfaceFrame.SpellChatBtn1:SetNormalTexture(ImageList.spellChatButton)
SpellChatInterfaceFrame.SpellChatBtn1:SetHighlightTexture(ImageList.spellChatButtonH, "BLEND")
SpellChatInterfaceFrame.SpellChatBtn1:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatInterfaceFrameSpellChatBtn1)
    end
)

SpellChatInterfaceFrame.SpellChatBtn2 =
    CreateFrame("Button", "SpellChatInterfaceFrameSpellChatBtn2", SpellChatInterfaceFrame)
SpellChatInterfaceFrame.SpellChatBtn2:SetPoint(
    "TOPRIGHT",
    SpellChatInterfaceFrame,
    "TOPRIGHT",
    -NumberList.navSpellChatButtonGapX,
    -NumberList.navSpellChatButtonGapY
)
SpellChatInterfaceFrame.SpellChatBtn2:SetSize(NumberList.navSpellChatButtonSize, NumberList.navSpellChatButtonSize)
SpellChatInterfaceFrame.SpellChatBtn2:SetNormalTexture(ImageList.spellChatButton)
SpellChatInterfaceFrame.SpellChatBtn2:SetHighlightTexture(ImageList.spellChatButtonH, "BLEND")
SpellChatInterfaceFrame.SpellChatBtn2:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatInterfaceFrameSpellChatBtn2)
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         navigation panel          ===========================
-- ===================================================================================================
-- ===================================================================================================

local SpellChatNavigationPanel = CreateFrame("Frame", "SpellChatNavigationPanel", SpellChatInterfaceFrame)
SpellChatNavigationPanel:SetSize(NumberList.navButtonFrameW, NumberList.navButtonGapW)
SpellChatNavigationPanel:SetPoint("TOP", SpellChatInterfaceFrame, "TOP", 0, NumberList.navButtonFrameTopGap)

SpellChatNavigationPanel.DeathKnightBtn =
    CreateFrame("Button", "SpellChatNavigationPanelDeathKnightBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.DeathKnightBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanel,
    "TOPLEFT",
    NumberList.navFirstButtonGapX,
    0
)
SpellChatNavigationPanel.DeathKnightBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.DeathKnightBtn:SetNormalTexture(ImageList.deathKnightButton)
SpellChatNavigationPanel.DeathKnightBtn:SetHighlightTexture(ImageList.deathKnightButtonH, "BLEND")
SpellChatNavigationPanel.DeathKnightBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelDeathKnightBtn)
    end
)

SpellChatNavigationPanel.DemonHunterBtn =
    CreateFrame("Button", "SpellChatNavigationPanelDemonHunterBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.DemonHunterBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelDeathKnightBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.DemonHunterBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.DemonHunterBtn:SetNormalTexture(ImageList.demonHunterButton)
SpellChatNavigationPanel.DemonHunterBtn:SetHighlightTexture(ImageList.demonHunterButtonH, "BLEND")
SpellChatNavigationPanel.DemonHunterBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelDemonHunterBtn)
    end
)

SpellChatNavigationPanel.DruidBtn = CreateFrame("Button", "SpellChatNavigationPanelDruidBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.DruidBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelDemonHunterBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.DruidBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.DruidBtn:SetNormalTexture(ImageList.druidButton)
SpellChatNavigationPanel.DruidBtn:SetHighlightTexture(ImageList.druidButtonH, "BLEND")
SpellChatNavigationPanel.DruidBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelDruidBtn)
    end
)

SpellChatNavigationPanel.EvokerBtn =
    CreateFrame("Button", "SpellChatNavigationPanelEvokerBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.EvokerBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelDruidBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.EvokerBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.EvokerBtn:SetNormalTexture(ImageList.evokerButton)
SpellChatNavigationPanel.EvokerBtn:SetHighlightTexture(ImageList.evokerButtonH, "BLEND")
SpellChatNavigationPanel.EvokerBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelEvokerBtn)
    end
)

SpellChatNavigationPanel.HunterBtn = CreateFrame("Button", "SpellChatNavigationPanelHunterBtn", SpellChatInterfaceFrame)
SpellChatNavigationPanel.HunterBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelEvokerBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.HunterBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.HunterBtn:SetNormalTexture(ImageList.hunterButton)
SpellChatNavigationPanel.HunterBtn:SetHighlightTexture(ImageList.hunterButtonH, "BLEND")
SpellChatNavigationPanel.HunterBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelHunterBtn)
    end
)

SpellChatNavigationPanel.MageBtn = CreateFrame("Button", "SpellChatNavigationPanelMageBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.MageBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelHunterBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.MageBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.MageBtn:SetNormalTexture(ImageList.mageButton)
SpellChatNavigationPanel.MageBtn:SetHighlightTexture(ImageList.mageButtonH, "BLEND")
SpellChatNavigationPanel.MageBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelMageBtn)
    end
)

SpellChatNavigationPanel.MonkBtn = CreateFrame("Button", "SpellChatNavigationPanelMonkBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.MonkBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelMageBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.MonkBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.MonkBtn:SetNormalTexture(ImageList.monkButton)
SpellChatNavigationPanel.MonkBtn:SetHighlightTexture(ImageList.monkButtonH, "BLEND")
SpellChatNavigationPanel.MonkBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelMonkBtn)
    end
)

SpellChatNavigationPanel.MountBtn = CreateFrame("Button", "SpellChatNavigationPanelMountBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.MountBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelMonkBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.MountBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.MountBtn:SetNormalTexture(ImageList.horseShoeButton)
SpellChatNavigationPanel.MountBtn:SetHighlightTexture(ImageList.horseShoeButtonH, "BLEND")
SpellChatNavigationPanel.MountBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelMountBtn)
    end
)

SpellChatNavigationPanel.HandWaveBtn =
    CreateFrame("Button", "SpellChatNavigationPanelHandWaveBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.HandWaveBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelMountBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.HandWaveBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.HandWaveBtn:SetNormalTexture(ImageList.handButton)
SpellChatNavigationPanel.HandWaveBtn:SetHighlightTexture(ImageList.handButtonH, "BLEND")
SpellChatNavigationPanel.HandWaveBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelHandWaveBtn)
    end
)

SpellChatNavigationPanel.PaladinBtn =
    CreateFrame("Button", "SpellChatNavigationPanelPaladinBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.PaladinBtn:SetPoint("CENTER", SpellChatNavigationPanel, "BOTTOMLEFT", 0, 0)
SpellChatNavigationPanel.PaladinBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.PaladinBtn:SetNormalTexture(ImageList.paladinButton)
SpellChatNavigationPanel.PaladinBtn:SetHighlightTexture(ImageList.paladinButtonH, "BLEND")
SpellChatNavigationPanel.PaladinBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelPaladinBtn)
    end
)

SpellChatNavigationPanel.PriestBtn =
    CreateFrame("Button", "SpellChatNavigationPanelPriestBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.PriestBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelPaladinBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.PriestBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.PriestBtn:SetNormalTexture(ImageList.priestButton)
SpellChatNavigationPanel.PriestBtn:SetHighlightTexture(ImageList.priestButtonH, "BLEND")
SpellChatNavigationPanel.PriestBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelPriestBtn)
    end
)

SpellChatNavigationPanel.RogueBtn = CreateFrame("Button", "SpellChatNavigationPanelRogueBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.RogueBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelPriestBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.RogueBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.RogueBtn:SetNormalTexture(ImageList.rogueButton)
SpellChatNavigationPanel.RogueBtn:SetHighlightTexture(ImageList.rogueButtonH, "BLEND")
SpellChatNavigationPanel.RogueBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelRogueBtn)
    end
)

SpellChatNavigationPanel.ShamanBtn =
    CreateFrame("Button", "SpellChatNavigationPanelShamanBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.ShamanBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelRogueBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.ShamanBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.ShamanBtn:SetNormalTexture(ImageList.shamanButton)
SpellChatNavigationPanel.ShamanBtn:SetHighlightTexture(ImageList.shamanButtonH, "BLEND")
SpellChatNavigationPanel.ShamanBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelShamanBtn)
    end
)

SpellChatNavigationPanel.WarlockBtn =
    CreateFrame("Button", "SpellChatNavigationPanelWarlockBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.WarlockBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelShamanBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.WarlockBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.WarlockBtn:SetNormalTexture(ImageList.warlockButton)
SpellChatNavigationPanel.WarlockBtn:SetHighlightTexture(ImageList.warlockButtonH, "BLEND")
SpellChatNavigationPanel.WarlockBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelWarlockBtn)
    end
)

SpellChatNavigationPanel.WarriorBtn =
    CreateFrame("Button", "SpellChatNavigationPanelWarriorBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.WarriorBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelWarlockBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.WarriorBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.WarriorBtn:SetNormalTexture(ImageList.warriorButton)
SpellChatNavigationPanel.WarriorBtn:SetHighlightTexture(ImageList.warriorButtonH, "BLEND")
SpellChatNavigationPanel.WarriorBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelWarriorBtn)
    end
)

SpellChatNavigationPanel.PetBtn = CreateFrame("Button", "SpellChatNavigationPanelPetBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.PetBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelWarriorBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.PetBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.PetBtn:SetNormalTexture(ImageList.pawButton)
SpellChatNavigationPanel.PetBtn:SetHighlightTexture(ImageList.pawButtonH, "BLEND")
SpellChatNavigationPanel.PetBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelPetBtn)
    end
)

SpellChatNavigationPanel.ItemBtn = CreateFrame("Button", "SpellChatNavigationPanelItemBtn", SpellChatNavigationPanel)
SpellChatNavigationPanel.ItemBtn:SetPoint(
    "CENTER",
    SpellChatNavigationPanelPetBtn,
    "CENTER",
    NumberList.navButtonGapW,
    0
)
SpellChatNavigationPanel.ItemBtn:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
SpellChatNavigationPanel.ItemBtn:SetNormalTexture(ImageList.itemButton)
SpellChatNavigationPanel.ItemBtn:SetHighlightTexture(ImageList.itemButtonH, "BLEND")
SpellChatNavigationPanel.ItemBtn:SetScript(
    "OnClick",
    function()
        toggleButton(SpellChatNavigationPanelItemBtn)
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         SpellChat1 frame         ===========================
-- ===================================================================================================
-- ===================================================================================================

local SpellChatFrame1 = CreateFrame("Frame", "SpellChatFrame1", SpellChatInterfaceFrame, "BackdropTemplate")
SpellChatFrame1:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
SpellChatFrame1:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
SpellChatFrame1:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
SpellChatFrame1:SetBackdropBorderColor(unpack(ColourList.spellChatEdge))

SpellChatFrame1.EnableSpellChatCheckBox =
    CreateFrame("CheckButton", "SpellChatFrameEnableSpellChatCheckBox", SpellChatFrame1, "UICheckButtonTemplate")
SpellChatFrame1.EnableSpellChatCheckBox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
SpellChatFrame1.EnableSpellChatCheckBox:SetPoint(
    "TOPLEFT",
    SpellChatFrame1,
    "TOPLEFT",
    NumberList.checkBoxBigGap,
    -NumberList.checkBoxBigGap
)
SpellChatFrame1.EnableSpellChatCheckBox.text:SetFontObject(TextList.checkBoxFontObject)
SpellChatFrame1.EnableSpellChatCheckBox.text:SetText(TextList.spellChatEnableText)
SpellChatFrame1.EnableSpellChatCheckBox:SetScript(
    "OnClick",
    function()
        if SpellChatOptionsList.spellChatEnabled then
            SpellChatOptionsList.spellChatEnabled = false
            SpellChatFrame1.EnableSpellChatButtonCheckBox:SetEnabled(false)
            SpellChatFrame1.EnableSpellChatSixButtonCheckBox:SetEnabled(false)
            SpellChatFrame1.FeedbackMessagesCheckBox:SetEnabled(false)
        else
            SpellChatOptionsList.spellChatEnabled = true
            SpellChatFrame1.EnableSpellChatButtonCheckBox:SetEnabled(true)
            SpellChatFrame1.EnableSpellChatSixButtonCheckBox:SetEnabled(true)
            SpellChatFrame1.FeedbackMessagesCheckBox:SetEnabled(true)
        end
    end
)

SpellChatFrame1.EnableSpellChatButtonCheckBox =
    CreateFrame("CheckButton", "SpellChatFrameEnableSpellChatButtonCheckBox", SpellChatFrame1, "UICheckButtonTemplate")
SpellChatFrame1.EnableSpellChatButtonCheckBox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
SpellChatFrame1.EnableSpellChatButtonCheckBox:SetPoint(
    "TOP",
    SpellChatFrameEnableSpellChatCheckBox,
    "BOTTOM",
    0,
    -NumberList.checkBoxGap
)
SpellChatFrame1.EnableSpellChatButtonCheckBox.text:SetFontObject(TextList.checkBoxFontObject)
SpellChatFrame1.EnableSpellChatButtonCheckBox.text:SetText(TextList.spellChatButtonText)
SpellChatFrame1.EnableSpellChatButtonCheckBox:SetScript(
    "OnClick",
    function()
        if SpellChatOptionsList.magicButtonEnabled then
            SpellChatOptionsList.magicButtonEnabled = false
            spellChatMagicButton:Hide()
        else
            SpellChatOptionsList.magicButtonEnabled = true
            spellChatMagicButton:Show()
        end
    end
)

SpellChatFrame1.EnableSpellChatSixButtonCheckBox =
    CreateFrame(
    "CheckButton",
    "SpellChatFrameEnableSpellChatSixButtonCheckBox",
    SpellChatFrame1,
    "UICheckButtonTemplate"
)
SpellChatFrame1.EnableSpellChatSixButtonCheckBox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
SpellChatFrame1.EnableSpellChatSixButtonCheckBox:SetPoint(
    "TOP",
    SpellChatFrameEnableSpellChatButtonCheckBox,
    "BOTTOM",
    0,
    -NumberList.checkBoxGap
)
SpellChatFrame1.EnableSpellChatSixButtonCheckBox.text:SetFontObject(TextList.checkBoxFontObject)
SpellChatFrame1.EnableSpellChatSixButtonCheckBox.text:SetText(TextList.sixButtonEnableText)
SpellChatFrame1.EnableSpellChatSixButtonCheckBox:SetScript(
    "OnClick",
    function()
        if SpellChatOptionsList.buttonBoxEnabled then
            SpellChatOptionsList.buttonBoxEnabled = false
            HandWaveButtonGridFrame:Hide()
        else
            SpellChatOptionsList.buttonBoxEnabled = true
            HandWaveButtonGridFrame:Show()
        end
    end
)

SpellChatFrame1.GuildChatButtonsCheckBox =
    CreateFrame("CheckButton", "SpellChatFrame1GuildChatButtonsCheckBox", SpellChatFrame1, "UICheckButtonTemplate")
SpellChatFrame1.GuildChatButtonsCheckBox:SetSize(NumberList.enableCheckBoxSmallSize, NumberList.enableCheckBoxSmallSize)
SpellChatFrame1.GuildChatButtonsCheckBox:SetPoint(
    "TOP",
    SpellChatFrameEnableSpellChatSixButtonCheckBox,
    "BOTTOM",
    15,
    -NumberList.checkBoxSmallGap
)
SpellChatFrame1.GuildChatButtonsCheckBox.text:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.GuildChatButtonsCheckBox.text:SetText(TextList.guildButtonsToggleText)
SpellChatFrame1.GuildChatButtonsCheckBox:SetScript(
    "OnClick",
    function()
        if SpellChatHandButtonList[1].guildButtons then
            SpellChatHandButtonList[1].guildButtons = false
        else
            SpellChatHandButtonList[1].guildButtons = true
        end
        handWaveGridFrameButtonLayout()
    end
)

SpellChatFrame1.GroupChatButtonsCheckBox =
    CreateFrame("CheckButton", "SpellChatFrame1GroupChatButtonsCheckBox", SpellChatFrame1, "UICheckButtonTemplate")
SpellChatFrame1.GroupChatButtonsCheckBox:SetSize(NumberList.enableCheckBoxSmallSize, NumberList.enableCheckBoxSmallSize)
SpellChatFrame1.GroupChatButtonsCheckBox:SetPoint(
    "TOP",
    SpellChatFrame1GuildChatButtonsCheckBox,
    "BOTTOM",
    0,
    -NumberList.checkBoxSmallGap
)
SpellChatFrame1.GroupChatButtonsCheckBox.text:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.GroupChatButtonsCheckBox.text:SetText(TextList.groupButtonsToggleText)
SpellChatFrame1.GroupChatButtonsCheckBox:SetScript(
    "OnClick",
    function()
        if SpellChatHandButtonList[2].groupButtons then
            SpellChatHandButtonList[2].groupButtons = false
        else
            SpellChatHandButtonList[2].groupButtons = true
        end
        handWaveGridFrameButtonLayout()
    end
)

SpellChatFrame1.GeneralChatButtonsCheckBox =
    CreateFrame("CheckButton", "SpellChatFrame1GeneralChatButtonsCheckBox", SpellChatFrame1, "UICheckButtonTemplate")
SpellChatFrame1.GeneralChatButtonsCheckBox:SetSize(
    NumberList.enableCheckBoxSmallSize,
    NumberList.enableCheckBoxSmallSize
)
SpellChatFrame1.GeneralChatButtonsCheckBox:SetPoint(
    "TOP",
    SpellChatFrame1GroupChatButtonsCheckBox,
    "BOTTOM",
    0,
    -NumberList.checkBoxSmallGap
)
SpellChatFrame1.GeneralChatButtonsCheckBox.text:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.GeneralChatButtonsCheckBox.text:SetText(TextList.generalButtonsToggleText)
SpellChatFrame1.GeneralChatButtonsCheckBox:SetScript(
    "OnClick",
    function()
        if SpellChatHandButtonList[3].generalButtons then
            SpellChatHandButtonList[3].generalButtons = false
        else
            SpellChatHandButtonList[3].generalButtons = true
        end
        handWaveGridFrameButtonLayout()
    end
)

SpellChatFrame1.TradeChatButtonsCheckBox =
    CreateFrame("CheckButton", "SpellChatFrame1TradeChatButtonsCheckBox", SpellChatFrame1, "UICheckButtonTemplate")
SpellChatFrame1.TradeChatButtonsCheckBox:SetSize(NumberList.enableCheckBoxSmallSize, NumberList.enableCheckBoxSmallSize)
SpellChatFrame1.TradeChatButtonsCheckBox:SetPoint(
    "TOP",
    SpellChatFrame1GeneralChatButtonsCheckBox,
    "BOTTOM",
    0,
    -NumberList.checkBoxSmallGap
)
SpellChatFrame1.TradeChatButtonsCheckBox.text:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.TradeChatButtonsCheckBox.text:SetText(TextList.tradeLFGButtonsToggleText)
SpellChatFrame1.TradeChatButtonsCheckBox:SetScript(
    "OnClick",
    function()
        if SpellChatHandButtonList[4].tradeLFGButtons then
            SpellChatHandButtonList[4].tradeLFGButtons = false
        else
            SpellChatHandButtonList[4].tradeLFGButtons = true
        end
        handWaveGridFrameButtonLayout()
    end
)

SpellChatFrame1.LFGChatButtonsCheckBox =
    CreateFrame("CheckButton", "SpellChatFrame1LFGChatButtonsCheckBox", SpellChatFrame1, "UICheckButtonTemplate")
SpellChatFrame1.LFGChatButtonsCheckBox:SetSize(NumberList.enableCheckBoxSmallSize, NumberList.enableCheckBoxSmallSize)
SpellChatFrame1.LFGChatButtonsCheckBox:SetPoint(
    "TOP",
    SpellChatFrame1TradeChatButtonsCheckBox,
    "BOTTOM",
    0,
    -NumberList.checkBoxSmallGap
)
SpellChatFrame1.LFGChatButtonsCheckBox.text:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.LFGChatButtonsCheckBox.text:SetText(TextList.sayYellButtonsToggleText)
SpellChatFrame1.LFGChatButtonsCheckBox:SetScript(
    "OnClick",
    function()
        if SpellChatHandButtonList[5].sayYellButtons then
            SpellChatHandButtonList[5].sayYellButtons = false
        else
            SpellChatHandButtonList[5].sayYellButtons = true
        end
        handWaveGridFrameButtonLayout()
    end
)

SpellChatFrame1.FeedbackMessagesCheckBox =
    CreateFrame("CheckButton", "SpellChatFrameErrorMessagesCheckBox", SpellChatFrame1, "UICheckButtonTemplate")
SpellChatFrame1.FeedbackMessagesCheckBox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)

SpellChatFrame1.FeedbackMessagesCheckBox:SetPoint(
    "TOP",
    SpellChatFrame1LFGChatButtonsCheckBox,
    "BOTTOM",
    -NumberList.checkBoxBigGap,
    -NumberList.checkBoxGap
)

SpellChatFrame1.FeedbackMessagesCheckBox.text:SetFontObject(TextList.checkBoxFontObject)
SpellChatFrame1.FeedbackMessagesCheckBox.text:SetText(TextList.allFeedbackMessagesText)
SpellChatFrame1.FeedbackMessagesCheckBox:SetScript(
    "OnClick",
    function()
        if SpellChatOptionsList.errorMessagesEnabled then
            SpellChatOptionsList.errorMessagesEnabled = false
        else
            SpellChatOptionsList.errorMessagesEnabled = true
        end
    end
)

SpellChatFrame1.KeybindsButton =
    CreateFrame(
    "Button",
    "SpellChatFrameKeybindsButton",
    SpellChatFrame1,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
SpellChatFrame1.KeybindsButton:SetSize(NumberList.scrollFrameWidth * 1.1, NumberList.clearTargetListHeight)
SpellChatFrame1.KeybindsButton:SetPoint(
    "TOPRIGHT",
    SpellChatFrame1,
    "TOPRIGHT",
    -NumberList.checkBoxBigGap,
    -NumberList.checkBoxBigGap
)
SpellChatFrame1.KeybindsButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
SpellChatFrame1.KeybindsButton:SetBackdropBorderColor(unpack(ColourList.spellChatEdge))
SpellChatFrame1.KeybindsButton:SetNormalFontObject(TextList.buttonFontObject)
SpellChatFrame1.KeybindsButton:SetHighlightFontObject(TextList.buttonFontObject)
SpellChatFrame1.KeybindsButton:SetText(TextList.keybindButtonText)
SpellChatFrame1.KeybindsButton:SetScript(
    "OnClick",
    function()
        GameMenuButtonKeybindings:Click("RightButton")
        KeyBindingFrame:Show()
        for _, v in pairs(KeyBindingFrame.categoryList.buttons) do
            if v:GetText() == "Walkerbo's Addons" or v:GetText() == "WALKERBO'S ADDONS" then
                v:Click()
            end
        end
    end
)

SpellChatFrame1.SpellChatFrameScaleTextBox =
    CreateFrame("EditBox", "SpellChatFrameSpellChatFrameScaleTextBox", SpellChatFrame1, "ChatConfigBoxTemplate")
SpellChatFrame1.SpellChatFrameScaleTextBox:SetPoint(
    "TOPLEFT",
    SpellChatFrameKeybindsButton,
    "BOTTOMLEFT",
    0,
    -NumberList.scaleTextBoxGap
)
SpellChatFrame1.SpellChatFrameScaleTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.SpellChatFrameScaleTextBox:SetNumeric(true)
SpellChatFrame1.SpellChatFrameScaleTextBox:SetSize(
    NumberList.percentageTextBoxWidth,
    NumberList.percentageTextBoxHeight
)
SpellChatFrame1.SpellChatFrameScaleTextBox:SetMaxLetters(3)
SpellChatFrame1.SpellChatFrameScaleTextBox:SetAutoFocus()
SpellChatFrame1.SpellChatFrameScaleTextBox:SetText("")
SpellChatFrame1.SpellChatFrameScaleTextBox:SetJustifyH("CENTER")
SpellChatFrame1.SpellChatFrameScaleTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        scaleNumber = tonumber(SpellChatFrame1.SpellChatFrameScaleTextBox:GetText())
        self:ClearFocus()
        updateScalePercentage(scaleNumber, "SpellChatFrameScaleTextBox")
    end
)

SpellChatFrame1.SpellChatFrameScaleText = SpellChatFrame1:CreateFontString("SpellChatFrameSpellChatFrameScaleText")
SpellChatFrame1.SpellChatFrameScaleText:SetPoint("LEFT", SpellChatFrameSpellChatFrameScaleTextBox, "RIGHT")
SpellChatFrame1.SpellChatFrameScaleText:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.SpellChatFrameScaleText:SetText(TextList.spellChatUIScaleText)

SpellChatFrame1.MagicButtonScaleTextBox =
    CreateFrame("EditBox", "SpellChatFrameMagicButtonScaleTextBox", SpellChatFrame1, "ChatConfigBoxTemplate")
SpellChatFrame1.MagicButtonScaleTextBox:SetPoint(
    "TOPLEFT",
    SpellChatFrameSpellChatFrameScaleTextBox,
    "BOTTOMLEFT",
    0,
    -NumberList.scaleTextBoxGap
)
SpellChatFrame1.MagicButtonScaleTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.MagicButtonScaleTextBox:SetNumeric(true)
SpellChatFrame1.MagicButtonScaleTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
SpellChatFrame1.MagicButtonScaleTextBox:SetMaxLetters(3)
SpellChatFrame1.MagicButtonScaleTextBox:SetAutoFocus()
SpellChatFrame1.MagicButtonScaleTextBox:SetText("")
SpellChatFrame1.MagicButtonScaleTextBox:SetJustifyH("CENTER")
SpellChatFrame1.MagicButtonScaleTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        scaleNumber = tonumber(SpellChatFrame1.MagicButtonScaleTextBox:GetText())
        self:ClearFocus()
        updateScalePercentage(scaleNumber, "MagicButtonScaleTextBox")
    end
)

SpellChatFrame1.MagicButtonScaleText = SpellChatFrame1:CreateFontString("SpellChatFrameMagicButtonScaleText")
SpellChatFrame1.MagicButtonScaleText:SetPoint("LEFT", SpellChatFrameMagicButtonScaleTextBox, "RIGHT")
SpellChatFrame1.MagicButtonScaleText:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.MagicButtonScaleText:SetText(TextList.spellChatButtonScaleText)

SpellChatFrame1.MagicButtonOpacityTextBox =
    CreateFrame("EditBox", "SpellChatFrameMagicButtonOpacityTextBox", SpellChatFrame1, "ChatConfigBoxTemplate")
SpellChatFrame1.MagicButtonOpacityTextBox:SetPoint(
    "TOPLEFT",
    SpellChatFrameMagicButtonScaleTextBox,
    "BOTTOMLEFT",
    0,
    -NumberList.scaleTextBoxGap
)
SpellChatFrame1.MagicButtonOpacityTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.MagicButtonOpacityTextBox:SetNumeric(true)
SpellChatFrame1.MagicButtonOpacityTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
SpellChatFrame1.MagicButtonOpacityTextBox:SetMaxLetters(3)
SpellChatFrame1.MagicButtonOpacityTextBox:SetAutoFocus()
SpellChatFrame1.MagicButtonOpacityTextBox:SetText("")
SpellChatFrame1.MagicButtonOpacityTextBox:SetJustifyH("CENTER")
SpellChatFrame1.MagicButtonOpacityTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        opacityNumber = tonumber(SpellChatFrame1.MagicButtonOpacityTextBox:GetText())
        self:ClearFocus()
        updateOpacityPercentage(opacityNumber, "MagicButtonOpacityTextBox")
    end
)

SpellChatFrame1.MagicButtonOpacityText = SpellChatFrame1:CreateFontString("SpellChatFrameMagicButtonOpacityText")
SpellChatFrame1.MagicButtonOpacityText:SetPoint("LEFT", SpellChatFrameMagicButtonOpacityTextBox, "RIGHT")
SpellChatFrame1.MagicButtonOpacityText:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.MagicButtonOpacityText:SetText(TextList.spellChatButtonOpacityText)

SpellChatFrame1.ButtonGridScaleTextBox =
    CreateFrame("EditBox", "SpellChatFrameButtonGridScaleTextBox", SpellChatFrame1, "ChatConfigBoxTemplate")
SpellChatFrame1.ButtonGridScaleTextBox:SetPoint(
    "TOPLEFT",
    SpellChatFrameMagicButtonOpacityTextBox,
    "BOTTOMLEFT",
    0,
    -NumberList.scaleTextBoxGap
)
SpellChatFrame1.ButtonGridScaleTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.ButtonGridScaleTextBox:SetNumeric(true)
SpellChatFrame1.ButtonGridScaleTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
SpellChatFrame1.ButtonGridScaleTextBox:SetMaxLetters(3)
SpellChatFrame1.ButtonGridScaleTextBox:SetAutoFocus()
SpellChatFrame1.ButtonGridScaleTextBox:SetText("")
SpellChatFrame1.ButtonGridScaleTextBox:SetJustifyH("CENTER")
SpellChatFrame1.ButtonGridScaleTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        scaleNumber = tonumber(SpellChatFrame1.ButtonGridScaleTextBox:GetText())
        self:ClearFocus()
        updateScalePercentage(scaleNumber, "ButtonGridScaleTextBox")
    end
)

SpellChatFrame1.ButtonGridScaleText = SpellChatFrame1:CreateFontString("SpellChatFrameButtonGridScaleText")
SpellChatFrame1.ButtonGridScaleText:SetPoint("LEFT", SpellChatFrameButtonGridScaleTextBox, "RIGHT")
SpellChatFrame1.ButtonGridScaleText:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.ButtonGridScaleText:SetText(TextList.spellChatButtonGridScaleText)

SpellChatFrame1.ButtonGridOpacityTextBox =
    CreateFrame("EditBox", "SpellChatFrameButtonGridOpacityTextBox", SpellChatFrame1, "ChatConfigBoxTemplate")
SpellChatFrame1.ButtonGridOpacityTextBox:SetPoint(
    "TOPLEFT",
    SpellChatFrameButtonGridScaleTextBox,
    "BOTTOMLEFT",
    0,
    -NumberList.scaleTextBoxGap
)
SpellChatFrame1.ButtonGridOpacityTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.ButtonGridOpacityTextBox:SetNumeric(true)
SpellChatFrame1.ButtonGridOpacityTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
SpellChatFrame1.ButtonGridOpacityTextBox:SetMaxLetters(3)
SpellChatFrame1.ButtonGridOpacityTextBox:SetAutoFocus()
SpellChatFrame1.ButtonGridOpacityTextBox:SetText("")
SpellChatFrame1.ButtonGridOpacityTextBox:SetJustifyH("CENTER")
SpellChatFrame1.ButtonGridOpacityTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        opacityNumber = tonumber(SpellChatFrame1.ButtonGridOpacityTextBox:GetText())
        self:ClearFocus()
        updateOpacityPercentage(opacityNumber, "ButtonGridOpacityTextBox")
    end
)

SpellChatFrame1.ButtonGridOpacityText = SpellChatFrame1:CreateFontString("SpellChatFrameButtonGridOpacityText")
SpellChatFrame1.ButtonGridOpacityText:SetPoint("LEFT", SpellChatFrameButtonGridOpacityTextBox, "RIGHT")
SpellChatFrame1.ButtonGridOpacityText:SetFontObject(TextList.checkBoxSmallFontObject)
SpellChatFrame1.ButtonGridOpacityText:SetText(TextList.spellChatButtonGridOpacityText)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         SpellChat2 frame         ===========================
-- ===================================================================================================
-- ===================================================================================================

local SpellChatFrame2 = CreateFrame("Frame", "SpellChatFrame2", SpellChatInterfaceFrame, "BackdropTemplate")
SpellChatFrame2:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
SpellChatFrame2:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
SpellChatFrame2:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
SpellChatFrame2:SetBackdropBorderColor(unpack(ColourList.spellChatEdge))

SpellChatFrame2.ClickInfoBox1 = CreateFrame("Frame", "SpellChatFrame2.ClickInfoBox1", SpellChatFrame2)
SpellChatFrame2.ClickInfoBox1:SetSize(NumberList.classFrameWidth, NumberList.slashCommandHeight * 2)
SpellChatFrame2.ClickInfoBox1:SetPoint(
    "TOPLEFT",
    SpellChatFrame2,
    "TOPLEFT",
    NumberList.checkBoxBigGap,
    -NumberList.checkBoxBigGap
)

SpellChatFrame2.ClickInfoBox1.Text = SpellChatFrame2.ClickInfoBox1:CreateFontString("SpellChatFrame2ClickInfoBox1Text")
SpellChatFrame2.ClickInfoBox1.Text:SetAllPoints(SpellChatFrame2.ClickInfoBox1)
SpellChatFrame2.ClickInfoBox1.Text:SetJustifyV("TOP")
SpellChatFrame2.ClickInfoBox1.Text:SetJustifyH("LEFT")
SpellChatFrame2.ClickInfoBox1.Text:SetFontObject(TextList.slashCommandFontObject)
SpellChatFrame2.ClickInfoBox1.Text:SetText(TextList.buttonClickText)

SpellChatFrame2.SlashCommandsBox1 = CreateFrame("Frame", "SpellChatFrameSlashCommandsBox1", SpellChatFrame2)
SpellChatFrame2.SlashCommandsBox1:SetSize(NumberList.slashCommandWidth, NumberList.slashCommandHeight)
SpellChatFrame2.SlashCommandsBox1:SetPoint(
    "BOTTOMLEFT",
    SpellChatFrame2,
    "BOTTOMLEFT",
    NumberList.checkBoxBigGap,
    NumberList.checkBoxBigGap
)

SpellChatFrame2.SlashCommandsBox1.Text =
    SpellChatFrame2.SlashCommandsBox1:CreateFontString("SpellChatFrameSlashCommandsBox1Text")
SpellChatFrame2.SlashCommandsBox1.Text:SetAllPoints(SpellChatFrameSlashCommandsBox1)
SpellChatFrame2.SlashCommandsBox1.Text:SetJustifyV("BOTTOM")
SpellChatFrame2.SlashCommandsBox1.Text:SetJustifyH("LEFT")
SpellChatFrame2.SlashCommandsBox1.Text:SetFontObject(TextList.slashCommandFontObject)
SpellChatFrame2.SlashCommandsBox1.Text:SetText(TextList.slashCommandText1)

SpellChatFrame2.SlashCommandsBox2 = CreateFrame("Frame", "SpellChatFrameSlashCommandsBox2", SpellChatFrame2)
SpellChatFrame2.SlashCommandsBox2:SetSize(NumberList.slashCommandWidth, NumberList.slashCommandHeight)
SpellChatFrame2.SlashCommandsBox2:SetPoint("LEFT", SpellChatFrameSlashCommandsBox1, "RIGHT")

SpellChatFrame2.SlashCommandsBox2.Text =
    SpellChatFrame2.SlashCommandsBox2:CreateFontString("SpellChatFrameSlashCommandsBox2Text")
SpellChatFrame2.SlashCommandsBox2.Text:SetAllPoints(SpellChatFrameSlashCommandsBox2)
SpellChatFrame2.SlashCommandsBox2.Text:SetJustifyV("BOTTOM")
SpellChatFrame2.SlashCommandsBox2.Text:SetJustifyH("LEFT")
SpellChatFrame2.SlashCommandsBox2.Text:SetFontObject(TextList.slashCommandFontObject)
SpellChatFrame2.SlashCommandsBox2.Text:SetText(TextList.slashCommandText2)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         DeathKnight class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local DeathKnightSpellChatFrame =
    CreateFrame("Frame", "DeathKnightSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
DeathKnightSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
DeathKnightSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
DeathKnightSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DeathKnightSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.deathKnightEdge))

DeathKnightSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "DeathKnightSpellChatFrameAddSpellButton",
    DeathKnightSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
DeathKnightSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
DeathKnightSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", DeathKnightSpellChatFrame, "TOPLEFT", 9, -10)
DeathKnightSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DeathKnightSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.deathKnightEdge))
DeathKnightSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
DeathKnightSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
DeathKnightSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
DeathKnightSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
DeathKnightSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local DeathKnightSpellScrollParent =
    CreateFrame(
    "Button",
    "DeathKnightSpellScrollParent",
    DeathKnightSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
DeathKnightSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DeathKnightSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.deathKnightEdge))
DeathKnightSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
DeathKnightSpellScrollParent:SetPoint("TOP", DeathKnightSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local DeathKnightSpellScrollFrame =
    CreateFrame("ScrollFrame", "DeathKnightSpellScrollFrame", DeathKnightSpellScrollParent, "FauxScrollFrameTemplate")
DeathKnightSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
DeathKnightSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
DeathKnightSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemScrollButtonHeight,
            updateDeathKnightSpellList
        )
    end
)

DeathKnightSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    DeathKnightSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, DeathKnightSpellScrollParent, "OptionsListButtonTemplate")
    local button = DeathKnightSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = DeathKnightSpellList
            VariableList.currentClassSpellLink = DeathKnightSpellList[self.index].spellLink
            VariableList.currentClassSpellID = DeathKnightSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = DeathKnightSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = DeathKnightSpellList[self.index].isEnabled
            loadSpellHeader()
            updateDeathKnightSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(DeathKnightSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

DeathKnightSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "DeathKnightClearSpellListButton",
    DeathKnightSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
DeathKnightSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
DeathKnightSpellChatFrame.ClearSpellListButton:SetPoint("TOP", DeathKnightSpellScrollParent, "BOTTOM", 0, -4)
DeathKnightSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DeathKnightSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.deathKnightEdge))
DeathKnightSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
DeathKnightSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
DeathKnightSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
DeathKnightSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
DeathKnightSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(DeathKnightSpellList)
        clearCurrentClassSpell()
        updateDeathKnightSpellList()
        updateDeathKnightSpellChatList()
        DeathKnightSpellChatFrame.AddPhraseTextBox:SetText("")
        DeathKnightSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

DeathKnightSpellChatFrame.ChatParent =
    CreateFrame("Frame", "DeathKnightSpellChatFrameChatParent", DeathKnightSpellChatFrame)
DeathKnightSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
DeathKnightSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", DeathKnightSpellChatFrame, "TOPRIGHT", -9, -10)
DeathKnightSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "DeathKnightSpellChatFrameChatHeader", DeathKnightSpellChatFrameChatParent, "BackdropTemplate")
DeathKnightSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DeathKnightSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.deathKnightEdge))
DeathKnightSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
DeathKnightSpellChatFrame.ChatHeader:SetPoint("TOP", DeathKnightSpellChatFrameChatParent)
DeathKnightSpellChatFrame.TitleText = DeathKnightSpellChatFrame:CreateFontString("MyTestFrameTitleText")
DeathKnightSpellChatFrame.TitleText:SetPoint("TOPLEFT", DeathKnightSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
DeathKnightSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
DeathKnightSpellChatFrame.TitleText:SetText("")

DeathKnightSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "DeathKnightSpellChatFrameDeleteSpellButton", DeathKnightSpellChatFrameChatHeader)
DeathKnightSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", DeathKnightSpellChatFrameChatHeader, "RIGHT", -10, 0)
DeathKnightSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
DeathKnightSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
DeathKnightSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
DeathKnightSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateDeathKnightSpellList()
        updateDeathKnightSpellChatList()
        DeathKnightSpellChatFrame.AddPhraseTextBox:SetText("")
        DeathKnightSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

DeathKnightSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "DeathKnightSpellChatFramePercentageTextBox",
    DeathKnightSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
DeathKnightSpellChatFrame.PercentageTextBox:SetPoint(
    "BOTTOMLEFT",
    DeathKnightSpellChatFrameChatHeader,
    "BOTTOMLEFT",
    10,
    5
)
DeathKnightSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
DeathKnightSpellChatFrame.PercentageTextBox:SetNumeric(true)
DeathKnightSpellChatFrame.PercentageTextBox:SetSize(
    NumberList.percentageTextBoxWidth,
    NumberList.percentageTextBoxHeight
)
DeathKnightSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
DeathKnightSpellChatFrame.PercentageTextBox:SetAutoFocus()
DeathKnightSpellChatFrame.PercentageTextBox:SetText("")
DeathKnightSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
DeathKnightSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(DeathKnightSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

DeathKnightSpellChatFrame.PercentageText =
    DeathKnightSpellChatFrame:CreateFontString("DeathKnightSpellChatFramePercentageText")
DeathKnightSpellChatFrame.PercentageText:SetPoint("LEFT", DeathKnightSpellChatFramePercentageTextBox, "RIGHT")
DeathKnightSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
DeathKnightSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

DeathKnightSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "DeathKnightSpellChatFrameEnableCheckbox",
    DeathKnightSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
DeathKnightSpellChatFrame.EnableCheckbox:ClearAllPoints()
DeathKnightSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    DeathKnightSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
DeathKnightSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
DeathKnightSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
DeathKnightSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
DeathKnightSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
DeathKnightSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)
--]]
DeathKnightSpellChatFrame.AddChatHeader =
    CreateFrame(
    "Frame",
    "DeathKnightSpellChatFrameAddChatHeader",
    DeathKnightSpellChatFrameChatParent,
    "BackdropTemplate"
)
DeathKnightSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DeathKnightSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.deathKnightEdge))
DeathKnightSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, 31)
DeathKnightSpellChatFrame.AddChatHeader:SetPoint("TOP", DeathKnightSpellChatFrameChatHeader, "BOTTOM", 0, -5)

DeathKnightSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "DeathKnightSpellChatFrameAddPhraseTextBox", DeathKnightSpellChatFrameAddChatHeader)
DeathKnightSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", DeathKnightSpellChatFrameAddChatHeader, "LEFT", 10, 0)
DeathKnightSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
DeathKnightSpellChatFrame.AddPhraseTextBox:SetSize(NumberList.scrollSpellFrameWidth - 40, 25)
DeathKnightSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
DeathKnightSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
DeathKnightSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
DeathKnightSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                DeathKnightSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                DeathKnightSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                DeathKnightSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
DeathKnightSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                DeathKnightSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                DeathKnightSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                DeathKnightSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
DeathKnightSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = DeathKnightSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateDeathKnightSpellChatList()
            DeathKnightSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local DeathKnightChatScrollParent =
    CreateFrame("Frame", "DeathKnightChatScrollParent", DeathKnightSpellChatFrameChatParent, "BackdropTemplate")
DeathKnightChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DeathKnightChatScrollParent:SetBackdropBorderColor(unpack(ColourList.deathKnightEdge))
DeathKnightChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
DeathKnightChatScrollParent:SetPoint("TOP", DeathKnightSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local DeathKnightChatScrollFrame =
    CreateFrame("ScrollFrame", "DeathKnightChatScrollFrame", DeathKnightChatScrollParent, "FauxScrollFrameTemplate")
DeathKnightChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
DeathKnightChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
DeathKnightChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateDeathKnightSpellChatList
        )
    end
)

DeathKnightChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    DeathKnightChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, DeathKnightChatScrollParent, "OptionsListButtonTemplate")
    local button = DeathKnightChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateDeathKnightSpellChatList()
            end
        end
    )
end

DeathKnightSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "DeathKnightSpellChatFrameClearChatListButton",
    DeathKnightSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
DeathKnightSpellChatFrame.ClearChatListButton:SetSize(
    NumberList.scrollSpellFrameWidth,
    NumberList.clearTargetListHeight
)
DeathKnightSpellChatFrame.ClearChatListButton:SetPoint("TOP", DeathKnightChatScrollParent, "BOTTOM", 0, -4)
DeathKnightSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DeathKnightSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.deathKnightEdge))
DeathKnightSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
DeathKnightSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
DeathKnightSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
DeathKnightSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
DeathKnightSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateDeathKnightSpellChatList()
        DeathKnightSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         DemonHunter class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local DemonHunterSpellChatFrame =
    CreateFrame("Frame", "DemonHunterSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
DemonHunterSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
DemonHunterSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
DemonHunterSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DemonHunterSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.demonHunterEdge))

DemonHunterSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "DemonHunterSpellChatFrameAddSpellButton",
    DemonHunterSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
DemonHunterSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
DemonHunterSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", DemonHunterSpellChatFrame, "TOPLEFT", 9, -10)
DemonHunterSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DemonHunterSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.demonHunterEdge))
DemonHunterSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
DemonHunterSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
DemonHunterSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
DemonHunterSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
DemonHunterSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local DemonHunterSpellScrollParent =
    CreateFrame(
    "Button",
    "DemonHunterSpellScrollParent",
    DemonHunterSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
DemonHunterSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DemonHunterSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.demonHunterEdge))
DemonHunterSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
DemonHunterSpellScrollParent:SetPoint("TOP", DemonHunterSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local DemonHunterSpellScrollFrame =
    CreateFrame("ScrollFrame", "DemonHunterSpellScrollFrame", DemonHunterSpellScrollParent, "FauxScrollFrameTemplate")
DemonHunterSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
DemonHunterSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
DemonHunterSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemScrollButtonHeight,
            updateDemonHunterSpellList
        )
    end
)

DemonHunterSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    DemonHunterSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, DemonHunterSpellScrollParent, "OptionsListButtonTemplate")
    local button = DemonHunterSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = DemonHunterSpellList
            VariableList.currentClassSpellLink = DemonHunterSpellList[self.index].spellLink
            VariableList.currentClassSpellID = DemonHunterSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = DemonHunterSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = DemonHunterSpellList[self.index].isEnabled
            loadSpellHeader()
            updateDemonHunterSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(DemonHunterSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

DemonHunterSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "DemonHunterSpellChatFrameClearSpellListButton",
    DemonHunterSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
DemonHunterSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
DemonHunterSpellChatFrame.ClearSpellListButton:SetPoint("TOP", DemonHunterSpellScrollParent, "BOTTOM", 0, -4)
DemonHunterSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DemonHunterSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.demonHunterEdge))
DemonHunterSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
DemonHunterSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
DemonHunterSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
DemonHunterSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
DemonHunterSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(DemonHunterSpellList)
        clearCurrentClassSpell()
        updateDemonHunterSpellList()
        updateDemonHunterSpellChatList()
        DemonHunterSpellChatFrame.AddPhraseTextBox:SetText("")
        DemonHunterSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

DemonHunterSpellChatFrame.ChatParent =
    CreateFrame("Frame", "DemonHunterSpellChatFrameChatParent", DemonHunterSpellChatFrame)
DemonHunterSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
DemonHunterSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", DemonHunterSpellChatFrame, "TOPRIGHT", -9, -10)
DemonHunterSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "DemonHunterSpellChatFrameChatHeader", DemonHunterSpellChatFrameChatParent, "BackdropTemplate")
DemonHunterSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DemonHunterSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.demonHunterEdge))
DemonHunterSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
DemonHunterSpellChatFrame.ChatHeader:SetPoint("TOP", DemonHunterSpellChatFrameChatParent)
DemonHunterSpellChatFrame.TitleText = DemonHunterSpellChatFrame:CreateFontString("MyTestFrameTitleText")
DemonHunterSpellChatFrame.TitleText:SetPoint("TOPLEFT", DemonHunterSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
DemonHunterSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
DemonHunterSpellChatFrame.TitleText:SetText("")

DemonHunterSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "DemonHunterSpellChatFrameDeleteSpellButton", DemonHunterSpellChatFrameChatHeader)
DemonHunterSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", DemonHunterSpellChatFrameChatHeader, "RIGHT", -10, 0)
DemonHunterSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
DemonHunterSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
DemonHunterSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
DemonHunterSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateDemonHunterSpellList()
        updateDemonHunterSpellChatList()
        DemonHunterSpellChatFrame.AddPhraseTextBox:SetText("")
        DemonHunterSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

DemonHunterSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "DemonHunterSpellChatFramePercentageTextBox",
    DemonHunterSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
DemonHunterSpellChatFrame.PercentageTextBox:SetPoint(
    "BOTTOMLEFT",
    DemonHunterSpellChatFrameChatHeader,
    "BOTTOMLEFT",
    10,
    5
)
DemonHunterSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
DemonHunterSpellChatFrame.PercentageTextBox:SetNumeric(true)
DemonHunterSpellChatFrame.PercentageTextBox:SetSize(
    NumberList.percentageTextBoxWidth,
    NumberList.percentageTextBoxHeight
)
DemonHunterSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
DemonHunterSpellChatFrame.PercentageTextBox:SetAutoFocus()
DemonHunterSpellChatFrame.PercentageTextBox:SetText("")
DemonHunterSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
DemonHunterSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(DemonHunterSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

DemonHunterSpellChatFrame.PercentageText =
    DemonHunterSpellChatFrame:CreateFontString("DemonHunterSpellChatFramePercentageText")
DemonHunterSpellChatFrame.PercentageText:SetPoint("LEFT", DemonHunterSpellChatFramePercentageTextBox, "RIGHT")
DemonHunterSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
DemonHunterSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

DemonHunterSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "DemonHunterSpellChatFrameEnableCheckbox",
    DemonHunterSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
DemonHunterSpellChatFrame.EnableCheckbox:ClearAllPoints()
DemonHunterSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    DemonHunterSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
DemonHunterSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
DemonHunterSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
DemonHunterSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
DemonHunterSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
DemonHunterSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

DemonHunterSpellChatFrame.AddChatHeader =
    CreateFrame(
    "Frame",
    "DemonHunterSpellChatFrameAddChatHeader",
    DemonHunterSpellChatFrameChatParent,
    "BackdropTemplate"
)
DemonHunterSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DemonHunterSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.demonHunterEdge))
DemonHunterSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
DemonHunterSpellChatFrame.AddChatHeader:SetPoint("TOP", DemonHunterSpellChatFrameChatHeader, "BOTTOM", 0, -5)

DemonHunterSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "DemonHunterSpellChatFrameAddPhraseTextBox", DemonHunterSpellChatFrameAddChatHeader)
DemonHunterSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", DemonHunterSpellChatFrameAddChatHeader, "LEFT", 10, 0)
DemonHunterSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
DemonHunterSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
DemonHunterSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
DemonHunterSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
DemonHunterSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
DemonHunterSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                DemonHunterSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                DemonHunterSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                DemonHunterSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
DemonHunterSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                DemonHunterSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                DemonHunterSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                DemonHunterSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
DemonHunterSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = DemonHunterSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateDemonHunterSpellChatList()
            DemonHunterSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local DemonHunterChatScrollParent =
    CreateFrame("Frame", "DemonHunterChatScrollParent", DemonHunterSpellChatFrameChatParent, "BackdropTemplate")
DemonHunterChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DemonHunterChatScrollParent:SetBackdropBorderColor(unpack(ColourList.demonHunterEdge))
DemonHunterChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
DemonHunterChatScrollParent:SetPoint("TOP", DemonHunterSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local DemonHunterChatScrollFrame =
    CreateFrame("ScrollFrame", "DemonHunterChatScrollFrame", DemonHunterChatScrollParent, "FauxScrollFrameTemplate")
DemonHunterChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
DemonHunterChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
DemonHunterChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateDemonHunterSpellChatList
        )
    end
)

DemonHunterChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    DemonHunterChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, DemonHunterChatScrollParent, "OptionsListButtonTemplate")
    local button = DemonHunterChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateDemonHunterSpellChatList()
            end
        end
    )
end

DemonHunterSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "DemonHunterSpellChatFrameClearChatListButton",
    DemonHunterSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
DemonHunterSpellChatFrame.ClearChatListButton:SetSize(
    NumberList.scrollSpellFrameWidth,
    NumberList.clearTargetListHeight
)
DemonHunterSpellChatFrame.ClearChatListButton:SetPoint("TOP", DemonHunterChatScrollParent, "BOTTOM", 0, -4)
DemonHunterSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DemonHunterSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.demonHunterEdge))
DemonHunterSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
DemonHunterSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
DemonHunterSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
DemonHunterSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
DemonHunterSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateDemonHunterSpellChatList()
        DemonHunterSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Druid class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local DruidSpellChatFrame = CreateFrame("Frame", "DruidSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
DruidSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
DruidSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
DruidSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DruidSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.druidEdge))

DruidSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "DruidSpellChatFrameAddSpellButton",
    DruidSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
DruidSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
DruidSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", DruidSpellChatFrame, "TOPLEFT", 9, -10)
DruidSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DruidSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.druidEdge))
DruidSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
DruidSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
DruidSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
DruidSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
DruidSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local DruidSpellScrollParent =
    CreateFrame(
    "Button",
    "DruidSpellScrollParent",
    DruidSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
DruidSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DruidSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.druidEdge))
DruidSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
DruidSpellScrollParent:SetPoint("TOP", DruidSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local DruidSpellScrollFrame =
    CreateFrame("ScrollFrame", "DruidSpellScrollFrame", DruidSpellScrollParent, "FauxScrollFrameTemplate")
DruidSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
DruidSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
DruidSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateDruidSpellList)
    end
)

DruidSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    DruidSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, DruidSpellScrollParent, "OptionsListButtonTemplate")
    local button = DruidSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = DruidSpellList
            VariableList.currentClassSpellLink = DruidSpellList[self.index].spellLink
            VariableList.currentClassSpellID = DruidSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = DruidSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = DruidSpellList[self.index].isEnabled
            loadSpellHeader()
            updateDruidSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(DruidSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

DruidSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "DruidSpellChatFrameClearSpellListButton",
    DruidSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
DruidSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
DruidSpellChatFrame.ClearSpellListButton:SetPoint("TOP", DruidSpellScrollParent, "BOTTOM", 0, -4)
DruidSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DruidSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.druidEdge))
DruidSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
DruidSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
DruidSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
DruidSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
DruidSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(DruidSpellList)
        clearCurrentClassSpell()
        updateDruidSpellList()
        updateDruidSpellChatList()
        DruidSpellChatFrame.AddPhraseTextBox:SetText("")
        DruidSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

DruidSpellChatFrame.ChatParent = CreateFrame("Frame", "DruidSpellChatFrameChatParent", DruidSpellChatFrame)
DruidSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
DruidSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", DruidSpellChatFrame, "TOPRIGHT", -9, -10)
DruidSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "DruidSpellChatFrameChatHeader", DruidSpellChatFrameChatParent, "BackdropTemplate")
DruidSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DruidSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.druidEdge))
DruidSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
DruidSpellChatFrame.ChatHeader:SetPoint("TOP", DruidSpellChatFrameChatParent)
DruidSpellChatFrame.TitleText = DruidSpellChatFrame:CreateFontString("MyTestFrameTitleText")
DruidSpellChatFrame.TitleText:SetPoint("TOPLEFT", DruidSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
DruidSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
DruidSpellChatFrame.TitleText:SetText("")

DruidSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "DruidSpellChatFrameDeleteSpellButton", DruidSpellChatFrameChatHeader)
DruidSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", DruidSpellChatFrameChatHeader, "RIGHT", -10, 0)
DruidSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
DruidSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
DruidSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
DruidSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateDruidSpellList()
        updateDruidSpellChatList()
        DruidSpellChatFrame.AddPhraseTextBox:SetText("")
        DruidSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

DruidSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "DruidSpellChatFramePercentageTextBox",
    DruidSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
DruidSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", DruidSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
DruidSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
DruidSpellChatFrame.PercentageTextBox:SetNumeric(true)
DruidSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
DruidSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
DruidSpellChatFrame.PercentageTextBox:SetAutoFocus()
DruidSpellChatFrame.PercentageTextBox:SetText("")
DruidSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
DruidSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(DruidSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

DruidSpellChatFrame.PercentageText = DruidSpellChatFrame:CreateFontString("DruidSpellChatFramePercentageText")
DruidSpellChatFrame.PercentageText:SetPoint("LEFT", DruidSpellChatFramePercentageTextBox, "RIGHT")
DruidSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
DruidSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

DruidSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "DruidSpellChatFrameEnableCheckbox",
    DruidSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
DruidSpellChatFrame.EnableCheckbox:ClearAllPoints()
DruidSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    DruidSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
DruidSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
DruidSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
DruidSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
DruidSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
DruidSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

DruidSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "DruidSpellChatFrameAddChatHeader", DruidSpellChatFrameChatParent, "BackdropTemplate")
DruidSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DruidSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.druidEdge))
DruidSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
DruidSpellChatFrame.AddChatHeader:SetPoint("TOP", DruidSpellChatFrameChatHeader, "BOTTOM", 0, -5)

DruidSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "DruidSpellChatFrameAddPhraseTextBox", DruidSpellChatFrameAddChatHeader)
DruidSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", DruidSpellChatFrameAddChatHeader, "LEFT", 10, 0)
DruidSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
DruidSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
DruidSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
DruidSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
DruidSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
DruidSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                DruidSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                DruidSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                DruidSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
DruidSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                DruidSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                DruidSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                DruidSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
DruidSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = DruidSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateDruidSpellChatList()
            DruidSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local DruidChatScrollParent =
    CreateFrame("Frame", "DruidChatScrollParent", DruidSpellChatFrameChatParent, "BackdropTemplate")
DruidChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DruidChatScrollParent:SetBackdropBorderColor(unpack(ColourList.druidEdge))
DruidChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
DruidChatScrollParent:SetPoint("TOP", DruidSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local DruidChatScrollFrame =
    CreateFrame("ScrollFrame", "DruidChatScrollFrame", DruidChatScrollParent, "FauxScrollFrameTemplate")
DruidChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
DruidChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
DruidChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateDruidSpellChatList
        )
    end
)

DruidChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    DruidChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, DruidChatScrollParent, "OptionsListButtonTemplate")
    local button = DruidChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateDruidSpellChatList()
            end
        end
    )
end

DruidSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "DruidSpellChatFrameClearChatListButton",
    DruidSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
DruidSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
DruidSpellChatFrame.ClearChatListButton:SetPoint("TOP", DruidChatScrollParent, "BOTTOM", 0, -4)
DruidSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
DruidSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.druidEdge))
DruidSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
DruidSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
DruidSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
DruidSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
DruidSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateDruidSpellChatList()
        DruidSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Evoker class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local EvokerSpellChatFrame = CreateFrame("Frame", "EvokerSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
EvokerSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
EvokerSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
EvokerSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
EvokerSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.evokerEdge))

EvokerSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "EvokerSpellChatFrameAddSpellButton",
    EvokerSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
EvokerSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
EvokerSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", EvokerSpellChatFrame, "TOPLEFT", 9, -10)
EvokerSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
EvokerSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.evokerEdge))
EvokerSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
EvokerSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
EvokerSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
EvokerSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
EvokerSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local EvokerSpellScrollParent =
    CreateFrame(
    "Button",
    "EvokerSpellScrollParent",
    EvokerSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
EvokerSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
EvokerSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.evokerEdge))
EvokerSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
EvokerSpellScrollParent:SetPoint("TOP", EvokerSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local EvokerSpellScrollFrame =
    CreateFrame("ScrollFrame", "EvokerSpellScrollFrame", EvokerSpellScrollParent, "FauxScrollFrameTemplate")
EvokerSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
EvokerSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
EvokerSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateEvokerSpellList)
    end
)

EvokerSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    EvokerSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, EvokerSpellScrollParent, "OptionsListButtonTemplate")
    local button = EvokerSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = EvokerSpellList
            VariableList.currentClassSpellLink = EvokerSpellList[self.index].spellLink
            VariableList.currentClassSpellID = EvokerSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = EvokerSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = EvokerSpellList[self.index].isEnabled
            loadSpellHeader()
            updateEvokerSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(EvokerSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

EvokerSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "EvokerSpellChatFrameClearSpellListButton",
    EvokerSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
EvokerSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
EvokerSpellChatFrame.ClearSpellListButton:SetPoint("TOP", EvokerSpellScrollParent, "BOTTOM", 0, -4)
EvokerSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
EvokerSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.evokerEdge))
EvokerSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
EvokerSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
EvokerSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
EvokerSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
EvokerSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(EvokerSpellList)
        clearCurrentClassSpell()
        updateEvokerSpellList()
        updateEvokerSpellChatList()
        EvokerSpellChatFrame.AddPhraseTextBox:SetText("")
        EvokerSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

EvokerSpellChatFrame.ChatParent = CreateFrame("Frame", "EvokerSpellChatFrameChatParent", EvokerSpellChatFrame)
EvokerSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
EvokerSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", EvokerSpellChatFrame, "TOPRIGHT", -9, -10)
EvokerSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "EvokerSpellChatFrameChatHeader", EvokerSpellChatFrameChatParent, "BackdropTemplate")
EvokerSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
EvokerSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.evokerEdge))
EvokerSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
EvokerSpellChatFrame.ChatHeader:SetPoint("TOP", EvokerSpellChatFrameChatParent)
EvokerSpellChatFrame.TitleText = EvokerSpellChatFrame:CreateFontString("MyTestFrameTitleText")
EvokerSpellChatFrame.TitleText:SetPoint("TOPLEFT", EvokerSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
EvokerSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
EvokerSpellChatFrame.TitleText:SetText("")

EvokerSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "EvokerSpellChatFrameDeleteSpellButton", EvokerSpellChatFrameChatHeader)
EvokerSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", EvokerSpellChatFrameChatHeader, "RIGHT", -10, 0)
EvokerSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
EvokerSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
EvokerSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
EvokerSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateEvokerSpellList()
        updateEvokerSpellChatList()
        EvokerSpellChatFrame.AddPhraseTextBox:SetText("")
        EvokerSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

EvokerSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "EvokerSpellChatFramePercentageTextBox",
    EvokerSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
EvokerSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", EvokerSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
EvokerSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
EvokerSpellChatFrame.PercentageTextBox:SetNumeric(true)
EvokerSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
EvokerSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
EvokerSpellChatFrame.PercentageTextBox:SetAutoFocus()
EvokerSpellChatFrame.PercentageTextBox:SetText("")
EvokerSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
EvokerSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(EvokerSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

EvokerSpellChatFrame.PercentageText = EvokerSpellChatFrame:CreateFontString("EvokerSpellChatFramePercentageText")
EvokerSpellChatFrame.PercentageText:SetPoint("LEFT", EvokerSpellChatFramePercentageTextBox, "RIGHT")
EvokerSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
EvokerSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

EvokerSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "EvokerSpellChatFrameEnableCheckbox",
    EvokerSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
EvokerSpellChatFrame.EnableCheckbox:ClearAllPoints()
EvokerSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    EvokerSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
EvokerSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
EvokerSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
EvokerSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
EvokerSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
EvokerSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

EvokerSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "EvokerSpellChatFrameAddChatHeader", EvokerSpellChatFrameChatParent, "BackdropTemplate")
EvokerSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
EvokerSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.evokerEdge))
EvokerSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
EvokerSpellChatFrame.AddChatHeader:SetPoint("TOP", EvokerSpellChatFrameChatHeader, "BOTTOM", 0, -5)

EvokerSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "EvokerSpellChatFrameAddPhraseTextBox", EvokerSpellChatFrameAddChatHeader)
EvokerSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", EvokerSpellChatFrameAddChatHeader, "LEFT", 10, 0)
EvokerSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
EvokerSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
EvokerSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
EvokerSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
EvokerSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
EvokerSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                EvokerSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                EvokerSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                EvokerSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
EvokerSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                EvokerSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                EvokerSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                EvokerSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
EvokerSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = EvokerSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateEvokerSpellChatList()
            EvokerSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local EvokerChatScrollParent =
    CreateFrame("Frame", "EvokerChatScrollParent", EvokerSpellChatFrameChatParent, "BackdropTemplate")
EvokerChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
EvokerChatScrollParent:SetBackdropBorderColor(unpack(ColourList.evokerEdge))
EvokerChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
EvokerChatScrollParent:SetPoint("TOP", EvokerSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local EvokerChatScrollFrame =
    CreateFrame("ScrollFrame", "EvokerChatScrollFrame", EvokerChatScrollParent, "FauxScrollFrameTemplate")
EvokerChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
EvokerChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
EvokerChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateEvokerSpellChatList
        )
    end
)

EvokerChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    EvokerChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, EvokerChatScrollParent, "OptionsListButtonTemplate")
    local button = EvokerChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateEvokerSpellChatList()
            end
        end
    )
end

EvokerSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "EvokerSpellChatFrameClearChatListButton",
    EvokerSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
EvokerSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
EvokerSpellChatFrame.ClearChatListButton:SetPoint("TOP", EvokerChatScrollParent, "BOTTOM", 0, -4)
EvokerSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
EvokerSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.evokerEdge))
EvokerSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
EvokerSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
EvokerSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
EvokerSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
EvokerSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateEvokerSpellChatList()
        EvokerSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Hunter class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local HunterSpellChatFrame = CreateFrame("Frame", "HunterSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
HunterSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
HunterSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
HunterSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HunterSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.hunterEdge))

HunterSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "HunterSpellChatFrameAddSpellButton",
    HunterSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
HunterSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
HunterSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", HunterSpellChatFrame, "TOPLEFT", 9, -10)
HunterSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HunterSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.hunterEdge))
HunterSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
HunterSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
HunterSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
HunterSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
HunterSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local HunterSpellScrollParent =
    CreateFrame(
    "Button",
    "HunterSpellScrollParent",
    HunterSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
HunterSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HunterSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.hunterEdge))
HunterSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
HunterSpellScrollParent:SetPoint("TOP", HunterSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local HunterSpellScrollFrame =
    CreateFrame("ScrollFrame", "HunterSpellScrollFrame", HunterSpellScrollParent, "FauxScrollFrameTemplate")
HunterSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
HunterSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
HunterSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateHunterSpellList)
    end
)

HunterSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    HunterSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, HunterSpellScrollParent, "OptionsListButtonTemplate")
    local button = HunterSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = HunterSpellList
            VariableList.currentClassSpellLink = HunterSpellList[self.index].spellLink
            VariableList.currentClassSpellID = HunterSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = HunterSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = HunterSpellList[self.index].isEnabled
            loadSpellHeader()
            updateHunterSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(HunterSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

HunterSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "HunterSpellChatFrameClearSpellListButton",
    HunterSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
HunterSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
HunterSpellChatFrame.ClearSpellListButton:SetPoint("TOP", HunterSpellScrollParent, "BOTTOM", 0, -4)
HunterSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HunterSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.hunterEdge))
HunterSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
HunterSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
HunterSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
HunterSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
HunterSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(HunterSpellList)
        clearCurrentClassSpell()
        updateHunterSpellList()
        updateHunterSpellChatList()
        HunterSpellChatFrame.AddPhraseTextBox:SetText("")
        HunterSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

HunterSpellChatFrame.ChatParent = CreateFrame("Frame", "HunterSpellChatFrameChatParent", HunterSpellChatFrame)
HunterSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
HunterSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", HunterSpellChatFrame, "TOPRIGHT", -9, -10)
HunterSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "HunterSpellChatFrameChatHeader", HunterSpellChatFrameChatParent, "BackdropTemplate")
HunterSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HunterSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.hunterEdge))
HunterSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
HunterSpellChatFrame.ChatHeader:SetPoint("TOP", HunterSpellChatFrameChatParent)
HunterSpellChatFrame.TitleText = HunterSpellChatFrame:CreateFontString("MyTestFrameTitleText")
HunterSpellChatFrame.TitleText:SetPoint("TOPLEFT", HunterSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
HunterSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
HunterSpellChatFrame.TitleText:SetText("")

HunterSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "HunterSpellChatFrameDeleteSpellButton", HunterSpellChatFrameChatHeader)
HunterSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", HunterSpellChatFrameChatHeader, "RIGHT", -10, 0)
HunterSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
HunterSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
HunterSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
HunterSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateHunterSpellList()
        updateHunterSpellChatList()
        HunterSpellChatFrame.AddPhraseTextBox:SetText("")
        HunterSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

HunterSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "HunterSpellChatFramePercentageTextBox",
    HunterSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
HunterSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", HunterSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
HunterSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
HunterSpellChatFrame.PercentageTextBox:SetNumeric(true)
HunterSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
HunterSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
HunterSpellChatFrame.PercentageTextBox:SetAutoFocus()
HunterSpellChatFrame.PercentageTextBox:SetText("")
HunterSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
HunterSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(HunterSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

HunterSpellChatFrame.PercentageText = HunterSpellChatFrame:CreateFontString("HunterSpellChatFramePercentageText")
HunterSpellChatFrame.PercentageText:SetPoint("LEFT", HunterSpellChatFramePercentageTextBox, "RIGHT")
HunterSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
HunterSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

HunterSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "HunterSpellChatFrameEnableCheckbox",
    HunterSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
HunterSpellChatFrame.EnableCheckbox:ClearAllPoints()
HunterSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    HunterSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
HunterSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
HunterSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
HunterSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
HunterSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
HunterSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

HunterSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "HunterSpellChatFrameAddChatHeader", HunterSpellChatFrameChatParent, "BackdropTemplate")
HunterSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HunterSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.hunterEdge))
HunterSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
HunterSpellChatFrame.AddChatHeader:SetPoint("TOP", HunterSpellChatFrameChatHeader, "BOTTOM", 0, -5)

HunterSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "HunterSpellChatFrameAddPhraseTextBox", HunterSpellChatFrameAddChatHeader)
HunterSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", HunterSpellChatFrameAddChatHeader, "LEFT", 10, 0)
HunterSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
HunterSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
HunterSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
HunterSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
HunterSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
HunterSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                HunterSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                HunterSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                HunterSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
HunterSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                HunterSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                HunterSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                HunterSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
HunterSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = HunterSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateHunterSpellChatList()
            HunterSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local HunterChatScrollParent =
    CreateFrame("Frame", "HunterChatScrollParent", HunterSpellChatFrameChatParent, "BackdropTemplate")
HunterChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HunterChatScrollParent:SetBackdropBorderColor(unpack(ColourList.hunterEdge))
HunterChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
HunterChatScrollParent:SetPoint("TOP", HunterSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local HunterChatScrollFrame =
    CreateFrame("ScrollFrame", "HunterChatScrollFrame", HunterChatScrollParent, "FauxScrollFrameTemplate")
HunterChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
HunterChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
HunterChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateHunterSpellChatList
        )
    end
)

HunterChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    HunterChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, HunterChatScrollParent, "OptionsListButtonTemplate")
    local button = HunterChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateHunterSpellChatList()
            end
        end
    )
end

HunterSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "HunterSpellChatFrameClearChatListButton",
    HunterSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
HunterSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
HunterSpellChatFrame.ClearChatListButton:SetPoint("TOP", HunterChatScrollParent, "BOTTOM", 0, -4)
HunterSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HunterSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.hunterEdge))
HunterSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
HunterSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
HunterSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
HunterSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
HunterSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateHunterSpellChatList()
        HunterSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Mage class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local MageSpellChatFrame = CreateFrame("Frame", "MageSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
MageSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
MageSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
MageSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MageSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.mageEdge))

MageSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "MageSpellChatFrameAddSpellButton",
    MageSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
MageSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
MageSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", MageSpellChatFrame, "TOPLEFT", 9, -10)
MageSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MageSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.mageEdge))
MageSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
MageSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
MageSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
MageSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
MageSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local MageSpellScrollParent =
    CreateFrame(
    "Button",
    "MageSpellScrollParent",
    MageSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
MageSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MageSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.mageEdge))
MageSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
MageSpellScrollParent:SetPoint("TOP", MageSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local MageSpellScrollFrame =
    CreateFrame("ScrollFrame", "MageSpellScrollFrame", MageSpellScrollParent, "FauxScrollFrameTemplate")
MageSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
MageSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
MageSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateMageSpellList)
    end
)

MageSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    MageSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, MageSpellScrollParent, "OptionsListButtonTemplate")
    local button = MageSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = MageSpellList
            VariableList.currentClassSpellLink = MageSpellList[self.index].spellLink
            VariableList.currentClassSpellID = MageSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = MageSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = MageSpellList[self.index].isEnabled
            loadSpellHeader()
            updateMageSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(MageSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

MageSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "MageSpellChatFrameClearSpellListButton",
    MageSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
MageSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
MageSpellChatFrame.ClearSpellListButton:SetPoint("TOP", MageSpellScrollParent, "BOTTOM", 0, -4)
MageSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MageSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.mageEdge))
MageSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
MageSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
MageSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
MageSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
MageSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(MageSpellList)
        clearCurrentClassSpell()
        updateMageSpellList()
        updateMageSpellChatList()
        MageSpellChatFrame.AddPhraseTextBox:SetText("")
        MageSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

MageSpellChatFrame.ChatParent = CreateFrame("Frame", "MageSpellChatFrameChatParent", MageSpellChatFrame)
MageSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
MageSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", MageSpellChatFrame, "TOPRIGHT", -9, -10)
MageSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "MageSpellChatFrameChatHeader", MageSpellChatFrameChatParent, "BackdropTemplate")
MageSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MageSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.mageEdge))
MageSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
MageSpellChatFrame.ChatHeader:SetPoint("TOP", MageSpellChatFrameChatParent)
MageSpellChatFrame.TitleText = MageSpellChatFrame:CreateFontString("MyTestFrameTitleText")
MageSpellChatFrame.TitleText:SetPoint("TOPLEFT", MageSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
MageSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
MageSpellChatFrame.TitleText:SetText("")

MageSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "MageSpellChatFrameDeleteSpellButton", MageSpellChatFrameChatHeader)
MageSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", MageSpellChatFrameChatHeader, "RIGHT", -10, 0)
MageSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
MageSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
MageSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
MageSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateMageSpellList()
        updateMageSpellChatList()
        MageSpellChatFrame.AddPhraseTextBox:SetText("")
        MageSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

MageSpellChatFrame.PercentageTextBox =
    CreateFrame("EditBox", "MageSpellChatFramePercentageTextBox", MageSpellChatFrameChatHeader, "ChatConfigBoxTemplate")
MageSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", MageSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
MageSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
MageSpellChatFrame.PercentageTextBox:SetNumeric(true)
MageSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
MageSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
MageSpellChatFrame.PercentageTextBox:SetAutoFocus()
MageSpellChatFrame.PercentageTextBox:SetText("")
MageSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
MageSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(MageSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

MageSpellChatFrame.PercentageText = MageSpellChatFrame:CreateFontString("MageSpellChatFramePercentageText")
MageSpellChatFrame.PercentageText:SetPoint("LEFT", MageSpellChatFramePercentageTextBox, "RIGHT")
MageSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
MageSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

MageSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "MageSpellChatFrameEnableCheckbox",
    MageSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
MageSpellChatFrame.EnableCheckbox:ClearAllPoints()
MageSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    MageSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
MageSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
MageSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
MageSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
MageSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
MageSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

MageSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "MageSpellChatFrameAddChatHeader", MageSpellChatFrameChatParent, "BackdropTemplate")
MageSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MageSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.mageEdge))
MageSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
MageSpellChatFrame.AddChatHeader:SetPoint("TOP", MageSpellChatFrameChatHeader, "BOTTOM", 0, -5)

MageSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "MageSpellChatFrameAddPhraseTextBox", MageSpellChatFrameAddChatHeader)
MageSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", MageSpellChatFrameAddChatHeader, "LEFT", 10, 0)
MageSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
MageSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
MageSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
MageSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
MageSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
MageSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                MageSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                MageSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                MageSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
MageSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                MageSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                MageSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                MageSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
MageSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = MageSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateMageSpellChatList()
            MageSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local MageChatScrollParent =
    CreateFrame("Frame", "MageChatScrollParent", MageSpellChatFrameChatParent, "BackdropTemplate")
MageChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MageChatScrollParent:SetBackdropBorderColor(unpack(ColourList.mageEdge))
MageChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
MageChatScrollParent:SetPoint("TOP", MageSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local MageChatScrollFrame =
    CreateFrame("ScrollFrame", "MageChatScrollFrame", MageChatScrollParent, "FauxScrollFrameTemplate")
MageChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
MageChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
MageChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateMageSpellChatList
        )
    end
)

MageChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    MageChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, MageChatScrollParent, "OptionsListButtonTemplate")
    local button = MageChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateMageSpellChatList()
            end
        end
    )
end

MageSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "MageSpellChatFrameClearChatListButton",
    MageSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
MageSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
MageSpellChatFrame.ClearChatListButton:SetPoint("TOP", MageChatScrollParent, "BOTTOM", 0, -4)
MageSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MageSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.mageEdge))
MageSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
MageSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
MageSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
MageSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
MageSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateMageSpellChatList()
        MageSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Monk class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local MonkSpellChatFrame = CreateFrame("Frame", "MonkSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
MonkSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
MonkSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
MonkSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MonkSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.monkEdge))

MonkSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "MonkSpellChatFrameAddSpellButton",
    MonkSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
MonkSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
MonkSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", MonkSpellChatFrame, "TOPLEFT", 9, -10)
MonkSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MonkSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.monkEdge))
MonkSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
MonkSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
MonkSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
MonkSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
MonkSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local MonkScrollParent =
    CreateFrame("Button", "MonkScrollParent", MonkSpellChatFrame, "BackdropTemplate", "TooltipBorderedFrameTemplate")
MonkScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MonkScrollParent:SetBackdropBorderColor(unpack(ColourList.monkEdge))
MonkScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
MonkScrollParent:SetPoint("TOP", MonkSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local MonkSpellScrollFrame =
    CreateFrame("ScrollFrame", "MonkSpellScrollFrame", MonkScrollParent, "FauxScrollFrameTemplate")
MonkSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
MonkSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
MonkSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateMonkSpellList)
    end
)

MonkSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    MonkSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, MonkScrollParent, "OptionsListButtonTemplate")
    local button = MonkSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = MonkSpellList
            VariableList.currentClassSpellLink = MonkSpellList[self.index].spellLink
            VariableList.currentClassSpellID = MonkSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = MonkSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = MonkSpellList[self.index].isEnabled
            loadSpellHeader()
            updateMonkSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(MonkSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

MonkSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "MonkSpellChatFrameClearSpellListButton",
    MonkSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
MonkSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
MonkSpellChatFrame.ClearSpellListButton:SetPoint("TOP", MonkScrollParent, "BOTTOM", 0, -4)
MonkSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MonkSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.monkEdge))
MonkSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
MonkSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
MonkSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
MonkSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
MonkSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(MonkSpellList)
        clearCurrentClassSpell()
        updateMonkSpellList()
        updateMonkSpellChatList()
        MonkSpellChatFrame.AddPhraseTextBox:SetText("")
        MonkSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

MonkSpellChatFrame.ChatParent = CreateFrame("Frame", "MonkSpellChatFrameChatParent", MonkSpellChatFrame)
MonkSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
MonkSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", MonkSpellChatFrame, "TOPRIGHT", -9, -10)
MonkSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "MonkSpellChatFrameChatHeader", MonkSpellChatFrameChatParent, "BackdropTemplate")
MonkSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MonkSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.monkEdge))
MonkSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
MonkSpellChatFrame.ChatHeader:SetPoint("TOP", MonkSpellChatFrameChatParent)
MonkSpellChatFrame.TitleText = MonkSpellChatFrame:CreateFontString("MyTestFrameTitleText")
MonkSpellChatFrame.TitleText:SetPoint("TOPLEFT", MonkSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
MonkSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
MonkSpellChatFrame.TitleText:SetText("")

MonkSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "MonkSpellChatFrameDeleteSpellButton", MonkSpellChatFrameChatHeader)
MonkSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", MonkSpellChatFrameChatHeader, "RIGHT", -10, 0)
MonkSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
MonkSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
MonkSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
MonkSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateMonkSpellList()
        updateMonkSpellChatList()
        MonkSpellChatFrame.AddPhraseTextBox:SetText("")
        MonkSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

MonkSpellChatFrame.PercentageTextBox =
    CreateFrame("EditBox", "MonkSpellChatFramePercentageTextBox", MonkSpellChatFrameChatHeader, "ChatConfigBoxTemplate")
MonkSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", MonkSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
MonkSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
MonkSpellChatFrame.PercentageTextBox:SetNumeric(true)
MonkSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
MonkSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
MonkSpellChatFrame.PercentageTextBox:SetAutoFocus()
MonkSpellChatFrame.PercentageTextBox:SetText("")
MonkSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
MonkSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(MonkSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

MonkSpellChatFrame.PercentageText = MonkSpellChatFrame:CreateFontString("MonkSpellChatFramePercentageText")
MonkSpellChatFrame.PercentageText:SetPoint("LEFT", MonkSpellChatFramePercentageTextBox, "RIGHT")
MonkSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
MonkSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

MonkSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "MonkSpellChatFrameEnableCheckbox",
    MonkSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
MonkSpellChatFrame.EnableCheckbox:ClearAllPoints()
MonkSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    MonkSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
MonkSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
MonkSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
MonkSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
MonkSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
MonkSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

MonkSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "MonkSpellChatFrameAddChatHeader", MonkSpellChatFrameChatParent, "BackdropTemplate")
MonkSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MonkSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.monkEdge))
MonkSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
MonkSpellChatFrame.AddChatHeader:SetPoint("TOP", MonkSpellChatFrameChatHeader, "BOTTOM", 0, -5)

MonkSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "MonkSpellChatFrameAddPhraseTextBox", MonkSpellChatFrameAddChatHeader)
MonkSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", MonkSpellChatFrameAddChatHeader, "LEFT", 10, 0)
MonkSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
MonkSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
MonkSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
MonkSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
MonkSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
MonkSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                MonkSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                MonkSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                MonkSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
MonkSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                MonkSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                MonkSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                MonkSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
MonkSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = MonkSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateMonkSpellChatList()
            MonkSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local MonkChatScrollParent =
    CreateFrame("Frame", "MonkChatScrollParent", MonkSpellChatFrameChatParent, "BackdropTemplate")
MonkChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MonkChatScrollParent:SetBackdropBorderColor(unpack(ColourList.monkEdge))
MonkChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
MonkChatScrollParent:SetPoint("TOP", MonkSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local MonkChatScrollFrame =
    CreateFrame("ScrollFrame", "MonkChatScrollFrame", MonkChatScrollParent, "FauxScrollFrameTemplate")
MonkChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
MonkChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
MonkChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateMonkSpellChatList
        )
    end
)

MonkChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    MonkChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, MonkChatScrollParent, "OptionsListButtonTemplate")
    local button = MonkChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateMonkSpellChatList()
            end
        end
    )
end

MonkSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "MonkSpellChatFrameClearChatListButton",
    MonkSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
MonkSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
MonkSpellChatFrame.ClearChatListButton:SetPoint("TOP", MonkChatScrollParent, "BOTTOM", 0, -4)
MonkSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MonkSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.monkEdge))
MonkSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
MonkSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
MonkSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
MonkSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
MonkSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateMonkSpellChatList()
        MonkSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Paladin class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local PaladinSpellChatFrame = CreateFrame("Frame", "PaladinSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
PaladinSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
PaladinSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
PaladinSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PaladinSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.paladinEdge))

PaladinSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "PaladinSpellChatFrameAddSpellButton",
    PaladinSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
PaladinSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
PaladinSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", PaladinSpellChatFrame, "TOPLEFT", 9, -10)
PaladinSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PaladinSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.paladinEdge))
PaladinSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
PaladinSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
PaladinSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
PaladinSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
PaladinSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local PaladinSpellScrollParent =
    CreateFrame(
    "Button",
    "PaladinSpellScrollParent",
    PaladinSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
PaladinSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PaladinSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.paladinEdge))
PaladinSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
PaladinSpellScrollParent:SetPoint("TOP", PaladinSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local PaladinSpellScrollFrame =
    CreateFrame("ScrollFrame", "PaladinSpellScrollFrame", PaladinSpellScrollParent, "FauxScrollFrameTemplate")
PaladinSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
PaladinSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
PaladinSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updatePaladinSpellList)
    end
)

PaladinSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    PaladinSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, PaladinSpellScrollParent, "OptionsListButtonTemplate")
    local button = PaladinSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = PaladinSpellList
            VariableList.currentClassSpellLink = PaladinSpellList[self.index].spellLink
            VariableList.currentClassSpellID = PaladinSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = PaladinSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = PaladinSpellList[self.index].isEnabled
            loadSpellHeader()
            updatePaladinSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(PaladinSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

PaladinSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "PaladinSpellChatFrameClearSpellListButton",
    PaladinSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
PaladinSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
PaladinSpellChatFrame.ClearSpellListButton:SetPoint("TOP", PaladinSpellScrollParent, "BOTTOM", 0, -4)
PaladinSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PaladinSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.paladinEdge))
PaladinSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
PaladinSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
PaladinSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
PaladinSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
PaladinSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(PaladinSpellList)
        clearCurrentClassSpell()
        updatePaladinSpellList()
        updatePaladinSpellChatList()
        PaladinSpellChatFrame.AddPhraseTextBox:SetText("")
        PaladinSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

PaladinSpellChatFrame.ChatParent = CreateFrame("Frame", "PaladinSpellChatFrameChatParent", PaladinSpellChatFrame)
PaladinSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
PaladinSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", PaladinSpellChatFrame, "TOPRIGHT", -9, -10)
PaladinSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "PaladinSpellChatFrameChatHeader", PaladinSpellChatFrameChatParent, "BackdropTemplate")
PaladinSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PaladinSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.paladinEdge))
PaladinSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
PaladinSpellChatFrame.ChatHeader:SetPoint("TOP", PaladinSpellChatFrameChatParent)
PaladinSpellChatFrame.TitleText = PaladinSpellChatFrame:CreateFontString("MyTestFrameTitleText")
PaladinSpellChatFrame.TitleText:SetPoint("TOPLEFT", PaladinSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
PaladinSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
PaladinSpellChatFrame.TitleText:SetText("")

PaladinSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "PaladinSpellChatFrameDeleteSpellButton", PaladinSpellChatFrameChatHeader)
PaladinSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", PaladinSpellChatFrameChatHeader, "RIGHT", -10, 0)
PaladinSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
PaladinSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
PaladinSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
PaladinSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updatePaladinSpellList()
        updatePaladinSpellChatList()
        PaladinSpellChatFrame.AddPhraseTextBox:SetText("")
        PaladinSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

PaladinSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "PaladinSpellChatFramePercentageTextBox",
    PaladinSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
PaladinSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", PaladinSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
PaladinSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
PaladinSpellChatFrame.PercentageTextBox:SetNumeric(true)
PaladinSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
PaladinSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
PaladinSpellChatFrame.PercentageTextBox:SetAutoFocus()
PaladinSpellChatFrame.PercentageTextBox:SetText("")
PaladinSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
PaladinSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(PaladinSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

PaladinSpellChatFrame.PercentageText = PaladinSpellChatFrame:CreateFontString("PaladinSpellChatFramePercentageText")
PaladinSpellChatFrame.PercentageText:SetPoint("LEFT", PaladinSpellChatFramePercentageTextBox, "RIGHT")
PaladinSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
PaladinSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

PaladinSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "PaladinSpellChatFrameEnableCheckbox",
    PaladinSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
PaladinSpellChatFrame.EnableCheckbox:ClearAllPoints()
PaladinSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    PaladinSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
PaladinSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
PaladinSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
PaladinSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
PaladinSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
PaladinSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

PaladinSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "PaladinSpellChatFrameAddChatHeader", PaladinSpellChatFrameChatParent, "BackdropTemplate")
PaladinSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PaladinSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.paladinEdge))
PaladinSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
PaladinSpellChatFrame.AddChatHeader:SetPoint("TOP", PaladinSpellChatFrameChatHeader, "BOTTOM", 0, -5)

PaladinSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "PaladinSpellChatFrameAddPhraseTextBox", PaladinSpellChatFrameAddChatHeader)
PaladinSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", PaladinSpellChatFrameAddChatHeader, "LEFT", 10, 0)
PaladinSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
PaladinSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
PaladinSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
PaladinSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
PaladinSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
PaladinSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                PaladinSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                PaladinSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                PaladinSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
PaladinSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                PaladinSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                PaladinSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                PaladinSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
PaladinSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = PaladinSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updatePaladinSpellChatList()
            PaladinSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local PaladinChatScrollParent =
    CreateFrame("Frame", "PaladinChatScrollParent", PaladinSpellChatFrameChatParent, "BackdropTemplate")
PaladinChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PaladinChatScrollParent:SetBackdropBorderColor(unpack(ColourList.paladinEdge))
PaladinChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
PaladinChatScrollParent:SetPoint("TOP", PaladinSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local PaladinChatScrollFrame =
    CreateFrame("ScrollFrame", "PaladinChatScrollFrame", PaladinChatScrollParent, "FauxScrollFrameTemplate")
PaladinChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
PaladinChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
PaladinChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updatePaladinSpellChatList
        )
    end
)

PaladinChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    PaladinChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, PaladinChatScrollParent, "OptionsListButtonTemplate")
    local button = PaladinChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updatePaladinSpellChatList()
            end
        end
    )
end

PaladinSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "PaladinSpellChatFrameClearChatListButton",
    PaladinSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
PaladinSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
PaladinSpellChatFrame.ClearChatListButton:SetPoint("TOP", PaladinChatScrollParent, "BOTTOM", 0, -4)
PaladinSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PaladinSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.paladinEdge))
PaladinSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
PaladinSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
PaladinSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
PaladinSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
PaladinSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updatePaladinSpellChatList()
        PaladinSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Priest class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local PriestSpellChatFrame = CreateFrame("Frame", "PriestSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
PriestSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
PriestSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
PriestSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PriestSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.priestEdge))

PriestSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "PriestSpellChatFrameAddSpellButton",
    PriestSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
PriestSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
PriestSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", PriestSpellChatFrame, "TOPLEFT", 9, -10)
PriestSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PriestSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.priestEdge))
PriestSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
PriestSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
PriestSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
PriestSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
PriestSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local PriestSpellScrollParent =
    CreateFrame(
    "Button",
    "PriestSpellScrollParent",
    PriestSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
PriestSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PriestSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.priestEdge))
PriestSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
PriestSpellScrollParent:SetPoint("TOP", PriestSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local PriestSpellScrollFrame =
    CreateFrame("ScrollFrame", "PriestSpellScrollFrame", PriestSpellScrollParent, "FauxScrollFrameTemplate")
PriestSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
PriestSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
PriestSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updatePriestSpellList)
    end
)

PriestSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    PriestSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, PriestSpellScrollParent, "OptionsListButtonTemplate")
    local button = PriestSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = PriestSpellList
            VariableList.currentClassSpellLink = PriestSpellList[self.index].spellLink
            VariableList.currentClassSpellID = PriestSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = PriestSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = PriestSpellList[self.index].isEnabled
            loadSpellHeader()
            updatePriestSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(PriestSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

PriestSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "PriestSpellChatFrameClearSpellListButton",
    PriestSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
PriestSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
PriestSpellChatFrame.ClearSpellListButton:SetPoint("TOP", PriestSpellScrollParent, "BOTTOM", 0, -4)
PriestSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PriestSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.priestEdge))
PriestSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
PriestSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
PriestSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
PriestSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
PriestSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(PriestSpellList)
        clearCurrentClassSpell()
        updatePriestSpellList()
        updatePriestSpellChatList()
        PriestSpellChatFrame.AddPhraseTextBox:SetText("")
        PriestSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

PriestSpellChatFrame.ChatParent = CreateFrame("Frame", "PriestSpellChatFrameChatParent", PriestSpellChatFrame)
PriestSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
PriestSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", PriestSpellChatFrame, "TOPRIGHT", -9, -10)
PriestSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "PriestSpellChatFrameChatHeader", PriestSpellChatFrameChatParent, "BackdropTemplate")
PriestSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PriestSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.priestEdge))
PriestSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
PriestSpellChatFrame.ChatHeader:SetPoint("TOP", PriestSpellChatFrameChatParent)
PriestSpellChatFrame.TitleText = PriestSpellChatFrame:CreateFontString("MyTestFrameTitleText")
PriestSpellChatFrame.TitleText:SetPoint("TOPLEFT", PriestSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
PriestSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
PriestSpellChatFrame.TitleText:SetText("")

PriestSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "PriestSpellChatFrameDeleteSpellButton", PriestSpellChatFrameChatHeader)
PriestSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", PriestSpellChatFrameChatHeader, "RIGHT", -10, 0)
PriestSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
PriestSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
PriestSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
PriestSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updatePriestSpellList()
        updatePriestSpellChatList()
        PriestSpellChatFrame.AddPhraseTextBox:SetText("")
        PriestSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

PriestSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "PriestSpellChatFramePercentageTextBox",
    PriestSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
PriestSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", PriestSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
PriestSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
PriestSpellChatFrame.PercentageTextBox:SetNumeric(true)
PriestSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
PriestSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
PriestSpellChatFrame.PercentageTextBox:SetAutoFocus()
PriestSpellChatFrame.PercentageTextBox:SetText("")
PriestSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
PriestSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(PriestSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

PriestSpellChatFrame.PercentageText = PriestSpellChatFrame:CreateFontString("PriestSpellChatFramePercentageText")
PriestSpellChatFrame.PercentageText:SetPoint("LEFT", PriestSpellChatFramePercentageTextBox, "RIGHT")
PriestSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
PriestSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

PriestSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "PriestSpellChatFrameEnableCheckbox",
    PriestSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
PriestSpellChatFrame.EnableCheckbox:ClearAllPoints()
PriestSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    PriestSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
PriestSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
PriestSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
PriestSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
PriestSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
PriestSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

PriestSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "PriestSpellChatFrameAddChatHeader", PriestSpellChatFrameChatParent, "BackdropTemplate")
PriestSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PriestSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.priestEdge))
PriestSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
PriestSpellChatFrame.AddChatHeader:SetPoint("TOP", PriestSpellChatFrameChatHeader, "BOTTOM", 0, -5)

PriestSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "PriestSpellChatFrameAddPhraseTextBox", PriestSpellChatFrameAddChatHeader)
PriestSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", PriestSpellChatFrameAddChatHeader, "LEFT", 10, 0)
PriestSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
PriestSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
PriestSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
PriestSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
PriestSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
PriestSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                PriestSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                PriestSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                PriestSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
PriestSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                PriestSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                PriestSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                PriestSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
PriestSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = PriestSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updatePriestSpellChatList()
            PriestSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local PriestChatScrollParent =
    CreateFrame("Frame", "PriestChatScrollParent", PriestSpellChatFrameChatParent, "BackdropTemplate")
PriestChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PriestChatScrollParent:SetBackdropBorderColor(unpack(ColourList.priestEdge))
PriestChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
PriestChatScrollParent:SetPoint("TOP", PriestSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local PriestChatScrollFrame =
    CreateFrame("ScrollFrame", "PriestChatScrollFrame", PriestChatScrollParent, "FauxScrollFrameTemplate")
PriestChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
PriestChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
PriestChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updatePriestSpellChatList
        )
    end
)

PriestChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    PriestChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, PriestChatScrollParent, "OptionsListButtonTemplate")
    local button = PriestChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updatePriestSpellChatList()
            end
        end
    )
end

PriestSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "PriestSpellChatFrameClearChatListButton",
    PriestSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
PriestSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
PriestSpellChatFrame.ClearChatListButton:SetPoint("TOP", PriestChatScrollParent, "BOTTOM", 0, -4)
PriestSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PriestSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.priestEdge))
PriestSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
PriestSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
PriestSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
PriestSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
PriestSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updatePriestSpellChatList()
        PriestSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Rogue class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local RogueSpellChatFrame = CreateFrame("Frame", "RogueSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
RogueSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
RogueSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
RogueSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
RogueSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.rogueEdge))

RogueSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "RogueSpellChatFrameAddSpellButton",
    RogueSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
RogueSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
RogueSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", RogueSpellChatFrame, "TOPLEFT", 9, -10)
RogueSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
RogueSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.rogueEdge))
RogueSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
RogueSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
RogueSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
RogueSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
RogueSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local RogueSpellScrollParent =
    CreateFrame(
    "Button",
    "RogueSpellScrollParent",
    RogueSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
RogueSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
RogueSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.rogueEdge))
RogueSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
RogueSpellScrollParent:SetPoint("TOP", RogueSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local RogueSpellScrollFrame =
    CreateFrame("ScrollFrame", "RogueSpellScrollFrame", RogueSpellScrollParent, "FauxScrollFrameTemplate")
RogueSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
RogueSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
RogueSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateRogueSpellList)
    end
)

RogueSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    RogueSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, RogueSpellScrollParent, "OptionsListButtonTemplate")
    local button = RogueSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = RogueSpellList
            VariableList.currentClassSpellLink = RogueSpellList[self.index].spellLink
            VariableList.currentClassSpellID = RogueSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = RogueSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = RogueSpellList[self.index].isEnabled
            loadSpellHeader()
            updateRogueSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(RogueSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

RogueSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "RogueSpellChatFrameClearSpellListButton",
    RogueSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
RogueSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
RogueSpellChatFrame.ClearSpellListButton:SetPoint("TOP", RogueSpellScrollParent, "BOTTOM", 0, -4)
RogueSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
RogueSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.rogueEdge))
RogueSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
RogueSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
RogueSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
RogueSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
RogueSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(RogueSpellList)
        clearCurrentClassSpell()
        updateRogueSpellList()
        updateRogueSpellChatList()
        RogueSpellChatFrame.AddPhraseTextBox:SetText("")
        RogueSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

RogueSpellChatFrame.ChatParent = CreateFrame("Frame", "RogueSpellChatFrameChatParent", RogueSpellChatFrame)
RogueSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
RogueSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", RogueSpellChatFrame, "TOPRIGHT", -9, -10)
RogueSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "RogueSpellChatFrameChatHeader", RogueSpellChatFrameChatParent, "BackdropTemplate")
RogueSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
RogueSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.rogueEdge))
RogueSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
RogueSpellChatFrame.ChatHeader:SetPoint("TOP", RogueSpellChatFrameChatParent)
RogueSpellChatFrame.TitleText = RogueSpellChatFrame:CreateFontString("MyTestFrameTitleText")
RogueSpellChatFrame.TitleText:SetPoint("TOPLEFT", RogueSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
RogueSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
RogueSpellChatFrame.TitleText:SetText("")

RogueSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "RogueSpellChatFrameDeleteSpellButton", RogueSpellChatFrameChatHeader)
RogueSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", RogueSpellChatFrameChatHeader, "RIGHT", -10, 0)
RogueSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
RogueSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
RogueSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
RogueSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateRogueSpellList()
        updateRogueSpellChatList()
        RogueSpellChatFrame.AddPhraseTextBox:SetText("")
        RogueSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

RogueSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "RogueSpellChatFramePercentageTextBox",
    RogueSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
RogueSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", RogueSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
RogueSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
RogueSpellChatFrame.PercentageTextBox:SetNumeric(true)
RogueSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
RogueSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
RogueSpellChatFrame.PercentageTextBox:SetAutoFocus()
RogueSpellChatFrame.PercentageTextBox:SetText("")
RogueSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
RogueSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(RogueSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

RogueSpellChatFrame.PercentageText = RogueSpellChatFrame:CreateFontString("RogueSpellChatFramePercentageText")
RogueSpellChatFrame.PercentageText:SetPoint("LEFT", RogueSpellChatFramePercentageTextBox, "RIGHT")
RogueSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
RogueSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

RogueSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "RogueSpellChatFrameEnableCheckbox",
    RogueSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
RogueSpellChatFrame.EnableCheckbox:ClearAllPoints()
RogueSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    RogueSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
RogueSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
RogueSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
RogueSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
RogueSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
RogueSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

RogueSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "RogueSpellChatFrameAddChatHeader", RogueSpellChatFrameChatParent, "BackdropTemplate")
RogueSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
RogueSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.rogueEdge))
RogueSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
RogueSpellChatFrame.AddChatHeader:SetPoint("TOP", RogueSpellChatFrameChatHeader, "BOTTOM", 0, -5)

RogueSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "RogueSpellChatFrameAddPhraseTextBox", RogueSpellChatFrameAddChatHeader)
RogueSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", RogueSpellChatFrameAddChatHeader, "LEFT", 10, 0)
RogueSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
RogueSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
RogueSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
RogueSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
RogueSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
RogueSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                RogueSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                RogueSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                RogueSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
RogueSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                RogueSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                RogueSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                RogueSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
RogueSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = RogueSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateRogueSpellChatList()
            RogueSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local RogueChatScrollParent =
    CreateFrame("Frame", "RogueChatScrollParent", RogueSpellChatFrameChatParent, "BackdropTemplate")
RogueChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
RogueChatScrollParent:SetBackdropBorderColor(unpack(ColourList.rogueEdge))
RogueChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
RogueChatScrollParent:SetPoint("TOP", RogueSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local RogueChatScrollFrame =
    CreateFrame("ScrollFrame", "RogueChatScrollFrame", RogueChatScrollParent, "FauxScrollFrameTemplate")
RogueChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
RogueChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
RogueChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateRogueSpellChatList
        )
    end
)

RogueChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    RogueChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, RogueChatScrollParent, "OptionsListButtonTemplate")
    local button = RogueChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateRogueSpellChatList()
            end
        end
    )
end

RogueSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "RogueSpellChatFrameClearChatListButton",
    RogueSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
RogueSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
RogueSpellChatFrame.ClearChatListButton:SetPoint("TOP", RogueChatScrollParent, "BOTTOM", 0, -4)
RogueSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
RogueSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.rogueEdge))
RogueSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
RogueSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
RogueSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
RogueSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
RogueSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateRogueSpellChatList()
        RogueSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Shaman class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local ShamanSpellChatFrame = CreateFrame("Frame", "ShamanSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
ShamanSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
ShamanSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
ShamanSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ShamanSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.shamanEdge))

ShamanSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "ShamanSpellChatFrameAddSpellButton",
    ShamanSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
ShamanSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
ShamanSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", ShamanSpellChatFrame, "TOPLEFT", 9, -10)
ShamanSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ShamanSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.shamanEdge))
ShamanSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
ShamanSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
ShamanSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
ShamanSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
ShamanSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local ShamanSpellScrollParent =
    CreateFrame(
    "Button",
    "ShamanSpellScrollParent",
    ShamanSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
ShamanSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ShamanSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.shamanEdge))
ShamanSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
ShamanSpellScrollParent:SetPoint("TOP", ShamanSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local ShamanSpellScrollFrame =
    CreateFrame("ScrollFrame", "ShamanSpellScrollFrame", ShamanSpellScrollParent, "FauxScrollFrameTemplate")
ShamanSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
ShamanSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
ShamanSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateShamanSpellList)
    end
)

ShamanSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    ShamanSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, ShamanSpellScrollParent, "OptionsListButtonTemplate")
    local button = ShamanSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = ShamanSpellList
            VariableList.currentClassSpellLink = ShamanSpellList[self.index].spellLink
            VariableList.currentClassSpellID = ShamanSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = ShamanSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = ShamanSpellList[self.index].isEnabled
            loadSpellHeader()
            updateShamanSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(ShamanSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

ShamanSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "ShamanSpellChatFrameClearSpellListButton",
    ShamanSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
ShamanSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
ShamanSpellChatFrame.ClearSpellListButton:SetPoint("TOP", ShamanSpellScrollParent, "BOTTOM", 0, -4)
ShamanSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ShamanSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.shamanEdge))
ShamanSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
ShamanSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
ShamanSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
ShamanSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
ShamanSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(ShamanSpellList)
        clearCurrentClassSpell()
        updateShamanSpellList()
        updateShamanSpellChatList()
        ShamanSpellChatFrame.AddPhraseTextBox:SetText("")
        ShamanSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

ShamanSpellChatFrame.ChatParent = CreateFrame("Frame", "ShamanSpellChatFrameChatParent", ShamanSpellChatFrame)
ShamanSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
ShamanSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", ShamanSpellChatFrame, "TOPRIGHT", -9, -10)
ShamanSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "ShamanSpellChatFrameChatHeader", ShamanSpellChatFrameChatParent, "BackdropTemplate")
ShamanSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ShamanSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.shamanEdge))
ShamanSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
ShamanSpellChatFrame.ChatHeader:SetPoint("TOP", ShamanSpellChatFrameChatParent)
ShamanSpellChatFrame.TitleText = ShamanSpellChatFrame:CreateFontString("MyTestFrameTitleText")
ShamanSpellChatFrame.TitleText:SetPoint("TOPLEFT", ShamanSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
ShamanSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
ShamanSpellChatFrame.TitleText:SetText("")

ShamanSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "ShamanSpellChatFrameDeleteSpellButton", ShamanSpellChatFrameChatHeader)
ShamanSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", ShamanSpellChatFrameChatHeader, "RIGHT", -10, 0)
ShamanSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
ShamanSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
ShamanSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
ShamanSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateShamanSpellList()
        updateShamanSpellChatList()
        ShamanSpellChatFrame.AddPhraseTextBox:SetText("")
        ShamanSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

ShamanSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "ShamanSpellChatFramePercentageTextBox",
    ShamanSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
ShamanSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", ShamanSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
ShamanSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
ShamanSpellChatFrame.PercentageTextBox:SetNumeric(true)
ShamanSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
ShamanSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
ShamanSpellChatFrame.PercentageTextBox:SetAutoFocus()
ShamanSpellChatFrame.PercentageTextBox:SetText("")
ShamanSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
ShamanSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(ShamanSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

ShamanSpellChatFrame.PercentageText = ShamanSpellChatFrame:CreateFontString("ShamanSpellChatFramePercentageText")
ShamanSpellChatFrame.PercentageText:SetPoint("LEFT", ShamanSpellChatFramePercentageTextBox, "RIGHT")
ShamanSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
ShamanSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

ShamanSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "ShamanSpellChatFrameEnableCheckbox",
    ShamanSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
ShamanSpellChatFrame.EnableCheckbox:ClearAllPoints()
ShamanSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    ShamanSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
ShamanSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
ShamanSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
ShamanSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
ShamanSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
ShamanSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

ShamanSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "ShamanSpellChatFrameAddChatHeader", ShamanSpellChatFrameChatParent, "BackdropTemplate")
ShamanSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ShamanSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.shamanEdge))
ShamanSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
ShamanSpellChatFrame.AddChatHeader:SetPoint("TOP", ShamanSpellChatFrameChatHeader, "BOTTOM", 0, -5)

ShamanSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "ShamanSpellChatFrameAddPhraseTextBox", ShamanSpellChatFrameAddChatHeader)
ShamanSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", ShamanSpellChatFrameAddChatHeader, "LEFT", 10, 0)
ShamanSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
ShamanSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
ShamanSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
ShamanSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
ShamanSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
ShamanSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                ShamanSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                ShamanSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                ShamanSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
ShamanSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                ShamanSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                ShamanSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                ShamanSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
ShamanSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = ShamanSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateShamanSpellChatList()
            ShamanSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local ShamanChatScrollParent =
    CreateFrame("Frame", "ShamanChatScrollParent", ShamanSpellChatFrameChatParent, "BackdropTemplate")
ShamanChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ShamanChatScrollParent:SetBackdropBorderColor(unpack(ColourList.shamanEdge))
ShamanChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
ShamanChatScrollParent:SetPoint("TOP", ShamanSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local ShamanChatScrollFrame =
    CreateFrame("ScrollFrame", "ShamanChatScrollFrame", ShamanChatScrollParent, "FauxScrollFrameTemplate")
ShamanChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
ShamanChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
ShamanChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateShamanSpellChatList
        )
    end
)

ShamanChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    ShamanChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, ShamanChatScrollParent, "OptionsListButtonTemplate")
    local button = ShamanChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateShamanSpellChatList()
            end
        end
    )
end

ShamanSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "ShamanSpellChatFrameClearChatListButton",
    ShamanSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
ShamanSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
ShamanSpellChatFrame.ClearChatListButton:SetPoint("TOP", ShamanChatScrollParent, "BOTTOM", 0, -4)
ShamanSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ShamanSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.shamanEdge))
ShamanSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
ShamanSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
ShamanSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
ShamanSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
ShamanSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateShamanSpellChatList()
        ShamanSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Warlock class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local WarlockSpellChatFrame = CreateFrame("Frame", "WarlockSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
WarlockSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
WarlockSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
WarlockSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarlockSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.warlockEdge))

WarlockSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "WarlockSpellChatFrameAddSpellButton",
    WarlockSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
WarlockSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
WarlockSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", WarlockSpellChatFrame, "TOPLEFT", 9, -10)
WarlockSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarlockSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.warlockEdge))
WarlockSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
WarlockSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
WarlockSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
WarlockSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
WarlockSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local WarlockSpellScrollParent =
    CreateFrame(
    "Button",
    "WarlockSpellScrollParent",
    WarlockSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
WarlockSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarlockSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.warlockEdge))
WarlockSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
WarlockSpellScrollParent:SetPoint("TOP", WarlockSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local WarlockSpellScrollFrame =
    CreateFrame("ScrollFrame", "WarlockSpellScrollFrame", WarlockSpellScrollParent, "FauxScrollFrameTemplate")
WarlockSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
WarlockSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
WarlockSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateWarlockSpellList)
    end
)

WarlockSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    WarlockSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, WarlockSpellScrollParent, "OptionsListButtonTemplate")
    local button = WarlockSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = WarlockSpellList
            VariableList.currentClassSpellLink = WarlockSpellList[self.index].spellLink
            VariableList.currentClassSpellID = WarlockSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = WarlockSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = WarlockSpellList[self.index].isEnabled
            loadSpellHeader()
            updateWarlockSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(WarlockSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

WarlockSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "WarlockSpellChatFrameClearSpellListButton",
    WarlockSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
WarlockSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
WarlockSpellChatFrame.ClearSpellListButton:SetPoint("TOP", WarlockSpellScrollParent, "BOTTOM", 0, -4)
WarlockSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarlockSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.warlockEdge))
WarlockSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
WarlockSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
WarlockSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
WarlockSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
WarlockSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(WarlockSpellList)
        clearCurrentClassSpell()
        updateWarlockSpellList()
        updateWarlockSpellChatList()
        WarlockSpellChatFrame.AddPhraseTextBox:SetText("")
        WarlockSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

WarlockSpellChatFrame.ChatParent = CreateFrame("Frame", "WarlockSpellChatFrameChatParent", WarlockSpellChatFrame)
WarlockSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
WarlockSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", WarlockSpellChatFrame, "TOPRIGHT", -9, -10)
WarlockSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "WarlockSpellChatFrameChatHeader", WarlockSpellChatFrameChatParent, "BackdropTemplate")
WarlockSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarlockSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.warlockEdge))
WarlockSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
WarlockSpellChatFrame.ChatHeader:SetPoint("TOP", WarlockSpellChatFrameChatParent)
WarlockSpellChatFrame.TitleText = WarlockSpellChatFrame:CreateFontString("MyTestFrameTitleText")
WarlockSpellChatFrame.TitleText:SetPoint("TOPLEFT", WarlockSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
WarlockSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
WarlockSpellChatFrame.TitleText:SetText("")

WarlockSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "WarlockSpellChatFrameDeleteSpellButton", WarlockSpellChatFrameChatHeader)
WarlockSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", WarlockSpellChatFrameChatHeader, "RIGHT", -10, 0)
WarlockSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
WarlockSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
WarlockSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
WarlockSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateWarlockSpellList()
        updateWarlockSpellChatList()
        WarlockSpellChatFrame.AddPhraseTextBox:SetText("")
        WarlockSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

WarlockSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "WarlockSpellChatFramePercentageTextBox",
    WarlockSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
WarlockSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", WarlockSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
WarlockSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
WarlockSpellChatFrame.PercentageTextBox:SetNumeric(true)
WarlockSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
WarlockSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
WarlockSpellChatFrame.PercentageTextBox:SetAutoFocus()
WarlockSpellChatFrame.PercentageTextBox:SetText("")
WarlockSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
WarlockSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(WarlockSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

WarlockSpellChatFrame.PercentageText = WarlockSpellChatFrame:CreateFontString("WarlockSpellChatFramePercentageText")
WarlockSpellChatFrame.PercentageText:SetPoint("LEFT", WarlockSpellChatFramePercentageTextBox, "RIGHT")
WarlockSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
WarlockSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

WarlockSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "WarlockSpellChatFrameEnableCheckbox",
    WarlockSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
WarlockSpellChatFrame.EnableCheckbox:ClearAllPoints()
WarlockSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    WarlockSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
WarlockSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
WarlockSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
WarlockSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
WarlockSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
WarlockSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

WarlockSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "WarlockSpellChatFrameAddChatHeader", WarlockSpellChatFrameChatParent, "BackdropTemplate")
WarlockSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarlockSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.warlockEdge))
WarlockSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.addChatHeaderHeight)
WarlockSpellChatFrame.AddChatHeader:SetPoint("TOP", WarlockSpellChatFrameChatHeader, "BOTTOM", 0, -5)

WarlockSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "WarlockSpellChatFrameAddPhraseTextBox", WarlockSpellChatFrameAddChatHeader)
WarlockSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", WarlockSpellChatFrameAddChatHeader, "LEFT", 10, 0)
WarlockSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
WarlockSpellChatFrame.AddPhraseTextBox:SetSize(
    NumberList.scrollSpellFrameWidth - NumberList.percentageTextBoxWidth,
    NumberList.addPhraseTextBoxHeight
)
WarlockSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
WarlockSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
WarlockSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
WarlockSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                WarlockSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                WarlockSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                WarlockSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)

WarlockSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = WarlockSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateWarlockSpellChatList()
            WarlockSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local WarlockChatScrollParent =
    CreateFrame("Frame", "WarlockChatScrollParent", WarlockSpellChatFrameChatParent, "BackdropTemplate")
WarlockChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarlockChatScrollParent:SetBackdropBorderColor(unpack(ColourList.warlockEdge))
WarlockChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
WarlockChatScrollParent:SetPoint("TOP", WarlockSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local WarlockChatScrollFrame =
    CreateFrame("ScrollFrame", "WarlockChatScrollFrame", WarlockChatScrollParent, "FauxScrollFrameTemplate")
WarlockChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
WarlockChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
WarlockChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateWarlockSpellChatList
        )
    end
)

WarlockChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    WarlockChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, WarlockChatScrollParent, "OptionsListButtonTemplate")
    local button = WarlockChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateWarlockSpellChatList()
            end
        end
    )
end

WarlockSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "WarlockSpellChatFrameClearChatListButton",
    WarlockSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
WarlockSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
WarlockSpellChatFrame.ClearChatListButton:SetPoint("TOP", WarlockChatScrollParent, "BOTTOM", 0, -4)
WarlockSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarlockSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.warlockEdge))
WarlockSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
WarlockSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
WarlockSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
WarlockSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
WarlockSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateWarlockSpellChatList()
        WarlockSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Warrior class frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local WarriorSpellChatFrame = CreateFrame("Frame", "WarriorSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
WarriorSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
WarriorSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
WarriorSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarriorSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.warriorEdge))

WarriorSpellChatFrame.AddSpellButton =
    CreateFrame(
    "Button",
    "WarriorSpellChatFrameAddSpellButton",
    WarriorSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
WarriorSpellChatFrame.AddSpellButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
WarriorSpellChatFrame.AddSpellButton:SetPoint("TOPLEFT", WarriorSpellChatFrame, "TOPLEFT", 9, -10)
WarriorSpellChatFrame.AddSpellButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarriorSpellChatFrame.AddSpellButton:SetBackdropBorderColor(unpack(ColourList.warriorEdge))
WarriorSpellChatFrame.AddSpellButton:SetNormalFontObject(TextList.buttonFontObject)
WarriorSpellChatFrame.AddSpellButton:SetHighlightFontObject(TextList.buttonFontObject)
WarriorSpellChatFrame.AddSpellButton:SetText(TextList.addSpellButtonText)
WarriorSpellChatFrame.AddSpellButton:SetScript(
    "OnReceiveDrag",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)
WarriorSpellChatFrame.AddSpellButton:SetScript(
    "OnClick",
    function()
        toggleButton(VariableList.currentAddClassNavigationButton)
        if GetCursorInfo() then
            cursorType, _, _, spellID = GetCursorInfo()
            if cursorType ~= "spell" then
                printErrorMessages("errorNotASpell")
            elseif checkIfSpellIsAlreadyListed(spellID) then
                printErrorMessages("errorAlreadyListed")
            else
                spellLink = GetSpellLink(spellID)
                addSpellToClassSpellList(spellID, spellLink)
                updateListBasedOnOpenFrame()
            end
            ClearCursor()
        end
    end
)

local WarriorSpellScrollParent =
    CreateFrame(
    "Button",
    "WarriorSpellScrollParent",
    WarriorSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
WarriorSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarriorSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.warriorEdge))
WarriorSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
WarriorSpellScrollParent:SetPoint("TOP", WarriorSpellChatFrameAddSpellButton, "BOTTOM", 0, -5)

local WarriorSpellScrollFrame =
    CreateFrame("ScrollFrame", "WarriorSpellScrollFrame", WarriorSpellScrollParent, "FauxScrollFrameTemplate")
WarriorSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
WarriorSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
WarriorSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateWarriorSpellList)
    end
)

WarriorSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    WarriorSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, WarriorSpellScrollParent, "OptionsListButtonTemplate")
    local button = WarriorSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentClassSpellList = WarriorSpellList
            VariableList.currentClassSpellLink = WarriorSpellList[self.index].spellLink
            VariableList.currentClassSpellID = WarriorSpellList[self.index].spellID
            VariableList.currentClassSpellPercentage = WarriorSpellList[self.index].percentage
            VariableList.currentClassSpellEnabled = WarriorSpellList[self.index].isEnabled
            loadSpellHeader()
            updateWarriorSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
            GameTooltip:SetHyperlink(WarriorSpellList[self.index].spellLink)
            GameTooltip:Show()
        end
    )
end

WarriorSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "WarriorSpellChatFrameClearSpellListButton",
    WarriorSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
WarriorSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
WarriorSpellChatFrame.ClearSpellListButton:SetPoint("TOP", WarriorSpellScrollParent, "BOTTOM", 0, -4)
WarriorSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarriorSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.warriorEdge))
WarriorSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
WarriorSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
WarriorSpellChatFrame.ClearSpellListButton:SetText(TextList.clearSpellListButtonText)
WarriorSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
WarriorSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(WarriorSpellList)
        clearCurrentClassSpell()
        updateWarriorSpellList()
        updateWarriorSpellChatList()
        WarriorSpellChatFrame.AddPhraseTextBox:SetText("")
        WarriorSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

WarriorSpellChatFrame.ChatParent = CreateFrame("Frame", "WarriorSpellChatFrameChatParent", WarriorSpellChatFrame)
WarriorSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
WarriorSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", WarriorSpellChatFrame, "TOPRIGHT", -9, -10)
WarriorSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "WarriorSpellChatFrameChatHeader", WarriorSpellChatFrameChatParent, "BackdropTemplate")
WarriorSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarriorSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.warriorEdge))
WarriorSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
WarriorSpellChatFrame.ChatHeader:SetPoint("TOP", WarriorSpellChatFrameChatParent)
WarriorSpellChatFrame.TitleText = WarriorSpellChatFrame:CreateFontString("MyTestFrameTitleText")
WarriorSpellChatFrame.TitleText:SetPoint("TOPLEFT", WarriorSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
WarriorSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
WarriorSpellChatFrame.TitleText:SetText("")

WarriorSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "WarriorSpellChatFrameDeleteSpellButton", WarriorSpellChatFrameChatHeader)
WarriorSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", WarriorSpellChatFrameChatHeader, "RIGHT", -10, 0)
WarriorSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
WarriorSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
WarriorSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
WarriorSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentClassSpell()
        updateWarriorSpellList()
        updateWarriorSpellChatList()
        WarriorSpellChatFrame.AddPhraseTextBox:SetText("")
        WarriorSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

WarriorSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "WarriorSpellChatFramePercentageTextBox",
    WarriorSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
WarriorSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", WarriorSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
WarriorSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
WarriorSpellChatFrame.PercentageTextBox:SetNumeric(true)
WarriorSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
WarriorSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
WarriorSpellChatFrame.PercentageTextBox:SetAutoFocus()
WarriorSpellChatFrame.PercentageTextBox:SetText("")
WarriorSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
WarriorSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(WarriorSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateSpellPercentage(percentageNumber)
    end
)

WarriorSpellChatFrame.PercentageText = WarriorSpellChatFrame:CreateFontString("WarriorSpellChatFramePercentageText")
WarriorSpellChatFrame.PercentageText:SetPoint("LEFT", WarriorSpellChatFramePercentageTextBox, "RIGHT")
WarriorSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
WarriorSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

WarriorSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "WarriorSpellChatFrameEnableCheckbox",
    WarriorSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
WarriorSpellChatFrame.EnableCheckbox:ClearAllPoints()
WarriorSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    WarriorSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
WarriorSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
WarriorSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentClassSpellEnabled)
WarriorSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
WarriorSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
WarriorSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = false
            updateSpellEnabled()
        elseif not VariableList.currentClassSpellEnabled then
            VariableList.currentClassSpellEnabled = true
            updateSpellEnabled()
        end
    end
)

WarriorSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "WarriorSpellChatFrameAddChatHeader", WarriorSpellChatFrameChatParent, "BackdropTemplate")
WarriorSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarriorSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.warriorEdge))
WarriorSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, 31)
WarriorSpellChatFrame.AddChatHeader:SetPoint("TOP", WarriorSpellChatFrameChatHeader, "BOTTOM", 0, -5)

WarriorSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "WarriorSpellChatFrameAddPhraseTextBox", WarriorSpellChatFrameAddChatHeader)
WarriorSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", WarriorSpellChatFrameAddChatHeader, "LEFT", 10, 0)
WarriorSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
WarriorSpellChatFrame.AddPhraseTextBox:SetSize(NumberList.scrollSpellFrameWidth - 40, 25)
WarriorSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
WarriorSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
WarriorSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
WarriorSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                WarriorSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                WarriorSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                WarriorSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
WarriorSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                WarriorSpellChatFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                WarriorSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                WarriorSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
WarriorSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = WarriorSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToClassSpellList(chatPhrase)
            updateWarriorSpellChatList()
            WarriorSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local WarriorChatScrollParent =
    CreateFrame("Frame", "WarriorChatScrollParent", WarriorSpellChatFrameChatParent, "BackdropTemplate")
WarriorChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarriorChatScrollParent:SetBackdropBorderColor(unpack(ColourList.warriorEdge))
WarriorChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
WarriorChatScrollParent:SetPoint("TOP", WarriorSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local WarriorChatScrollFrame =
    CreateFrame("ScrollFrame", "WarriorChatScrollFrame", WarriorChatScrollParent, "FauxScrollFrameTemplate")
WarriorChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
WarriorChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
WarriorChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateWarriorSpellChatList
        )
    end
)

WarriorChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    WarriorChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, WarriorChatScrollParent, "OptionsListButtonTemplate")
    local button = WarriorChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentClassSpellPhrase = currentClassSpellList[self.index]
                clearCurrentClassSpellChat()
                updateWarriorSpellChatList()
            end
        end
    )
end

WarriorSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "WarriorSpellChatFrameClearChatListButton",
    WarriorSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
WarriorSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
WarriorSpellChatFrame.ClearChatListButton:SetPoint("TOP", WarriorChatScrollParent, "BOTTOM", 0, -4)
WarriorSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
WarriorSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.warriorEdge))
WarriorSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
WarriorSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
WarriorSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
WarriorSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
WarriorSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentChatList()
        updateWarriorSpellChatList()
        WarriorSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Items frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local ItemsSpellChatFrame = CreateFrame("Frame", "ItemsSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
ItemsSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
ItemsSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
ItemsSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ItemsSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.itemEdge))

ItemsSpellChatFrame.AddItemButton =
    CreateFrame(
    "Button",
    "ItemsSpellChatFrameAddItemButton",
    ItemsSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
ItemsSpellChatFrame.AddItemButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
ItemsSpellChatFrame.AddItemButton:SetPoint("TOPLEFT", ItemsSpellChatFrame, "TOPLEFT", 9, -10)
ItemsSpellChatFrame.AddItemButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ItemsSpellChatFrame.AddItemButton:SetBackdropBorderColor(unpack(ColourList.itemEdge))
ItemsSpellChatFrame.AddItemButton:SetNormalFontObject(TextList.buttonFontObject)
ItemsSpellChatFrame.AddItemButton:SetHighlightFontObject(TextList.buttonFontObject)
ItemsSpellChatFrame.AddItemButton:SetText(TextList.addItemButtonText)
ItemsSpellChatFrame.AddItemButton:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2 = GetCursorInfo()
            masterAddObjectToList(cursorType, arg1, arg2)
        end
    end
)
ItemsSpellChatFrame.AddItemButton:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2 = GetCursorInfo()
            masterAddObjectToList(cursorType, arg1, arg2)
        end
    end
)

local ItemsSpellScrollParent =
    CreateFrame(
    "Button",
    "ItemsSpellScrollParent",
    ItemsSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
ItemsSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ItemsSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.itemEdge))
ItemsSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
ItemsSpellScrollParent:SetPoint("TOP", ItemsSpellChatFrameAddItemButton, "BOTTOM", 0, -5)

local ItemsSpellScrollFrame =
    CreateFrame("ScrollFrame", "ItemsSpellScrollFrame", ItemsSpellScrollParent, "FauxScrollFrameTemplate")
ItemsSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
ItemsSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
ItemsSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateItemsSpellList)
    end
)

ItemsSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    ItemsSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, ItemsSpellScrollParent, "OptionsListButtonTemplate")
    local button = ItemsSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentObjectLink = SpellChatItemList[self.index].itemLink
            VariableList.currentObjectID = SpellChatItemList[self.index].itemID
            VariableList.currentObjectPercentage = SpellChatItemList[self.index].percentage
            VariableList.currentObjectEnabled = SpellChatItemList[self.index].isEnabled
            loadItemHeader()
            updateItemsSpellChatList()
        end
    )
    button:SetScript(
        "OnEnter",
        function(self)
            if SpellChatItemList[self.index].itemType ~= "battlepet" then -- debug --
                GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 15)
                GameTooltip:SetHyperlink(SpellChatItemList[self.index].itemLink)
                GameTooltip:Show()
            end -- debug --
        end
    )
end

ItemsSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "ItemsSpellChatFrameClearSpellListButton",
    ItemsSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
ItemsSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
ItemsSpellChatFrame.ClearSpellListButton:SetPoint("TOP", ItemsSpellScrollParent, "BOTTOM", 0, -4)
ItemsSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ItemsSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.itemEdge))
ItemsSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
ItemsSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
ItemsSpellChatFrame.ClearSpellListButton:SetText(TextList.clearItemListButtonText)
ItemsSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
ItemsSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(SpellChatItemList)
        clearCurrentItem()
        updateItemsSpellList()
        updateItemsSpellChatList()
        ItemsSpellChatFrame.AddPhraseTextBox:SetText("")
        ItemsSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

ItemsSpellChatFrame.ChatParent = CreateFrame("Frame", "ItemsSpellChatFrameChatParent", ItemsSpellChatFrame)
ItemsSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
ItemsSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", ItemsSpellChatFrame, "TOPRIGHT", -9, -10)
ItemsSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "ItemsSpellChatFrameChatHeader", ItemsSpellChatFrameChatParent, "BackdropTemplate")
ItemsSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ItemsSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.itemEdge))
ItemsSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
ItemsSpellChatFrame.ChatHeader:SetPoint("TOP", ItemsSpellChatFrameChatParent)
ItemsSpellChatFrame.TitleText = ItemsSpellChatFrame:CreateFontString("MyTestFrameTitleText")
ItemsSpellChatFrame.TitleText:SetPoint("TOPLEFT", ItemsSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
ItemsSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
ItemsSpellChatFrame.TitleText:SetText("")

ItemsSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "ItemsSpellChatFrameDeleteSpellButton", ItemsSpellChatFrameChatHeader)
ItemsSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", ItemsSpellChatFrameChatHeader, "RIGHT", -10, 0)
ItemsSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
ItemsSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
ItemsSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
ItemsSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentItem()
        updateItemsSpellList()
        updateItemsSpellChatList()
        ItemsSpellChatFrame.AddPhraseTextBox:SetText("")
        ItemsSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

ItemsSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "ItemsSpellChatFramePercentageTextBox",
    ItemsSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
ItemsSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", ItemsSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
ItemsSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
ItemsSpellChatFrame.PercentageTextBox:SetNumeric(true)
ItemsSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
ItemsSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
ItemsSpellChatFrame.PercentageTextBox:SetAutoFocus()
ItemsSpellChatFrame.PercentageTextBox:SetText("")
ItemsSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
ItemsSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(ItemsSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateItemPercentage(percentageNumber)
    end
)

ItemsSpellChatFrame.PercentageText = ItemsSpellChatFrame:CreateFontString("ItemsSpellChatFramePercentageText")
ItemsSpellChatFrame.PercentageText:SetPoint("LEFT", ItemsSpellChatFramePercentageTextBox, "RIGHT")
ItemsSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
ItemsSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

ItemsSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "ItemsSpellChatFrameEnableCheckbox",
    ItemsSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
ItemsSpellChatFrame.EnableCheckbox:ClearAllPoints()
ItemsSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    ItemsSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
ItemsSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
ItemsSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentObjectEnabled)
ItemsSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
ItemsSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
ItemsSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentObjectEnabled then
            VariableList.currentObjectEnabled = false
            updateItemEnabled()
        elseif not VariableList.currentObjectEnabled then
            VariableList.currentObjectEnabled = true
            updateItemEnabled()
        end
    end
)

ItemsSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "ItemsSpellChatFrameAddChatHeader", ItemsSpellChatFrameChatParent, "BackdropTemplate")
ItemsSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ItemsSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.itemEdge))
ItemsSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, 31)
ItemsSpellChatFrame.AddChatHeader:SetPoint("TOP", ItemsSpellChatFrameChatHeader, "BOTTOM", 0, -5)

ItemsSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "ItemsSpellChatFrameAddPhraseTextBox", ItemsSpellChatFrameAddChatHeader)
ItemsSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", ItemsSpellChatFrameAddChatHeader, "LEFT", 10, 0)
ItemsSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
ItemsSpellChatFrame.AddPhraseTextBox:SetSize(NumberList.scrollSpellFrameWidth - 40, 25)
ItemsSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
ItemsSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
ItemsSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
ItemsSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            if cursorLink ~= nil then
                print(cursorType, arg1, arg2, arg3)
                ItemsSpellChatFrame.AddPhraseTextBox:Insert(
                    getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3) .. " "
                )
                ItemsSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                ItemsSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
ItemsSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            if cursorLink ~= nil then
                ItemsSpellChatFrame.AddPhraseTextBox:Insert(
                    getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3) .. " "
                )
                ItemsSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                ItemsSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
ItemsSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = ItemsSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToItemChatList(chatPhrase)
            updateItemsSpellChatList()
            ItemsSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local ItemsChatScrollParent =
    CreateFrame("Frame", "ItemsChatScrollParent", ItemsSpellChatFrameChatParent, "BackdropTemplate")
ItemsChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ItemsChatScrollParent:SetBackdropBorderColor(unpack(ColourList.itemEdge))
ItemsChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
ItemsChatScrollParent:SetPoint("TOP", ItemsSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local ItemsChatScrollFrame =
    CreateFrame("ScrollFrame", "ItemsChatScrollFrame", ItemsChatScrollParent, "FauxScrollFrameTemplate")
ItemsChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
ItemsChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
ItemsChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateItemsSpellChatList
        )
    end
)

ItemsChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    ItemsChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, ItemsChatScrollParent, "OptionsListButtonTemplate")
    local button = ItemsChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentObjectPhrase = currentObjectList[self.index]
                clearCurrentItemSpellChat()
                updateItemsSpellChatList()
            end
        end
    )
end

ItemsSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "ItemsSpellChatFrameClearChatListButton",
    ItemsSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
ItemsSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
ItemsSpellChatFrame.ClearChatListButton:SetPoint("TOP", ItemsChatScrollParent, "BOTTOM", 0, -5)
ItemsSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
ItemsSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.itemEdge))
ItemsSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
ItemsSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
ItemsSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
ItemsSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
ItemsSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentItemChatList()
        updateItemsSpellChatList()
        ItemsSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Mounts frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local MountSpellChatFrame = CreateFrame("Frame", "MountSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
MountSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
MountSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
MountSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MountSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.mountEdge))

MountSpellChatFrame.AddMountButton =
    CreateFrame(
    "Button",
    "MountSpellChatFrameAddMountButton",
    MountSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
MountSpellChatFrame.AddMountButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
MountSpellChatFrame.AddMountButton:SetPoint("TOPLEFT", MountSpellChatFrame, "TOPLEFT", 9, -10)
MountSpellChatFrame.AddMountButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MountSpellChatFrame.AddMountButton:SetBackdropBorderColor(unpack(ColourList.mountEdge))
MountSpellChatFrame.AddMountButton:SetNormalFontObject(TextList.buttonFontObject)
MountSpellChatFrame.AddMountButton:SetHighlightFontObject(TextList.buttonFontObject)
MountSpellChatFrame.AddMountButton:SetText(TextList.addMountButtonText)
MountSpellChatFrame.AddMountButton:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2 = GetCursorInfo()
            masterAddObjectToList(cursorType, arg1, arg2)
        end
    end
)
MountSpellChatFrame.AddMountButton:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2 = GetCursorInfo()
            masterAddObjectToList(cursorType, arg1, arg2)
        end
    end
)

local MountSpellScrollParent =
    CreateFrame(
    "Button",
    "MountSpellScrollParent",
    MountSpellChatFrame,
    "BackdropTemplate",
    "TooltipBorderedFrameTemplate"
)
MountSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MountSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.mountEdge))
MountSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
MountSpellScrollParent:SetPoint("TOP", MountSpellChatFrameAddMountButton, "BOTTOM", 0, -5)

local MountSpellScrollFrame =
    CreateFrame("ScrollFrame", "MountSpellScrollFrame", MountSpellScrollParent, "FauxScrollFrameTemplate")
MountSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
MountSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
MountSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updateMountSpellList)
    end
)

MountSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    MountSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, MountSpellScrollParent, "OptionsListButtonTemplate")
    local button = MountSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentObjectLink = SpellChatMountList[self.index].mountLink
            VariableList.currentObjectID = SpellChatMountList[self.index].mountID
            VariableList.currentObjectPercentage = SpellChatMountList[self.index].percentage
            VariableList.currentObjectEnabled = SpellChatMountList[self.index].isEnabled
            loadMountHeader()
            updateMountSpellChatList()
        end
    )
end

MountSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "MountSpellChatFrameClearSpellListButton",
    MountSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
MountSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
MountSpellChatFrame.ClearSpellListButton:SetPoint("TOP", MountSpellScrollParent, "BOTTOM", 0, -4)
MountSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MountSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.mountEdge))
MountSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
MountSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
MountSpellChatFrame.ClearSpellListButton:SetText(TextList.clearMountListButtonText)
MountSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
MountSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(SpellChatMountList)
        clearCurrentMount()
        updateMountSpellList()
        updateMountSpellChatList()
        MountSpellChatFrame.AddPhraseTextBox:SetText("")
        MountSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

MountSpellChatFrame.ChatParent = CreateFrame("Frame", "MountSpellChatFrameChatParent", MountSpellChatFrame)
MountSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
MountSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", MountSpellChatFrame, "TOPRIGHT", -9, -10)
MountSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "MountSpellChatFrameChatHeader", MountSpellChatFrameChatParent, "BackdropTemplate")
MountSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MountSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.mountEdge))
MountSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
MountSpellChatFrame.ChatHeader:SetPoint("TOP", MountSpellChatFrameChatParent)
MountSpellChatFrame.TitleText = MountSpellChatFrame:CreateFontString("MyTestFrameTitleText")
MountSpellChatFrame.TitleText:SetPoint("TOPLEFT", MountSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
MountSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
MountSpellChatFrame.TitleText:SetText("")

MountSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "MountSpellChatFrameDeleteSpellButton", MountSpellChatFrameChatHeader)
MountSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", MountSpellChatFrameChatHeader, "RIGHT", -10, 0)
MountSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
MountSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
MountSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
MountSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentMount()
        updateMountSpellList()
        updateMountSpellChatList()
        MountSpellChatFrame.AddPhraseTextBox:SetText("")
        MountSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

MountSpellChatFrame.PercentageTextBox =
    CreateFrame(
    "EditBox",
    "MountSpellChatFramePercentageTextBox",
    MountSpellChatFrameChatHeader,
    "ChatConfigBoxTemplate"
)
MountSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", MountSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
MountSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
MountSpellChatFrame.PercentageTextBox:SetNumeric(true)
MountSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
MountSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
MountSpellChatFrame.PercentageTextBox:SetAutoFocus()
MountSpellChatFrame.PercentageTextBox:SetText("")
MountSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
MountSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(MountSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updateMountPercentage(percentageNumber)
    end
)

MountSpellChatFrame.PercentageText = MountSpellChatFrame:CreateFontString("MountSpellChatFramePercentageText")
MountSpellChatFrame.PercentageText:SetPoint("LEFT", MountSpellChatFramePercentageTextBox, "RIGHT")
MountSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
MountSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

MountSpellChatFrame.EnableCheckbox =
    CreateFrame(
    "CheckButton",
    "MountSpellChatFrameEnableCheckbox",
    MountSpellChatFrameChatHeader,
    "UICheckButtonTemplate"
)
MountSpellChatFrame.EnableCheckbox:ClearAllPoints()
MountSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    MountSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
MountSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
MountSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentObjectEnabled)
MountSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
MountSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
MountSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentObjectEnabled then
            VariableList.currentObjectEnabled = false
            updateMountEnabled()
        elseif not VariableList.currentObjectEnabled then
            VariableList.currentObjectEnabled = true
            updateMountEnabled()
        end
    end
)

MountSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "MountspellChatFrameAddChatHeader", MountSpellChatFrameChatParent, "BackdropTemplate")
MountSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MountSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.mountEdge))
MountSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, 31)
MountSpellChatFrame.AddChatHeader:SetPoint("TOP", MountSpellChatFrameChatHeader, "BOTTOM", 0, -5)

MountSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "MountSpellChatFrameAddPhraseTextBox", MountspellChatFrameAddChatHeader)
MountSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", MountspellChatFrameAddChatHeader, "LEFT", 10, 0)
MountSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
MountSpellChatFrame.AddPhraseTextBox:SetSize(NumberList.scrollSpellFrameWidth - 40, 25)
MountSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
MountSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
MountSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
MountSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            if cursorLink ~= nil then
                print(cursorType, arg1, arg2, arg3)
                MountSpellChatFrame.AddPhraseTextBox:Insert(
                    getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3) .. " "
                )
                MountSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                MountSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
MountSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            if cursorLink ~= nil then
                MountSpellChatFrame.AddPhraseTextBox:Insert(
                    getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3) .. " "
                )
                MountSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                MountSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
MountSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = MountSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToMountChatList(chatPhrase)
            updateMountSpellChatList()
            MountSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local MountChatScrollParent =
    CreateFrame("Frame", "MountChatScrollParent", MountSpellChatFrameChatParent, "BackdropTemplate")
MountChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MountChatScrollParent:SetBackdropBorderColor(unpack(ColourList.mountEdge))
MountChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
MountChatScrollParent:SetPoint("TOP", MountspellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local MountChatScrollFrame =
    CreateFrame("ScrollFrame", "MountChatScrollFrame", MountChatScrollParent, "FauxScrollFrameTemplate")
MountChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
MountChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
MountChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updateMountSpellChatList
        )
    end
)

MountChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    MountChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, MountChatScrollParent, "OptionsListButtonTemplate")
    local button = MountChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentObjectPhrase = currentObjectList[self.index]
                clearCurrentMountSpellChat()
                updateMountSpellChatList()
            end
        end
    )
end

MountSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "MountSpellChatFrameClearChatListButton",
    MountSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
MountSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
MountSpellChatFrame.ClearChatListButton:SetPoint("TOP", MountChatScrollParent, "BOTTOM", 0, -5)
MountSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
MountSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.mountEdge))
MountSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
MountSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
MountSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
MountSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
MountSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentMountChatList()
        updateMountSpellChatList()
        MountSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Pets frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local PetSpellChatFrame = CreateFrame("Frame", "PetSpellChatFrame", SpellChatInterfaceFrame, "BackdropTemplate")
PetSpellChatFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
PetSpellChatFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
PetSpellChatFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PetSpellChatFrame:SetBackdropBorderColor(unpack(ColourList.petEdge))

PetSpellChatFrame.AddPetButton =
    CreateFrame(
    "Button",
    "PetSpellChatFrameAddPetButton",
    PetSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
PetSpellChatFrame.AddPetButton:SetSize(NumberList.scrollFrameWidth, NumberList.chatHeaderHeight)
PetSpellChatFrame.AddPetButton:SetPoint("TOPLEFT", PetSpellChatFrame, "TOPLEFT", 9, -10)
PetSpellChatFrame.AddPetButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PetSpellChatFrame.AddPetButton:SetBackdropBorderColor(unpack(ColourList.petEdge))
PetSpellChatFrame.AddPetButton:SetNormalFontObject(TextList.buttonFontObject)
PetSpellChatFrame.AddPetButton:SetHighlightFontObject(TextList.buttonFontObject)
PetSpellChatFrame.AddPetButton:SetText(TextList.addPetButtonText)
PetSpellChatFrame.AddPetButton:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2 = GetCursorInfo()
            masterAddObjectToList(cursorType, arg1, arg2)
        end
    end
)
PetSpellChatFrame.AddPetButton:SetScript(
    "OnClick",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2 = GetCursorInfo()
            masterAddObjectToList(cursorType, arg1, arg2)
        end
    end
)

local PetSpellScrollParent =
    CreateFrame("Button", "PetSpellScrollParent", PetSpellChatFrame, "BackdropTemplate", "TooltipBorderedFrameTemplate")
PetSpellScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PetSpellScrollParent:SetBackdropBorderColor(unpack(ColourList.petEdge))
PetSpellScrollParent:SetSize(NumberList.scrollFrameWidth, NumberList.scrollFrameHeight)
PetSpellScrollParent:SetPoint("TOP", PetSpellChatFrameAddPetButton, "BOTTOM", 0, -5)

local PetSpellScrollFrame =
    CreateFrame("ScrollFrame", "PetSpellScrollFrame", PetSpellScrollParent, "FauxScrollFrameTemplate")
PetSpellScrollFrame:SetPoint("TOPLEFT", 0, -8)
PetSpellScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
PetSpellScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.spellItemScrollButtonHeight, updatePetSpellList)
    end
)

PetSpellScrollFrame.buttons = {}
for index = 1, NumberList.spellItemScrollButtonNumber do
    PetSpellScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, PetSpellScrollParent, "OptionsListButtonTemplate")
    local button = PetSpellScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self)
            VariableList.currentObjectLink = SpellChatPetList[self.index].petLink
            VariableList.currentObjectID = SpellChatPetList[self.index].petID
            VariableList.currentObjectPercentage = SpellChatPetList[self.index].percentage
            VariableList.currentObjectEnabled = SpellChatPetList[self.index].isEnabled
            loadPetHeader()
            updatePetSpellChatList()
        end
    )
end

PetSpellChatFrame.ClearSpellListButton =
    CreateFrame(
    "Button",
    "PetSpellChatFrameClearSpellListButton",
    PetSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
PetSpellChatFrame.ClearSpellListButton:SetSize(NumberList.scrollFrameWidth, NumberList.clearTargetListHeight)
PetSpellChatFrame.ClearSpellListButton:SetPoint("TOP", PetSpellScrollParent, "BOTTOM", 0, -4)
PetSpellChatFrame.ClearSpellListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PetSpellChatFrame.ClearSpellListButton:SetBackdropBorderColor(unpack(ColourList.petEdge))
PetSpellChatFrame.ClearSpellListButton:SetNormalFontObject(TextList.buttonFontObject)
PetSpellChatFrame.ClearSpellListButton:SetHighlightFontObject(TextList.buttonFontObject)
PetSpellChatFrame.ClearSpellListButton:SetText(TextList.clearPetListButtonText)
PetSpellChatFrame.ClearSpellListButton:RegisterForClicks("RightButtonUp")
PetSpellChatFrame.ClearSpellListButton:SetScript(
    "OnClick",
    function()
        wipe(SpellChatPetList)
        clearCurrentPet()
        updatePetSpellList()
        updatePetSpellChatList()
        PetSpellChatFrame.AddPhraseTextBox:SetText("")
        PetSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

PetSpellChatFrame.ChatParent = CreateFrame("Frame", "PetSpellChatFrameChatParent", PetSpellChatFrame)
PetSpellChatFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
PetSpellChatFrame.ChatParent:SetPoint("TOPRIGHT", PetSpellChatFrame, "TOPRIGHT", -9, -10)
PetSpellChatFrame.ChatHeader =
    CreateFrame("Frame", "PetSpellChatFrameChatHeader", PetSpellChatFrameChatParent, "BackdropTemplate")
PetSpellChatFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PetSpellChatFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.petEdge))
PetSpellChatFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
PetSpellChatFrame.ChatHeader:SetPoint("TOP", PetSpellChatFrameChatParent)
PetSpellChatFrame.TitleText = PetSpellChatFrame:CreateFontString("MyTestFrameTitleText")
PetSpellChatFrame.TitleText:SetPoint("TOPLEFT", PetSpellChatFrameChatHeader, "TOPLEFT", 10, -10)
PetSpellChatFrame.TitleText:SetFontObject(TextList.checkBoxFontObject)
PetSpellChatFrame.TitleText:SetText("")

PetSpellChatFrame.DeleteSpellButton =
    CreateFrame("Button", "PetSpellChatFrameDeleteSpellButton", PetSpellChatFrameChatHeader)
PetSpellChatFrame.DeleteSpellButton:SetPoint("RIGHT", PetSpellChatFrameChatHeader, "RIGHT", -10, 0)
PetSpellChatFrame.DeleteSpellButton:SetSize(NumberList.navButtonSize / 1.5, NumberList.navButtonSize / 1.5)
PetSpellChatFrame.DeleteSpellButton:SetNormalTexture(ImageList.removeSpellItemButton)
PetSpellChatFrame.DeleteSpellButton:SetHighlightTexture(ImageList.removeSpellItemButton, "BLEND")
PetSpellChatFrame.DeleteSpellButton:SetScript(
    "OnClick",
    function()
        clearCurrentPet()
        updatePetSpellList()
        updatePetSpellChatList()
        PetSpellChatFrame.AddPhraseTextBox:SetText("")
        PetSpellChatFrame.AddPhraseTextBox:ClearFocus()
    end
)

PetSpellChatFrame.PercentageTextBox =
    CreateFrame("EditBox", "PetSpellChatFramePercentageTextBox", PetSpellChatFrameChatHeader, "ChatConfigBoxTemplate")
PetSpellChatFrame.PercentageTextBox:SetPoint("BOTTOMLEFT", PetSpellChatFrameChatHeader, "BOTTOMLEFT", 10, 5)
PetSpellChatFrame.PercentageTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
PetSpellChatFrame.PercentageTextBox:SetNumeric(true)
PetSpellChatFrame.PercentageTextBox:SetSize(NumberList.percentageTextBoxWidth, NumberList.percentageTextBoxHeight)
PetSpellChatFrame.PercentageTextBox:SetMaxLetters(3)
PetSpellChatFrame.PercentageTextBox:SetAutoFocus()
PetSpellChatFrame.PercentageTextBox:SetText("")
PetSpellChatFrame.PercentageTextBox:SetJustifyH("CENTER")
PetSpellChatFrame.PercentageTextBox:SetScript(
    "OnEnterPressed",
    function(self)
        percentageNumber = tonumber(PetSpellChatFrame.PercentageTextBox:GetText())
        self:ClearFocus()
        updatePetPercentage(percentageNumber)
    end
)

PetSpellChatFrame.PercentageText = PetSpellChatFrame:CreateFontString("PetSpellChatFramePercentageText")
PetSpellChatFrame.PercentageText:SetPoint("LEFT", PetSpellChatFramePercentageTextBox, "RIGHT")
PetSpellChatFrame.PercentageText:SetFontObject(TextList.checkBoxSmallFontObject)
PetSpellChatFrame.PercentageText:SetText(TextList.chatFrequencyText)

PetSpellChatFrame.EnableCheckbox =
    CreateFrame("CheckButton", "PetSpellChatFrameEnableCheckbox", PetSpellChatFrameChatHeader, "UICheckButtonTemplate")
PetSpellChatFrame.EnableCheckbox:ClearAllPoints()
PetSpellChatFrame.EnableCheckbox:SetPoint(
    "LEFT",
    PetSpellChatFramePercentageText,
    "RIGHT",
    NumberList.enableCheckBoxSize,
    NumberList.checkEnableBottomGap
)
PetSpellChatFrame.EnableCheckbox:SetSize(NumberList.enableCheckBoxSize, NumberList.enableCheckBoxSize)
PetSpellChatFrame.EnableCheckbox:SetChecked(VariableList.currentObjectEnabled)
PetSpellChatFrame.EnableCheckbox.text:SetText(TextList.enableChatsText)
PetSpellChatFrame.EnableCheckbox.text:SetFontObject(TextList.checkBoxSmallFontObject)
PetSpellChatFrame.EnableCheckbox:SetScript(
    "OnClick",
    function(self)
        if VariableList.currentObjectEnabled then
            VariableList.currentObjectEnabled = false
            updatePetEnabled()
        elseif not VariableList.currentObjectEnabled then
            VariableList.currentObjectEnabled = true
            updatePetEnabled()
        end
    end
)

PetSpellChatFrame.AddChatHeader =
    CreateFrame("Frame", "PetSpellChatFrameAddChatHeader", PetSpellChatFrameChatParent, "BackdropTemplate")
PetSpellChatFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PetSpellChatFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.petEdge))
PetSpellChatFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, 31)
PetSpellChatFrame.AddChatHeader:SetPoint("TOP", PetSpellChatFrameChatHeader, "BOTTOM", 0, -5)

PetSpellChatFrame.AddPhraseTextBox =
    CreateFrame("EditBox", "PetSpellChatFrameAddPhraseTextBox", PetSpellChatFrameAddChatHeader)
PetSpellChatFrame.AddPhraseTextBox:SetPoint("LEFT", PetSpellChatFrameAddChatHeader, "LEFT", 10, 0)
PetSpellChatFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
PetSpellChatFrame.AddPhraseTextBox:SetSize(NumberList.scrollSpellFrameWidth - 40, 25)
PetSpellChatFrame.AddPhraseTextBox:SetMaxLetters(100)
PetSpellChatFrame.AddPhraseTextBox:SetAutoFocus(false)
PetSpellChatFrame.AddPhraseTextBox:SetJustifyH("LEFT")
PetSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            if cursorLink ~= nil then
                print(cursorType, arg1, arg2, arg3)
                PetSpellChatFrame.AddPhraseTextBox:Insert(
                    getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3) .. " "
                )
                PetSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                PetSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
PetSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            if cursorLink ~= nil then
                PetSpellChatFrame.AddPhraseTextBox:Insert(
                    getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3) .. " "
                )
                PetSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                PetSpellChatFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
PetSpellChatFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = PetSpellChatFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            addChatStringToPetChatList(chatPhrase)
            updatePetSpellChatList()
            PetSpellChatFrame.AddPhraseTextBox:SetText("")
        end
    end
)

local PetChatScrollParent = CreateFrame("Frame", "PetChatScrollParent", PetSpellChatFrameChatParent, "BackdropTemplate")
PetChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PetChatScrollParent:SetBackdropBorderColor(unpack(ColourList.petEdge))
PetChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatScrollParentHeight)
PetChatScrollParent:SetPoint("TOP", PetSpellChatFrameAddChatHeader, "BOTTOM", 0, -5)

local PetChatScrollFrame =
    CreateFrame("ScrollFrame", "PetChatScrollFrame", PetChatScrollParent, "FauxScrollFrameTemplate")
PetChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
PetChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
PetChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(
            self,
            offset,
            NumberList.spellItemChatScrollButtonHeight,
            updatePetSpellChatList
        )
    end
)

PetChatScrollFrame.buttons = {}
for index = 1, NumberList.spellItemChatScrollButtonNumber do
    PetChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, PetChatScrollParent, "OptionsListButtonTemplate")
    local button = PetChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentObjectPhrase = currentObjectList[self.index]
                clearCurrentPetSpellChat()
                updatePetSpellChatList()
            end
        end
    )
end

PetSpellChatFrame.ClearChatListButton =
    CreateFrame(
    "Button",
    "PetSpellChatFrameClearChatListButton",
    PetSpellChatFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
PetSpellChatFrame.ClearChatListButton:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
PetSpellChatFrame.ClearChatListButton:SetPoint("TOP", PetChatScrollParent, "BOTTOM", 0, -5)
PetSpellChatFrame.ClearChatListButton:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = true,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
PetSpellChatFrame.ClearChatListButton:SetBackdropBorderColor(unpack(ColourList.petEdge))
PetSpellChatFrame.ClearChatListButton:SetNormalFontObject(TextList.buttonFontObject)
PetSpellChatFrame.ClearChatListButton:SetHighlightFontObject(TextList.buttonFontObject)
PetSpellChatFrame.ClearChatListButton:SetText(TextList.clearChatListButtonText)
PetSpellChatFrame.ClearChatListButton:RegisterForClicks("RightButtonUp")
PetSpellChatFrame.ClearChatListButton:SetScript(
    "OnClick",
    function()
        clearCurrentPetChatList()
        updatePetSpellChatList()
        PetSpellChatFrame.AddPhraseTextBox:SetText("")
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         Hand wave frame          ===========================
-- ===================================================================================================
-- ===================================================================================================

local HandWaveFrame = CreateFrame("Frame", "HandWaveFrame", SpellChatInterfaceFrame, "BackdropTemplate")
HandWaveFrame:SetSize(NumberList.classFrameWidth, NumberList.classFrameHeight)
HandWaveFrame:SetPoint("BOTTOM", SpellChatInterfaceFrame, "BOTTOM", 0, NumberList.spellChatFrameBottomGap)
HandWaveFrame:SetBackdrop(
    {
        bgFile = nil,
        insets = {
            left = NumberList.insetSize,
            right = NumberList.insetSize,
            top = NumberList.insetSize,
            bottom = NumberList.insetSize
        },
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame:SetBackdropBorderColor(unpack(ColourList.spellChatEdge))

HandWaveFrame.GuildHello =
    CreateFrame("Button", "HandWaveFrameGuildHello", HandWaveFrame, "BackdropTemplate", "UIMenuButtonStretchTemplate")
HandWaveFrame.GuildHello:SetSize(NumberList.scrollFrameWidth, NumberList.handWaveSelectChatButtonHeight)
HandWaveFrame.GuildHello:SetPoint("TOPLEFT", HandWaveFrame, "TOPLEFT", 9, -10)
HandWaveFrame.GuildHello:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.GuildHello:SetBackdropBorderColor(unpack(ColourList.guildEdge))
HandWaveFrame.GuildHello:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.GuildHello:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.GuildHello:SetText(TextList.guildHelloButtonText)
HandWaveFrame.GuildHello:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        HandWaveFrame.AddPhraseTextBox:SetFocus(true)
        VariableList.currentHandWaveChatList = SpellChatGuildHelloList
        HandWaveFrame.TitleText:SetText(TextList.guildHelloButtonText)
        HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.guildEdge))
        HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.guildEdge))
        HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.guildEdge))
        updateCurrentHandWaveList()
    end
)

HandWaveFrame.GuildGoodbye =
    CreateFrame("Button", "HandWaveFrameGuildGoodbye", HandWaveFrame, "BackdropTemplate", "UIMenuButtonStretchTemplate")
HandWaveFrame.GuildGoodbye:SetSize(NumberList.scrollFrameWidth, NumberList.handWaveSelectChatButtonHeight)
HandWaveFrame.GuildGoodbye:SetPoint("TOP", HandWaveFrameGuildHello, "BOTTOM", 0, NumberList.handWaveSelectChatButtonGap)
HandWaveFrame.GuildGoodbye:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.GuildGoodbye:SetBackdropBorderColor(unpack(ColourList.guildEdge))
HandWaveFrame.GuildGoodbye:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.GuildGoodbye:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.GuildGoodbye:SetText(TextList.guildGoodbyeButtonText)
HandWaveFrame.GuildGoodbye:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        HandWaveFrame.AddPhraseTextBox:SetFocus(true)
        VariableList.currentHandWaveChatList = SpellChatGuildGoodbyeList
        HandWaveFrame.TitleText:SetText(TextList.guildGoodbyeButtonText)
        HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.guildEdge))
        HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.guildEdge))
        HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.guildEdge))
        updateCurrentHandWaveList()
    end
)

HandWaveFrame.GroupHello =
    CreateFrame("Button", "HandWaveFrameGroupHello", HandWaveFrame, "BackdropTemplate", "UIMenuButtonStretchTemplate")
HandWaveFrame.GroupHello:SetSize(NumberList.scrollFrameWidth, NumberList.handWaveSelectChatButtonHeight)
HandWaveFrame.GroupHello:SetPoint(
    "TOP",
    HandWaveFrameGuildGoodbye,
    "BOTTOM",
    0,
    NumberList.handWaveSelectChatButtonGap * 2
)
HandWaveFrame.GroupHello:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.GroupHello:SetBackdropBorderColor(unpack(ColourList.groupEdge))
HandWaveFrame.GroupHello:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.GroupHello:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.GroupHello:SetText(TextList.groupHelloButtonText)
HandWaveFrame.GroupHello:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        HandWaveFrame.AddPhraseTextBox:SetFocus(true)
        VariableList.currentHandWaveChatList = SpellChatGroupHelloList
        HandWaveFrame.TitleText:SetText(TextList.groupHelloButtonText)
        HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.groupEdge))
        HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.groupEdge))
        HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.groupEdge))
        updateCurrentHandWaveList()
    end
)

HandWaveFrame.GroupGoodbye =
    CreateFrame("Button", "HandWaveFrameGroupGoodbye", HandWaveFrame, "BackdropTemplate", "UIMenuButtonStretchTemplate")
HandWaveFrame.GroupGoodbye:SetSize(NumberList.scrollFrameWidth, NumberList.handWaveSelectChatButtonHeight)
HandWaveFrame.GroupGoodbye:SetPoint("TOP", HandWaveFrameGroupHello, "BOTTOM", 0, NumberList.handWaveSelectChatButtonGap)
HandWaveFrame.GroupGoodbye:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.GroupGoodbye:SetBackdropBorderColor(unpack(ColourList.groupEdge))
HandWaveFrame.GroupGoodbye:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.GroupGoodbye:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.GroupGoodbye:SetText(TextList.groupGoodbyeButtonText)
HandWaveFrame.GroupGoodbye:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        HandWaveFrame.AddPhraseTextBox:SetFocus(true)
        VariableList.currentHandWaveChatList = SpellChatGroupGoodbyeList
        HandWaveFrame.TitleText:SetText(TextList.groupGoodbyeButtonText)
        HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.groupEdge))
        HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.groupEdge))
        HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.groupEdge))
        updateCurrentHandWaveList()
    end
)

HandWaveFrame.generalChat1 =
    CreateFrame("Button", "HandWaveFrameGeneralHello", HandWaveFrame, "BackdropTemplate", "UIMenuButtonStretchTemplate")
HandWaveFrame.generalChat1:SetSize(NumberList.scrollFrameWidth, NumberList.handWaveSelectChatButtonHeight)
HandWaveFrame.generalChat1:SetPoint(
    "TOP",
    HandWaveFrameGroupGoodbye,
    "BOTTOM",
    0,
    NumberList.handWaveSelectChatButtonGap * 2
)
HandWaveFrame.generalChat1:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.generalChat1:SetBackdropBorderColor(unpack(ColourList.generalEdge))
HandWaveFrame.generalChat1:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.generalChat1:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.generalChat1:SetText(TextList.generalChat1ChannelButtonText)
HandWaveFrame.generalChat1:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        HandWaveFrame.AddPhraseTextBox:SetFocus(true)
        VariableList.currentHandWaveChatList = SpellChatGeneral1List
        HandWaveFrame.TitleText:SetText(TextList.generalChat1ChannelButtonText)
        HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.generalEdge))
        HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.generalEdge))
        HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.generalEdge))
        updateCurrentHandWaveList()
    end
)

HandWaveFrame.generalChat2 =
    CreateFrame("Button", "HandWaveFramegeneralChat2", HandWaveFrame, "BackdropTemplate", "UIMenuButtonStretchTemplate")
HandWaveFrame.generalChat2:SetSize(NumberList.scrollFrameWidth, NumberList.handWaveSelectChatButtonHeight)
HandWaveFrame.generalChat2:SetPoint(
    "TOP",
    HandWaveFrameGeneralHello,
    "BOTTOM",
    0,
    NumberList.handWaveSelectChatButtonGap
)
HandWaveFrame.generalChat2:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.generalChat2:SetBackdropBorderColor(unpack(ColourList.generalEdge))
HandWaveFrame.generalChat2:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.generalChat2:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.generalChat2:SetText(TextList.generalChat2ChannelButtonText)
HandWaveFrame.generalChat2:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        HandWaveFrame.AddPhraseTextBox:SetFocus(true)
        VariableList.currentHandWaveChatList = SpellChatGeneral2List
        HandWaveFrame.TitleText:SetText(TextList.generalChat2ChannelButtonText)
        HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.generalEdge))
        HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.generalEdge))
        HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.generalEdge))
        updateCurrentHandWaveList()
    end
)

HandWaveFrame.tradeChat =
    CreateFrame("Button", "HandWaveFrametradeChat", HandWaveFrame, "BackdropTemplate", "UIMenuButtonStretchTemplate")
HandWaveFrame.tradeChat:SetSize(NumberList.scrollFrameWidth, NumberList.handWaveSelectChatButtonHeight)
HandWaveFrame.tradeChat:SetPoint(
    "TOP",
    HandWaveFramegeneralChat2,
    "BOTTOM",
    0,
    NumberList.handWaveSelectChatButtonGap * 2
)
HandWaveFrame.tradeChat:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.tradeChat:SetBackdropBorderColor(unpack(ColourList.tradeEdge))
HandWaveFrame.tradeChat:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.tradeChat:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.tradeChat:SetText(TextList.tradeChatChannelButtonText)
HandWaveFrame.tradeChat:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        HandWaveFrame.AddPhraseTextBox:SetFocus(true)
        VariableList.currentHandWaveChatList = SpellChatTradeList
        HandWaveFrame.TitleText:SetText(TextList.tradeChatChannelButtonText)
        HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.tradeEdge))
        HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.tradeEdge))
        HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.tradeEdge))
        updateCurrentHandWaveList()
    end
)

HandWaveFrame.lfgChat =
    CreateFrame("Button", "HandWaveFramelfgChat", HandWaveFrame, "BackdropTemplate", "UIMenuButtonStretchTemplate")
HandWaveFrame.lfgChat:SetSize(NumberList.scrollFrameWidth, NumberList.handWaveSelectChatButtonHeight)
HandWaveFrame.lfgChat:SetPoint("TOP", HandWaveFrametradeChat, "BOTTOM", 0, NumberList.handWaveSelectChatButtonGap)
HandWaveFrame.lfgChat:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.lfgChat:SetBackdropBorderColor(unpack(ColourList.lfgEdge))
HandWaveFrame.lfgChat:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.lfgChat:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.lfgChat:SetText(TextList.lfgChatChannelButtonText)
HandWaveFrame.lfgChat:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        HandWaveFrame.AddPhraseTextBox:SetFocus(true)
        VariableList.currentHandWaveChatList = SpellChatLFGList
        HandWaveFrame.TitleText:SetText(TextList.lfgChatChannelButtonText)
        HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.lfgEdge))
        HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.lfgEdge))
        HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.lfgEdge))
        updateCurrentHandWaveList()
    end
)

HandWaveFrame.sayChat =
    CreateFrame("Button", "HandWaveFramesayChat", HandWaveFrame, "BackdropTemplate", "UIMenuButtonStretchTemplate")
HandWaveFrame.sayChat:SetSize(NumberList.scrollFrameWidth, NumberList.handWaveSelectChatButtonHeight)
HandWaveFrame.sayChat:SetPoint("TOP", HandWaveFramelfgChat, "BOTTOM", 0, NumberList.handWaveSelectChatButtonGap * 2)
HandWaveFrame.sayChat:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.sayChat:SetBackdropBorderColor(unpack(ColourList.sayEdge))
HandWaveFrame.sayChat:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.sayChat:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.sayChat:SetText(TextList.sayChatChannelButtonText)
HandWaveFrame.sayChat:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        HandWaveFrame.AddPhraseTextBox:SetFocus(true)
        VariableList.currentHandWaveChatList = SpellChatSayList
        HandWaveFrame.TitleText:SetText(TextList.sayChatChannelButtonText)
        HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.sayEdge))
        HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.sayEdge))
        HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.sayEdge))
        updateCurrentHandWaveList()
    end
)

HandWaveFrame.yellChat =
    CreateFrame("Button", "HandWaveFrameyellChat", HandWaveFrame, "BackdropTemplate", "UIMenuButtonStretchTemplate")
HandWaveFrame.yellChat:SetSize(NumberList.scrollFrameWidth, NumberList.handWaveSelectChatButtonHeight)
HandWaveFrame.yellChat:SetPoint("TOP", HandWaveFramesayChat, "BOTTOM", 0, NumberList.handWaveSelectChatButtonGap)
HandWaveFrame.yellChat:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.yellChat:SetBackdropBorderColor(unpack(ColourList.yellEdge))
HandWaveFrame.yellChat:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.yellChat:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.yellChat:SetText(TextList.yellChatChannelButtonText)
HandWaveFrame.yellChat:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        HandWaveFrame.AddPhraseTextBox:SetFocus(true)
        VariableList.currentHandWaveChatList = SpellChatYellList
        HandWaveFrame.TitleText:SetText(TextList.yellChatChannelButtonText)
        HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.yellEdge))
        HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.yellEdge))
        HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.yellEdge))
        updateCurrentHandWaveList()
    end
)

HandWaveFrame.ChatParent = CreateFrame("Frame", "HandWaveFrameChatParent", HandWaveFrame)
HandWaveFrame.ChatParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.scrollSpellFrameHight)
HandWaveFrame.ChatParent:SetPoint("TOPRIGHT", HandWaveFrame, "TOPRIGHT", -9, -10)
HandWaveFrame.ChatHeader = CreateFrame("Frame", "HandWaveFrameChatHeader", HandWaveFrameChatParent, "BackdropTemplate")
HandWaveFrame.ChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.ChatHeader:SetBackdropBorderColor(unpack(ColourList.spellChatEdge))
HandWaveFrame.ChatHeader:SetSize(NumberList.scrollSpellFrameWidth, NumberList.chatHeaderHeight)
HandWaveFrame.ChatHeader:SetPoint("TOP", HandWaveFrameChatParent)
HandWaveFrame.TitleText = HandWaveFrame:CreateFontString("MyTestFrameTitleText")
HandWaveFrame.TitleText:SetPoint("CENTER", HandWaveFrameChatHeader)
HandWaveFrame.TitleText:SetFontObject(TextList.handTitleFontObject)
HandWaveFrame.TitleText:SetText("")

HandWaveFrame.AddChatHeader =
    CreateFrame("Frame", "HandWaveFrameAddChatHeader", HandWaveFrameChatParent, "BackdropTemplate")
HandWaveFrame.AddChatHeader:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.AddChatHeader:SetBackdropBorderColor(unpack(ColourList.spellChatEdge))
HandWaveFrame.AddChatHeader:SetSize(NumberList.scrollSpellFrameWidth, 31)
HandWaveFrame.AddChatHeader:SetPoint("TOP", HandWaveFrameChatHeader, "BOTTOM", 0, -5)

HandWaveFrame.AddPhraseTextBox = CreateFrame("EditBox", "HandWaveFrameAddPhraseTextBox", HandWaveFrameAddChatHeader)
HandWaveFrame.AddPhraseTextBox:SetPoint("LEFT", HandWaveFrameAddChatHeader, "LEFT", 10, 0)
HandWaveFrame.AddPhraseTextBox:SetFontObject(TextList.checkBoxSmallFontObject)
HandWaveFrame.AddPhraseTextBox:SetSize(NumberList.scrollSpellFrameWidth - 40, 25)
HandWaveFrame.AddPhraseTextBox:SetMaxLetters(100)
HandWaveFrame.AddPhraseTextBox:SetAutoFocus(false)
HandWaveFrame.AddPhraseTextBox:SetJustifyH("LEFT")
HandWaveFrame.AddPhraseTextBox:SetScript(
    "OnReceiveDrag",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                HandWaveFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                HandWaveFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                HandWaveFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
HandWaveFrame.AddPhraseTextBox:SetScript(
    "OnMouseDown",
    function()
        if GetCursorInfo() then
            cursorType, arg1, arg2, arg3 = GetCursorInfo()
            cursorLink = getCursorLinkForCurrentPhrase(cursorType, arg1, arg2, arg3)
            if cursorLink ~= nil then
                HandWaveFrame.AddPhraseTextBox:Insert(cursorLink .. " ")
                HandWaveFrame.AddPhraseTextBox:SetAutoFocus(true)
            else
                HandWaveFrame.AddPhraseTextBox:SetAutoFocus(true)
            end
        end
        ClearCursor()
    end
)
HandWaveFrame.AddPhraseTextBox:SetScript(
    "OnEnterPressed",
    function()
        chatPhrase = HandWaveFrame.AddPhraseTextBox:GetText()
        if chatPhrase ~= "" then
            table.insert(VariableList.currentHandWaveChatList, 1, chatPhrase)
            HandWaveFrame.AddPhraseTextBox:SetText("")
            updateCurrentHandWaveList()
        end
    end
)

local HandWaveChatScrollParent =
    CreateFrame("Frame", "HandWaveChatScrollParent", HandWaveFrameChatParent, "BackdropTemplate")
HandWaveChatScrollParent:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = false,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveChatScrollParent:SetBackdropBorderColor(unpack(ColourList.spellChatEdge))
HandWaveChatScrollParent:SetSize(NumberList.scrollSpellFrameWidth, NumberList.handWaveScrollFrameHeight)
HandWaveChatScrollParent:SetPoint("TOP", HandWaveFrameAddChatHeader, "BOTTOM", 0, -5)

local HandWaveChatScrollFrame =
    CreateFrame("ScrollFrame", "HandWaveChatScrollFrame", HandWaveChatScrollParent, "FauxScrollFrameTemplate")
HandWaveChatScrollFrame:SetPoint("TOPLEFT", 0, -8)
HandWaveChatScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
HandWaveChatScrollFrame:SetScript(
    "OnVerticalScroll",
    function(self, offset)
        FauxScrollFrame_OnVerticalScroll(self, offset, NumberList.handWaveScrollButtonHeight, updateCurrentHandWaveList)
    end
)

HandWaveChatScrollFrame.buttons = {}
for index = 1, NumberList.handWaveScrollButtonNumber do
    HandWaveChatScrollFrame.buttons[index] =
        CreateFrame("Button", "$parentbtn" .. index, HandWaveChatScrollParent, "OptionsListButtonTemplate")
    local button = HandWaveChatScrollFrame.buttons[index]
    button:SetNormalFontObject(TextList.checkBoxSmallFontObject)
    button:SetHighlightFontObject(TextList.checkBoxSmallFontObject)
    button:SetSize(NumberList.scrollSpellFrameWidth, NumberList.phraseTextButtonHeight)
    button:SetPoint("TOPLEFT", 8, -(index - 1) * NumberList.phraseTextButtonHeight - 8)
    button:SetScript(
        "OnClick",
        function(self, button)
            if button == "RightButton" then
                VariableList.currentHandWaveChatPhrase = VariableList.currentHandWaveChatList[self.index]
                clearCurrentHandWaveChatPhrase()
                updateCurrentHandWaveList()
            end
        end
    )
end

HandWaveFrame.HandClearCurrentList =
    CreateFrame(
    "Button",
    "HandWaveFrameHandClearCurrentList",
    HandWaveFrame,
    "BackdropTemplate",
    "UIMenuButtonStretchTemplate"
)
HandWaveFrame.HandClearCurrentList:SetSize(NumberList.scrollSpellFrameWidth, NumberList.clearTargetListHeight)
HandWaveFrame.HandClearCurrentList:SetPoint("TOP", HandWaveChatScrollParent, "BOTTOM", 0, -4)
HandWaveFrame.HandClearCurrentList:SetBackdrop(
    {
        bgFile = nil,
        insets = nil,
        tileSize = nil,
        tile = nil,
        edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = NumberList.edgeSize
    }
)
HandWaveFrame.HandClearCurrentList:SetBackdropBorderColor(unpack(ColourList.spellChatEdge))
HandWaveFrame.HandClearCurrentList:SetNormalFontObject(TextList.buttonFontObject)
HandWaveFrame.HandClearCurrentList:SetHighlightFontObject(TextList.buttonFontObject)
HandWaveFrame.HandClearCurrentList:SetText(TextList.clearCurrentListText)
HandWaveFrame.HandClearCurrentList:RegisterForClicks("RightButtonUp")
HandWaveFrame.HandClearCurrentList:SetScript(
    "OnClick",
    function()
        HandWaveFrame.AddPhraseTextBox:SetText("")
        wipe(VariableList.currentHandWaveChatList)
        updateCurrentHandWaveList()
    end
)
--]]
-- ===================================================================================================
-- ===================================================================================================
-- ===========================         hand button grid          ===========================
-- ===================================================================================================
-- ===================================================================================================

local HandWaveButtonGridFrame = CreateFrame("Frame", "HandWaveButtonGridFrame", UIParent)
HandWaveButtonGridFrame:ClearAllPoints()
HandWaveButtonGridFrame:SetPoint("TOPLEFT", SpellChatInterfaceFrame, "TOPRIGHT")
HandWaveButtonGridFrame:SetClampedToScreen(true)
HandWaveButtonGridFrame:SetMovable(true)

HandWaveButtonGridFrame.guildButtons =
    CreateFrame("Button", "HandWaveButtonGridFrameguildButtons", HandWaveButtonGridFrame)
HandWaveButtonGridFrame.guildButtons:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
HandWaveButtonGridFrame.guildButtons:SetNormalTexture(ImageList.guildHelloButton)
HandWaveButtonGridFrame.guildButtons:SetHighlightTexture(ImageList.guildHelloButtonH, "ADD")
HandWaveButtonGridFrame.guildButtons:RegisterForDrag("MiddleButton")
HandWaveButtonGridFrame.guildButtons:RegisterForClicks("RightButtonUp", "LeftButtonUp")
--HandWaveButtonGridFrame.guildButtons:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
HandWaveButtonGridFrame.guildButtons:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            SPCTRUNGUILDHELLOCHATFUNCTION()
        end
    end
)
HandWaveButtonGridFrame.guildButtons:SetScript(
    "OnDragStart",
    function()
        HandWaveButtonGridFrame.guildButtons:GetParent():StartMoving()
    end
)
HandWaveButtonGridFrame.guildButtons:SetScript(
    "OnDragStop",
    function()
        HandWaveButtonGridFrame.guildButtons:GetParent():StopMovingOrSizing()
    end
)
HandWaveButtonGridFrame.guildButtons:SetScript(
    "OnEnter",
    function()
        HandWaveButtonGridFrame.guildButtons:SetAlpha(1)
    end
)
HandWaveButtonGridFrame.guildButtons:SetScript(
    "OnLeave",
    function()
        HandWaveButtonGridFrame.guildButtons:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
    end
)

HandWaveButtonGridFrame.guildButtons2 =
    CreateFrame("Button", "HandWaveButtonGridFrameguildButtons2", HandWaveButtonGridFrame)
HandWaveButtonGridFrame.guildButtons2:SetPoint("TOP", HandWaveButtonGridFrameguildButtons, "BOTTOM")
HandWaveButtonGridFrame.guildButtons2:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
HandWaveButtonGridFrame.guildButtons2:SetNormalTexture(ImageList.guildGoodbyeButton)
HandWaveButtonGridFrame.guildButtons2:SetHighlightTexture(ImageList.guildGoodbyeButtonH, "BLEND")
HandWaveButtonGridFrame.guildButtons2:RegisterForDrag("MiddleButton")
HandWaveButtonGridFrame.guildButtons2:RegisterForClicks("RightButtonUp", "LeftButtonUp")
HandWaveButtonGridFrame.guildButtons2:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            SPCTRUNGUILDGOODBYECHATFUNCTION()
        end
    end
)
HandWaveButtonGridFrame.guildButtons2:SetScript(
    "OnDragStart",
    function()
        HandWaveButtonGridFrame.guildButtons2:GetParent():StartMoving()
    end
)
HandWaveButtonGridFrame.guildButtons2:SetScript(
    "OnDragStop",
    function()
        HandWaveButtonGridFrame.guildButtons2:GetParent():StopMovingOrSizing()
    end
)
HandWaveButtonGridFrame.guildButtons2:SetScript(
    "OnEnter",
    function()
        HandWaveButtonGridFrame.guildButtons2:SetAlpha(1)
    end
)
HandWaveButtonGridFrame.guildButtons2:SetScript(
    "OnLeave",
    function()
        HandWaveButtonGridFrame.guildButtons2:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
    end
)

HandWaveButtonGridFrame.groupButtons =
    CreateFrame("Button", "HandWaveButtonGridFramegroupButtons", HandWaveButtonGridFrame)
HandWaveButtonGridFrame.groupButtons:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
HandWaveButtonGridFrame.groupButtons:SetNormalTexture(ImageList.groupHelloButton)
HandWaveButtonGridFrame.groupButtons:SetHighlightTexture(ImageList.groupHelloButtonH, "BLEND")
HandWaveButtonGridFrame.groupButtons:RegisterForDrag("MiddleButton")
HandWaveButtonGridFrame.groupButtons:RegisterForClicks("RightButtonUp", "LeftButtonUp")
HandWaveButtonGridFrame.groupButtons:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            SPCTRUNGROUPHELLOCHATFUNCTION()
        end
    end
)
HandWaveButtonGridFrame.groupButtons:SetScript(
    "OnDragStart",
    function()
        HandWaveButtonGridFrame.groupButtons:GetParent():StartMoving()
    end
)
HandWaveButtonGridFrame.groupButtons:SetScript(
    "OnDragStop",
    function()
        HandWaveButtonGridFrame.groupButtons:GetParent():StopMovingOrSizing()
    end
)
HandWaveButtonGridFrame.groupButtons:SetScript(
    "OnEnter",
    function()
        HandWaveButtonGridFrame.groupButtons:SetAlpha(1)
    end
)
HandWaveButtonGridFrame.groupButtons:SetScript(
    "OnLeave",
    function()
        HandWaveButtonGridFrame.groupButtons:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
    end
)

HandWaveButtonGridFrame.groupButtons2 =
    CreateFrame("Button", "HandWaveButtonGridFramegroupButtons2", HandWaveButtonGridFrame)
HandWaveButtonGridFrame.groupButtons2:SetPoint("TOP", HandWaveButtonGridFramegroupButtons, "BOTTOM")
HandWaveButtonGridFrame.groupButtons2:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
HandWaveButtonGridFrame.groupButtons2:SetNormalTexture(ImageList.groupGoodbyeButton)
HandWaveButtonGridFrame.groupButtons2:SetHighlightTexture(ImageList.groupGoodbyeButtonH, "BLEND")
HandWaveButtonGridFrame.groupButtons2:RegisterForDrag("MiddleButton")
HandWaveButtonGridFrame.groupButtons2:RegisterForClicks("RightButtonUp", "LeftButtonUp")
HandWaveButtonGridFrame.groupButtons2:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            SPCTRUNGROUPGOODBYECHATFUNCTION()
        end
    end
)
HandWaveButtonGridFrame.groupButtons2:SetScript(
    "OnDragStart",
    function()
        HandWaveButtonGridFrame.groupButtons2:GetParent():StartMoving()
    end
)
HandWaveButtonGridFrame.groupButtons2:SetScript(
    "OnDragStop",
    function()
        HandWaveButtonGridFrame.groupButtons2:GetParent():StopMovingOrSizing()
    end
)
HandWaveButtonGridFrame.groupButtons2:SetScript(
    "OnEnter",
    function()
        HandWaveButtonGridFrame.groupButtons2:SetAlpha(1)
    end
)
HandWaveButtonGridFrame.groupButtons2:SetScript(
    "OnLeave",
    function()
        HandWaveButtonGridFrame.groupButtons2:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
    end
)

HandWaveButtonGridFrame.generalButtons =
    CreateFrame("Button", "HandWaveButtonGridFramegeneralButtons", HandWaveButtonGridFrame)
HandWaveButtonGridFrame.generalButtons:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
HandWaveButtonGridFrame.generalButtons:SetNormalTexture(ImageList.generalChat1Button)
HandWaveButtonGridFrame.generalButtons:SetHighlightTexture(ImageList.generalChat1ButtonH, "BLEND")
HandWaveButtonGridFrame.generalButtons:RegisterForDrag("MiddleButton")
HandWaveButtonGridFrame.generalButtons:RegisterForClicks("RightButtonUp", "LeftButtonUp")
HandWaveButtonGridFrame.generalButtons:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            SPCTRUNGENERALCHANNELCHAT1FUNCTION()
        end
    end
)
HandWaveButtonGridFrame.generalButtons:SetScript(
    "OnDragStart",
    function()
        HandWaveButtonGridFrame.generalButtons:GetParent():StartMoving()
    end
)
HandWaveButtonGridFrame.generalButtons:SetScript(
    "OnDragStop",
    function()
        HandWaveButtonGridFrame.generalButtons:GetParent():StopMovingOrSizing()
    end
)
HandWaveButtonGridFrame.generalButtons:SetScript(
    "OnEnter",
    function()
        HandWaveButtonGridFrame.generalButtons:SetAlpha(1)
    end
)
HandWaveButtonGridFrame.generalButtons:SetScript(
    "OnLeave",
    function()
        HandWaveButtonGridFrame.generalButtons:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
    end
)

HandWaveButtonGridFrame.generalButtons2 =
    CreateFrame("Button", "HandWaveButtonGridFramegeneralButtons2", HandWaveButtonGridFrame)
HandWaveButtonGridFrame.generalButtons2:SetPoint("TOP", HandWaveButtonGridFramegeneralButtons, "BOTTOM")
HandWaveButtonGridFrame.generalButtons2:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
HandWaveButtonGridFrame.generalButtons2:SetNormalTexture(ImageList.generalChat2Button)
HandWaveButtonGridFrame.generalButtons2:SetHighlightTexture(ImageList.generalChat2ButtonH, "BLEND")
HandWaveButtonGridFrame.generalButtons2:RegisterForDrag("MiddleButton")
HandWaveButtonGridFrame.generalButtons2:RegisterForClicks("RightButtonUp", "LeftButtonUp")
HandWaveButtonGridFrame.generalButtons2:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            SPCTRUNGENERALCHANNELCHAT2FUNCTION()
        end
    end
)
HandWaveButtonGridFrame.generalButtons2:SetScript(
    "OnDragStart",
    function()
        HandWaveButtonGridFrame.generalButtons2:GetParent():StartMoving()
    end
)
HandWaveButtonGridFrame.generalButtons2:SetScript(
    "OnDragStop",
    function()
        HandWaveButtonGridFrame.generalButtons2:GetParent():StopMovingOrSizing()
    end
)
HandWaveButtonGridFrame.generalButtons2:SetScript(
    "OnEnter",
    function()
        HandWaveButtonGridFrame.generalButtons2:SetAlpha(1)
    end
)
HandWaveButtonGridFrame.generalButtons2:SetScript(
    "OnLeave",
    function()
        HandWaveButtonGridFrame.generalButtons2:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
    end
)

HandWaveButtonGridFrame.tradeButton =
    CreateFrame("Button", "HandWaveButtonGridFrametradeLFGButtons", HandWaveButtonGridFrame)
HandWaveButtonGridFrame.tradeButton:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
HandWaveButtonGridFrame.tradeButton:SetNormalTexture(ImageList.tradeChatButton)
HandWaveButtonGridFrame.tradeButton:SetHighlightTexture(ImageList.tradeChatButtonH, "BLEND")
HandWaveButtonGridFrame.tradeButton:RegisterForDrag("MiddleButton")
HandWaveButtonGridFrame.tradeButton:RegisterForClicks("RightButtonUp", "LeftButtonUp")
HandWaveButtonGridFrame.tradeButton:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            if GetChannelName(2) == 2 then -- check if trade chat is available in this zone
                SPCTRUNTRADECHANNELCHATFUNCTION()
            else
                printErrorMessages("errorTradeChatNotAvailable")
            end
        end
    end
)
HandWaveButtonGridFrame.tradeButton:SetScript(
    "OnDragStart",
    function()
        HandWaveButtonGridFrame.tradeButton:GetParent():StartMoving()
    end
)
HandWaveButtonGridFrame.tradeButton:SetScript(
    "OnDragStop",
    function()
        HandWaveButtonGridFrame.tradeButton:GetParent():StopMovingOrSizing()
    end
)
HandWaveButtonGridFrame.tradeButton:SetScript(
    "OnEnter",
    function()
        HandWaveButtonGridFrame.tradeButton:SetAlpha(1)
    end
)
HandWaveButtonGridFrame.tradeButton:SetScript(
    "OnLeave",
    function()
        HandWaveButtonGridFrame.tradeButton:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
    end
)

HandWaveButtonGridFrame.lfgButton =
    CreateFrame("Button", "HandWaveButtonGridFrametradeLFGButtons2", HandWaveButtonGridFrame)
HandWaveButtonGridFrame.lfgButton:SetPoint("TOP", HandWaveButtonGridFrametradeLFGButtons, "BOTTOM")
HandWaveButtonGridFrame.lfgButton:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
HandWaveButtonGridFrame.lfgButton:SetNormalTexture(ImageList.lfgChatButton)
HandWaveButtonGridFrame.lfgButton:SetHighlightTexture(ImageList.lfgChatButtonH, "BLEND")
HandWaveButtonGridFrame.lfgButton:RegisterForDrag("MiddleButton")
HandWaveButtonGridFrame.lfgButton:RegisterForClicks("RightButtonUp", "LeftButtonUp")
HandWaveButtonGridFrame.lfgButton:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            if GetChannelName(4) == 4 then -- check if lfg chat is available in this zone
                SPCTRUNLFGCHANNELCHATFUNCTION()
            else
                printErrorMessages("errorLFGChatNotAvailable")
            end
        end
    end
)
HandWaveButtonGridFrame.lfgButton:SetScript(
    "OnDragStart",
    function()
        HandWaveButtonGridFrame.lfgButton:GetParent():StartMoving()
    end
)
HandWaveButtonGridFrame.lfgButton:SetScript(
    "OnDragStop",
    function()
        HandWaveButtonGridFrame.lfgButton:GetParent():StopMovingOrSizing()
    end
)
HandWaveButtonGridFrame.lfgButton:SetScript(
    "OnEnter",
    function()
        HandWaveButtonGridFrame.lfgButton:SetAlpha(1)
    end
)
HandWaveButtonGridFrame.lfgButton:SetScript(
    "OnLeave",
    function()
        HandWaveButtonGridFrame.lfgButton:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
    end
)

HandWaveButtonGridFrame.sayButton =
    CreateFrame("Button", "HandWaveButtonGridFramesayYellButtons", HandWaveButtonGridFrame)
HandWaveButtonGridFrame.sayButton:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
HandWaveButtonGridFrame.sayButton:SetNormalTexture(ImageList.sayChatButton)
HandWaveButtonGridFrame.sayButton:SetHighlightTexture(ImageList.sayChatButtonH, "BLEND")
HandWaveButtonGridFrame.sayButton:RegisterForDrag("MiddleButton")
HandWaveButtonGridFrame.sayButton:RegisterForClicks("RightButtonUp", "LeftButtonUp")
HandWaveButtonGridFrame.sayButton:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            SPCTRUNSAYCHANNELCHATFUNCTION()
        end
    end
)
HandWaveButtonGridFrame.sayButton:SetScript(
    "OnDragStart",
    function()
        HandWaveButtonGridFrame.sayButton:GetParent():StartMoving()
    end
)
HandWaveButtonGridFrame.sayButton:SetScript(
    "OnDragStop",
    function()
        HandWaveButtonGridFrame.sayButton:GetParent():StopMovingOrSizing()
    end
)
HandWaveButtonGridFrame.sayButton:SetScript(
    "OnEnter",
    function()
        HandWaveButtonGridFrame.sayButton:SetAlpha(1)
    end
)
HandWaveButtonGridFrame.sayButton:SetScript(
    "OnLeave",
    function()
        HandWaveButtonGridFrame.sayButton:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
    end
)

HandWaveButtonGridFrame.yellButton =
    CreateFrame("Button", "HandWaveButtonGridFramesayYellButtons2", HandWaveButtonGridFrame)
HandWaveButtonGridFrame.yellButton:SetPoint("TOP", HandWaveButtonGridFramesayYellButtons, "BOTTOM")
HandWaveButtonGridFrame.yellButton:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
HandWaveButtonGridFrame.yellButton:SetNormalTexture(ImageList.yellChatButton)
HandWaveButtonGridFrame.yellButton:SetHighlightTexture(ImageList.yellChatButtonH, "BLEND")
HandWaveButtonGridFrame.yellButton:RegisterForDrag("MiddleButton")
HandWaveButtonGridFrame.yellButton:RegisterForClicks("RightButtonUp", "LeftButtonUp")
HandWaveButtonGridFrame.yellButton:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            SPCTRUNYELLCHANNELCHATFUNCTION()
        end
    end
)
HandWaveButtonGridFrame.yellButton:SetScript(
    "OnDragStart",
    function()
        HandWaveButtonGridFrame.yellButton:GetParent():StartMoving()
    end
)
HandWaveButtonGridFrame.yellButton:SetScript(
    "OnDragStop",
    function()
        HandWaveButtonGridFrame.yellButton:GetParent():StopMovingOrSizing()
    end
)
HandWaveButtonGridFrame.yellButton:SetScript(
    "OnEnter",
    function()
        HandWaveButtonGridFrame.yellButton:SetAlpha(1)
    end
)
HandWaveButtonGridFrame.yellButton:SetScript(
    "OnLeave",
    function()
        HandWaveButtonGridFrame.yellButton:SetAlpha(SpellChatOptionsList.buttonBoxOpacity)
    end
)

-- ===================================================================================================
-- ===================================================================================================
-- ===========================         spellchat magic button          ===========================
-- ===================================================================================================
-- ===================================================================================================

local spellChatMagicButton = CreateFrame("Button", "spellChatMagicButton", UIParent)
spellChatMagicButton:SetSize(NumberList.navButtonSize, NumberList.navButtonSize)
spellChatMagicButton:SetScale(1)
spellChatMagicButton:SetAlpha(1)
spellChatMagicButton:ClearAllPoints()
spellChatMagicButton:SetPoint("BOTTOMRIGHT", SpellChatInterfaceFrame, "TOPRIGHT")
spellChatMagicButton:SetNormalTexture(ImageList.spellChatMagicButton)
spellChatMagicButton:SetHighlightTexture(ImageList.spellChatMagicButtonH, "BLEND")
spellChatMagicButton:SetClampedToScreen(true)
spellChatMagicButton:SetMovable(true)
spellChatMagicButton:RegisterForDrag("MiddleButton")
spellChatMagicButton:SetScript("OnDragStart", spellChatMagicButton.StartMoving)
spellChatMagicButton:SetScript("OnDragStop", spellChatMagicButton.StopMovingOrSizing)
spellChatMagicButton:RegisterForClicks("RightButtonUp", "LeftButtonUp")
spellChatMagicButton:SetScript(
    "OnClick",
    function(self, button)
        if button == "RightButton" then
            SPCTTOGGLESPELLCHATINTERFACEFRAME()
        elseif button == "LeftButton" then
            if SpellChatOptionsList.buttonBoxEnabled then
                if HandWaveButtonGridFrame:IsShown() then
                    SpellChatOptionsList.buttonBoxIsHidden = true
                    HandWaveButtonGridFrame:Hide()
                else
                    SpellChatOptionsList.buttonBoxIsHidden = false
                    HandWaveButtonGridFrame:Show()
                end
            end
        end
    end
)
spellChatMagicButton:SetScript(
    "OnEnter",
    function(self, button)
        spellChatMagicButton:SetAlpha(1)
    end
)
spellChatMagicButton:SetScript(
    "OnLeave",
    function(self, button)
        spellChatMagicButton:SetAlpha(SpellChatOptionsList.magicButtonOpacity)
    end
)
